/*
$Header: /export/CVS/UMT/include/umtAddrBook.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtAddrBook.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:44:31  sebast
# Revision 2.0
#
# Revision 1.16  1996/02/15  14:41:53  sebast
# GetInternetAddr(); added
#
# Revision 1.15  1995/10/28  13:25:58  vlad
# Some stuff redone.
#
# Revision 1.14  1995/10/28  12:36:50  vlad
# using umtLock implemented.
#
# Revision 1.13  1995/07/31  18:01:21  lord
# umt coding rules
#
# Revision 1.12  1995/07/31  17:43:33  lord
# umt naming convention
#
# Revision 1.11  1995/07/04  15:27:54  sebast
# #define ADDR_BOOK_LOCK_EXTENTION ".LOCK" removed. Do use LOCK_EXTENTION from umt_const
#
# Revision 1.10  1995/06/24  12:37:04  lord
# AddrBookEntry::operator = added
#
# Revision 1.9  1995/06/22  12:39:35  sebast
# classname() removed
#
# Revision 1.8  1995/06/22  10:55:57  sebast
# classname() removed
#
# Revision 1.7  1995/06/12  15:30:10  lord
# locked,lock_filename
#
# Revision 1.6  1995/06/12  15:20:40  lord
# ADDR_BOOK_LOCK_EXTENTION
#
# Revision 1.5  1995/05/20  16:18:04  lord
# msg.h->msg.h++
#
# Revision 1.4  1995/05/20  16:05:14  lord
# AddrBookEntry(msg *);
#
# Revision 1.3  1995/05/17  13:48:40  lord
# Unknown network type added
#
# Revision 1.2  1995/05/14  14:22:29  lord
# classname() functions added
#
# Revision 1.1  1995/05/09  14:00:35  lord
# Initial revision
#
*/

#ifndef ADDR_BOOK_H_FLAG
#define ADDR_BOOK_H_FLAG

#include "umtMember.h++"
#include "umtSlist.h++"
#include "umt_error.h++"
#include "umtString.h++"
#include "umtMsg.h++"
#include "umtLock.h++"
#include <sys/time.h>

class umtAddrBook;

class umtAddrBookEntry: public umtMember
{
    friend class umtAddrBook;
    
public: 
    umtAddrBookEntry(umtMsg *);
    umtAddrBookEntry();
    umtAddrBookEntry(umtAddrBookEntry *);
    ~umtAddrBookEntry();
    
    umtString Alias;
    umtString RealName;
    umtString Company;
    umtString Addr;

    umtInternetAddr GetInternetAddr();
    
    enum { Internet, Compuserve, Fidonet, Unknown } NetworkType;
    unsigned int Flags;

    time_t LastMessageReceivedAt;
    time_t LastMessageSentAt    ;
    
    virtual umtAddrBookEntry& operator =(const umtAddrBookEntry &);
    
protected: 
    
    status Load(FILE *);
    status Save(FILE *);
    
private:
};

class umtAddrBook: public umtSlist
{
public: 
    umtAddrBook(umtString);
    ~umtAddrBook();
    
    status Load();
    status Save();
    
    umtAddrBookEntry *GetByAlias(umtString);

protected: 
    
    umtString name;
    umtLock  *lock;
    
private: 
};

#endif


