/*************************************************************
 *      Configuration header file.                           *
 *                                  (c) Voloh S.             *
 *************************************************************/

/*
  $Header: /export/CVS/UMT/include/umtConfiguration.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

  $Log: umtConfiguration.h++,v $
  Revision 1.1.1.1  1996/10/21 20:46:45  vlad
  Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:44:34  sebast
# Revision 2.0
#
# Revision 1.8  1996/02/29  18:50:27  voloh
# getNewWord::Close() added.
#
# Revision 1.7  1995/09/12  15:50:26  sebast
# clineList::clineList(umtString*) commented
#
# Revision 1.6  1995/08/16  18:33:45  voloh
# Corrections on Cfg::Append() & Cfg::ReadConfiguration().
#
# Revision 1.5  1995/07/31  17:21:02  sebast
#     umtConfiguration *GetLast()            ;
#     umtConfiguration *GetFirst()           ;
#     umtConfiguration *GetNext(umtMember *a);
#     umtConfiguration *GetPrev(umtMember *a);
# 	added
#
# Revision 1.4  1995/07/31  16:33:49  lord
# umt coding rules
#
# Revision 1.3  1995/06/22  12:41:28  sebast
# classname() removed
#
# Revision 1.2  1995/05/10  17:56:23  sebast
# virtual int classname() added
#
# Revision 1.1  1995/04/26  11:57:27  sebast
# Initial revision
#
*/

#ifndef CONFIGURATION_H_FLAG
#define CONFIGURATION_H_FLAG

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "umtSlist.h++"
#include "umtString.h++"
#include "umt_error.h++"

class umtConfiguration;

class getNewWord
{
    friend    umtConfiguration;
    FILE      *mfile;
    char      Buffer[2000];
    char      *BCurs;
    int       buffer_free;

public: 
    getNewWord();
    ~getNewWord();

protected: 
    status InitObj(umtString);
    status InitObj(FILE*);
    void   Close();
    int getNewExp(char*);
};

class clineList : public umtSlist
{
    friend umtConfiguration;

public: 
    clineList();
//    clineList(umtString*);
    ~clineList();

    umtString GetStrByNumber(int);

protected: 
    status append(umtString,int);
};

/* **************** CONFIGURATION ****************** */

class umtConfiguration : public umtSlist
{

    umtString Name;
    clineList *Parameters;
    int ConfigurationIsReadOnly;

public: 
    umtConfiguration ();
    umtConfiguration (umtConfiguration *);
    umtConfiguration (umtString);
    ~umtConfiguration();
    
    umtConfiguration *GetLast()            ;
    umtConfiguration *GetFirst()           ;
    umtConfiguration *GetNext(umtMember *a);
    umtConfiguration *GetPrev(umtMember *a);

    umtString     GetStrField       (umtString,          int=0);
    status        GetIntField       (umtString,int*,     int=0);
    status        GetDoubleField    (umtString,double*,  int=0);
    status        GetLongField      (umtString,long*,    int=0);

    status        Set               (umtString,umtString,int=0);
    status        Set               (umtString,int,      int=0);
    status        Set               (umtString,double,   int=0);
    status        Set               (umtString,long,     int=0);

    status        Read              (umtString);
    status        Read              (umtString,int);
    status        Read              (FILE*,int=0);
    status        Write             (umtString);
    status        Write             (FILE*);
    status        Append2File       (umtString);
  
    int           ConfigurationReadOnly() {return ConfigurationIsReadOnly;}

    clineList*    GetParList        ();
    clineList*    GetParsByName     (umtString);
    umtString     GetName           ();
    umtString     GetParByNumber    (int);

    umtConfiguration* GetConfiguration (umtString);

protected: 
    status        mySet(umtString,umtString,int,int=0);
    status        ReadConfiguration(int);
    status        WriteConfiguration(FILE*,int,int);
    status        AddArr(umtConfiguration*);
    char*         StrOut(umtString,char*);
};

/* ************************************************* */

#endif /* CONFIGURATION_H_FLAG */











