/*
  $Header: /export/CVS/UMT/include/umtError.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $
  
  $Log: umtError.h++,v $
  Revision 1.1.1.1  1996/10/21 20:46:45  vlad
  Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:44:39  sebast
# Revision 2.0
#
# Revision 1.5  1996/03/07  15:12:59  vlad
# Enother constructor added.
#
  Revision 1.4  1996/03/03 16:56:02  vlad
  logfile_name added

# Revision 1.3  1995/11/17  13:00:01  vlad
# void Msg( enum Priority pr, const char *format, ... ) added.
#
# Revision 1.2  1995/09/28  11:13:53  lord
# Check for nil in DEBUGM
#
# Revision 1.1  1995/09/28  11:06:13  lord
# Initial revision
#
  */

#ifndef UMT_ERROR_CLASS_H_FLAG
#define UMT_ERROR_CLASS_H_FLAG

#include "umtPath.h++"

#define DEBUGM(str) {if(UMTError)UMTError->Msg(str,__FILE__,__LINE__);}

class umtError:public umtMember
{
public:
    
    umtError();
    umtError( umtError* );
    virtual ~umtError();

    enum Priority
    {
	Critical   = 0,
	Error      = 1,
	Warning    = 2,
	Statistics = 3,
	Info       = 4,
	Debug      = 5
    };
    
    virtual status Open     (umtPath,enum Priority, int lim = -1 );
    virtual status Close    ();
    virtual int    IsOpened ();

    void ChangeLevel(enum Priority);
    
    virtual void Msg(enum Priority,umtString);
    virtual void Msg(enum Priority,const char *format, ... );
    virtual void Msg(umtString,char *filename,int line); //For debugging only. Use DEBUGM
    
protected:
    int     count;
    FILE   *logfile;
    enum    Priority level;
    int     limit;
    umtPath logfile_name;
private:
    
};

extern umtError *UMTError;

#endif



