/*  $Header: /export/CVS/UMT/include/umtFolder.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

    $Log: umtFolder.h++,v $
    Revision 1.1.1.1  1996/10/21 20:46:45  vlad
    Puting to CVS. Version 1.00B3

 * Revision 2.0  1996/03/18  16:44:42  sebast
 * Revision 2.0
 *
 * Revision 1.39  1996/02/20  17:21:56  vlad
 * History new work scheme realised.
 *
 * Revision 1.38  1995/10/12  14:15:13  sebast
 * default value for ImportUnixFolder changed
 *
 * Revision 1.37  1995/10/09  11:44:30  sebast
 * lots functions made virtual
 *
 * Revision 1.36  1995/10/07  18:09:30  sebast
 * ImportUnixFolder() changed
 *
 * Revision 1.35  1995/10/07  16:17:01  lord
 * ImportMsg() => AddMsg()
 *
 * Revision 1.34  1995/10/05  16:16:45  sebast
 * ExportMsg() => ImportMsg();
 *
 * Revision 1.33  1995/10/04  18:49:08  sebast
 * constructors changed; some functions added/changed
 *
 * Revision 1.32  1995/09/29  13:45:27  sebast
 *     umtString GetNewMsgName(); added
 *
 * Revision 1.31  1995/09/27  17:08:24  lord
 * CountMessages added
 *
 * Revision 1.30  1995/09/27  12:48:13  lord
 * UnLoad added
 *
 * Revision 1.29  1995/09/26  19:05:03  lord
 * Lot of changes
 *
 * Revision 1.28  1995/09/26  13:51:55  lord
 * Dock added
 *
 * Revision 1.27  1995/09/25  14:04:04  sebast
 * ThePath => umtDir *ThePath
 *
 * Revision 1.26  1995/09/25  13:07:57  lord
 * Some new members
 *
 * Revision 1.25  1995/08/31  17:47:26  lord
 * Name added
 *
 * Revision 1.24  1995/08/24  16:38:17  lord
 * create_msg -> CreateMsg
 *
 * Revision 1.23  1995/08/01  15:20:24  sebast
 * umtCodingRules
 *
 * Revision 1.22  1995/07/10  13:56:32  lord
 * in Load and Save defenition variable named
 *
 * Revision 1.21  1995/07/10  13:49:00  lord
 * Remove second Load fucntion.
 * Make parametr defaults to nil.
 *
 * Revision 1.20  1995/06/22  12:44:53  sebast
 * classname() removed
 *
 * Revision 1.19  1995/06/05  16:51:49  lord
 * Syntax err fixed
 *
 * Revision 1.18  1995/06/05  15:37:06  lord
 * POPHistory *hist=nil and  int leave_mail_on_server=0 args to ImportPOPFolder
 *

 * Revision 1.17  1995/06/01  17:32:16  sebast
 * thePath now public
 *
 * Revision 1.16  1995/05/31  17:40:36  lord
 *   int is_incoming(); -> /dev/null
 *
 * Revision 1.15  1995/05/31  17:33:59  lord
 * is_incoming
 *
 * Revision 1.14  1995/05/31  15:35:42  lord
 * ImportPOPFolder
 *
 * Revision 1.13  1995/05/10  17:55:15  sebast
 * virtual int classname() added
 *
 * Revision 1.12  1995/05/05  15:49:16  sebast
 * ReSort(),Move(),Flush() written and tested
 *
 * Revision 1.11  1995/04/26  11:35:07  sebast
 * uses *.h++ instead *.h
 *
 * Revision 1.10  1995/04/26  08:43:07  lord
 * create_msg(umtString *) added
 *
 * Revision 1.9  1995/04/25  11:27:20  sebast
 * status Flush() added
 *
 * Revision 1.8  1995/04/03  15:08:23  sebast
 * some cosmetic
 *
 * Revision 1.7  95/03/17  19:59:43  19:59:43  sebast (Sebastian Kamyshenko)
 * changed to use umtString
 * 
 * Revision 1.6  1995/03/11  12:25:27  sebast
 * *** empty log message ***
 *
 * Revision 1.5  1995/02/19  21:50:34  sebast
 * save/load added
 *
 * Revision 1.4  95/02/13  20:49:49  20:49:49  lord (Vadim Zaliva)
 * Inherit it from slist<msg>
 * 
 * Revision 1.3  95/02/13  15:07:10  15:07:10  sebast (Sebastian Kamyshenko)
 * DeleteMsg( int number ) added
 * 
 * Revision 1.2  95/02/11  15:31:24  15:31:24  sebast (Sebastian Kamyshenko)
 * Yet another initial revision
 * 
 * Revision 1.1  95/02/11  15:30:21  15:30:21  sebast (Sebastian Kamyshenko)
 * Initial revision
 * 

*/

#ifndef FOLDER_H_FLAG
#define FOLDER_H_FLAG


#include "umtDir.h++"
#include "umtSlist.h++"
#include "umtDock.h++"
#include "umtMsg.h++"
#include "umtHistory.h++"

class umtFolder : public umtSlist
{ 
public:  
  
//    umtFolder();
    umtFolder(umtDir *aPath);
    virtual ~umtFolder();

    virtual umtMsg *GetFirst();
    virtual umtMsg *GetLast();
    virtual umtMsg *GetNext(umtMsg *);
    virtual umtMsg *GetPrev(umtMsg *);
    
    virtual status Save(umtDir *aPath = nil);
    virtual status Load(umtDir *aPath = nil);
    virtual status UnLoad();
    virtual status Remove();

    virtual status AddMsg(umtMsg *);
    
    virtual status Flush(); // removes all messages marked as removed

    // not implemented yet!
    status  ImportUnixFolder (umtPath *file,
			      umtHistory *hist=NULL,
			      int leave_mail_on_server=1
    );
    
    status  ImportMmdfFolder (umtPath *file);
    status  ImportEmacsFolder(umtPath *file);

    status  ImportPopFolder  (
	umtString server, 
	umtString service,
	umtString user, 
	umtString passwd,
	umtHistory *hist=NULL,       // No history
	int leave_mail_on_server=0 // Delete received msgs
    );
  
    virtual status  Move(char *target);

    umtDir  GetNewMsgName();
    
    umtDir    *ThePath;
    umtString Name;
    umtPath   Icon;
 
    int  Total;
    int  IsIncoming;
    int  IsOutgoing;

protected: 
  
    virtual umtMsg* CreateMsg(umtDir *); 
    int     CountMessages(); // updates Total
    int     IsLoaded;
  
private:  

    status      resort();
  
};


#endif


