/*
 * $Header: /export/CVS/UMT/include/umtLanguage.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $
 
 * $Log: umtLanguage.h++,v $
 * Revision 1.1.1.1  1996/10/21 20:46:45  vlad
 * Puting to CVS. Version 1.00B3
 *
# Revision 2.0  1996/03/18  16:44:57  sebast
# Revision 2.0
#
# Revision 1.16  1995/10/11  16:09:34  sebast
# some UMT_CONFIG constants changed
#
# Revision 1.15  1995/08/24  15:20:08  lord
# make read take const
#
# Revision 1.14  1995/08/24  14:34:29  lord
# Some defines changed
#
# Revision 1.13  1995/08/22  12:40:45  lord
# ChangeumtLanguage-> ChangeLanguage
#
# Revision 1.12  1995/07/31  16:27:22  lord
# RCS header fixed
#
 
# Revision 1.11  1995/07/31  16:02:20  lord
# umt coding rules
#
# Revision 1.10  1995/07/27  16:33:35  lord
# Remove default args in constructor and Change umtLanguage
#
# Revision 1.9  1995/06/22  12:20:08  sebast
# call of member() changed
#
# Revision 1.8  1995/06/22  12:18:19  sebast
# classname() removed
#
# Revision 1.7  1995/06/22  11:10:56  sebast
# classname() removed
#
# Revision 1.6  1995/06/12  15:55:14  vlad
# Declaration:
#          'parse_string( FILE* f, char *buff, int len );' added
#
# Revision 1.5  1995/06/11  08:03:08  vlad
# Default value in function ChangeumtLanguage( umtString n = "" ).
#
# Revision 1.4  1995/06/11  07:55:28  vlad
# Changed return value of operator [] ( umtString --> const char* )
# Added   method  umtString GetName() -- return name of currient umtLanguage.
#
# Revision 1.3  1995/06/10  15:40:33  vlad
# replaced UNEXISTING_STRING
#
# Revision 1.2  1995/06/10  14:38:56  lord
# brush-up
#
# Revision 1.1  1995/06/10  14:06:35  vlad
# Initial revision
#
 */

#ifndef umtLanguage_H_FLAG
#define umtLanguage_H_FLAG


#include "umtSlist.h++"
#include "umtString.h++"
#include "umt_error.h++"
#include "classnames.h++"
#include <stdio.h>

#define UNEXISTING_STRING              "-????-" 
#define UMT_CONFIG_umtLanguage_FIELD   "LanguageGroup.Languages"
#define UMT_CONFIG_DEFAULT_umtLanguage "LanguageGroup.DefaultLanguage"
//#define UMT_CONFIG_umtLanguage_PATH    "LanguageGroup.LanguagesPath" 
#define LANG_BUFF_SIZE                 2024
    
class umtLangMessage : public umtMember
{
public:
    umtLangMessage( int n, umtString s):umtMember(CLASS_LANG_MESSAGE)
    {
	number = n;
	message = s;
    }
    
    umtLangMessage       ( umtLangMessage *mess );
    virtual              ~umtLangMessage();
    
    int        Read    ( FILE *f, char *buff, int len );
    int        GetNum () { return number; }
    char*      GetStr () { return ( char *)message; }
    
protected:
    umtString  parse_string( FILE* f, char *buff, int len );

private:	
    int                  number;
    umtString            message;
};


class umtLanguage : public umtMember
{
    
public:
    umtLanguage                 ();
    virtual                     ~umtLanguage();
    
    const char* operator []   ( int num );
    status      ChangeLanguage( umtString n);
    // if ( n == "" ) Default umtLanguage will be load.
    void        Free          ();
    umtString   GetName       () { return name; }

protected:         
    status      read          ( const char *filename );
    static  int compar        ( const void *a, const void *b );
    
    umtString                 name; 
    umtLangMessage            **List;
    int                       number;
};

#endif












