/*
  $Header: /export/CVS/UMT/include/umtLock.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

  $Log: umtLock.h++,v $
  Revision 1.1.1.1  1996/10/21 20:46:45  vlad
  Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:00  sebast
# Revision 2.0
#
# Revision 1.10  1995/11/04  08:39:34  lord
# sys_satar -> sys_start
#
# Revision 1.9  1995/10/28  12:39:27  vlad
# Nothing.
#
# Revision 1.8  1995/10/25  18:58:14  vlad
# Process and system ID added.
#
# Revision 1.7  1995/08/22  13:09:28  lord
# LockMask->UMTLockMask
#
# Revision 1.6  1995/07/31  16:48:54  lord
# umt_path -> umtPath
#
# Revision 1.5  1995/07/31  16:45:51  lord
# umt coding rules
#
# Revision 1.4  1995/07/27  17:25:11  lord
# lock_mask now static
#
# Revision 1.3  1995/07/16  12:37:32  lord
# include sys/stat.h for Linux
#
# Revision 1.2  1995/07/15  13:43:39  lord
# ifdef
#
# Revision 1.1  1995/07/15  12:19:51  lord
# Initial revision
#
  */

#ifndef UMT_LOCK_FLAG
#define UMT_LOCK_FLAG

#include "umtPath.h++"
#include <fcntl.h>
#ifdef LINUX
# include <sys/stat.h> // S_IRUSR ...
#endif 
// -------------------------- class: umt_lock  --------------------
// Created by lord@topaz.kiev.ua at Sat Jul 15 14:52:01 1995
// ----------------------------------------------------------------
class umtLock:public umtMember
{
public:
    umtLock(umtPath);
    virtual ~umtLock();

    umtPath GetPath();

    status   Lock     ();
    status   UnLock   ();
    int      IsLocked ();

    static   const mode_t UMTLockMask;
    
private: 
    void fill_sys_start( void );
    
    umtPath       path;
    int           locked;
    static time_t sys_start;
    
};

#endif



