/* 
$Header: /export/CVS/UMT/include/umtMd5.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtMd5.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

 * Revision 2.0  1996/03/18  16:45:02  sebast
 * Revision 2.0
 *
 * Revision 1.4  1995/08/02  11:26:57  sebast
 * umtCodingRules
 *
 * Revision 1.3  1995/07/28  15:15:56  sebast
 * a lot of members made static
 *
 * Revision 1.2  1995/04/26  11:38:07  sebast
 * uses *.h++ instead *.h
 *
 * Revision 1.1  1995/02/24  18:28:59  lord
 * Initial revision
 *
*/

#ifndef MD5_H_FLAG
#define MD5_H_FLAG

#include <stdio.h>

#include "umtMember.h++"

class umtMDigest: public umtMember
{
public: 
  
    umtMDigest(char *string);
    umtMDigest(FILE *,long len=-1);      // file must be opened in "rb" mode
    umtMDigest(void);
  
    int ReadFile(FILE *,long len=-1); // 0-OK
    int ReadString(char *);           // 0-OK
  
    virtual ~umtMDigest(void);
    unsigned char *GetDigest();
  
protected:  
  
private: 
    // MD5 context.
    typedef struct {
	unsigned  long state[4];           /* state (ABCD) */
	unsigned  long count[2];           /* number of bits */
	unsigned  char buffer[64]; /* input buffer */
    } md5_ctx;
  
    unsigned  char digest[16];
    unsigned  char *padding;
    md5_ctx *context;
    void md5_init  (void);
    void md5_update ( unsigned  char *, unsigned  int );
    void md5_final (void);
    void md5_transform ( unsigned  long [4], unsigned  char [64]);
    void encode ( unsigned  char *, unsigned  long  *, unsigned  int );
    void decode ( unsigned  long *, unsigned  char *,  unsigned  int );

    unsigned  long md5_f( unsigned  long , unsigned  long , unsigned  long );
    unsigned  long md5_h( unsigned  long , unsigned  long , unsigned  long );
    unsigned  long md5_g( unsigned  long , unsigned  long , unsigned  long );
    unsigned  long md5_i( unsigned  long , unsigned  long , unsigned  long );
    unsigned  long rotate_left( unsigned  long , int );  
    void           md5_ff( unsigned  long &, unsigned  long , unsigned  long ,
			   unsigned  long ,
			   unsigned  long , int , unsigned  long ); 
    void           md5_gg( unsigned  long &, unsigned  long , unsigned  long ,
			   unsigned  long ,
			   unsigned  long , int , unsigned  long ); 
    void           md5_hh( unsigned  long &, unsigned  long , unsigned  long ,
			   unsigned  long ,
			   unsigned  long , int , unsigned  long ); 
    void           md5_ii( unsigned  long &, unsigned  long , unsigned  long ,
			   unsigned  long ,
			   unsigned  long , int , unsigned  long ); 
    static const int S11,S12,S13,S14,S21,S22,S23,S24,
	S31,S32,S33,S34,S41,S42,S43,S44;
  
};



#endif
