/*
 * $Header: /export/CVS/UMT/include/umtParseHeader.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $
 * $Log: umtParseHeader.h++,v $
 * Revision 1.1.1.1  1996/10/21 20:46:45  vlad
 * Puting to CVS. Version 1.00B3
 *
 * Revision 2.1  1996/04/12 14:33:48  vlad
 * Content-Disposition header filed processing staff added.
 *
 * Revision 2.0  1996/03/18 16:45:09  sebast
 * Revision 2.0
 *
 * Revision 1.16  1996/02/19  16:47:30  vlad
 * Fatal bug in parsing mailbox1 'aaa@bbb.ccc.dd( Real (name))' is fixed
 *
 * Revision 1.15  1995/08/01  10:56:21  lord
 * include parsing.h++ into class
 *
 * Revision 1.14  1995/08/01  07:57:52  lord
 * *** empty log message ***
 *
 * Revision 1.13  1995/07/31  18:11:06  sebast
 * some changed for UMT coding rules
 *
 * Revision 1.12  1995/07/31  15:42:38  sebast
 * names of headers changed
 *
 * Revision 1.11  1995/07/05  13:47:25  vlad
 * functions prototypes  pars_content_type( char *str ),
 * 		      pars_content_subtype( char *str )
 * removed.
 *
 * Revision 1.10  1995/06/11  15:09:07  vlad
 * Some sintax errors corrected.
 *
 * Revision 1.9  1995/06/11  14:25:17  vlad
 * prototype extern  char*  post_parsig_string( char *str ); added
 *
 * Revision 1.8  1995/06/11  13:30:07  vlad
 * 'TimeZome' stuff changed
 *
 * Revision 1.7  1995/05/27  12:37:34  vlad
 * Moved 'timezone.cfg' from UMT/lib to UMT/etc
 *
 * Revision 1.6  1995/05/26  15:13:06  vlad
 * Changed 'timezone.cfg' file situation.
 *
 * Revision 1.5  1995/04/26  11:35:49  sebast
 * uses *.h++ instead *.h
 *
 * Revision 1.4  1995/04/04  11:11:16  vlad
 * Declaration of finction
 * status  parse_field_content_type( char *str, ContentStruct *put_here );
 * done.
 *
 * Revision 1.3  1995/04/03  12:28:50  vlad
 * Decloration
 *   extern  content_transfer_encoding pars_content_encoding( char *str );
 * added;
 *
 * Revision 1.2  1995/04/02  16:40:47  vlad
 * Not first revision
 *
 *
 */

#ifndef PARSE_HEADER_H_FLAG
#define PARSE_HEADER_H_FLAG

#include <time.h>
#include "umtConfiguration.h++"
#include "umtMsg.h++"

class umtParseHeader:public umtMember
{
public: 
    virtual ~umtParseHeader();
    
    static const int   PARS_STRING_INC;
    static const int   TZ_MAX_LEN;
    static const char  *TZ_GROUP;

    enum  States
    {
	BEGIN_HEADER/*0*/, FIELD/*1*/, END_HEADER/*2*/, RETURN_PATH/*3*/,
	RECEIVED/*4*/, REPLY_TO/*5*/, FROM/*6*/, SENDER/*7*/,
	DATE/*8*/, RESENT_DATE/*9*/, TO/*10*/, CC/*11 */, BCC/*12*/, MESSAGE_ID/*13*/,
	IN_REPLY_TO/*14*/, REFERENCES/*15*/, KEYWORDS/*16*/,
	SUBJECT/*17*/, COMMENTS/*18*/, ENCRYPTED/*19*/, MIME_VERSION/*20*/,
	CONTENT_TYPE/*21*/, X_FACE/*22*/, ROUTE_ADDR/*23*/,
	MAILBOX1/*24*/, MAILBOX2/*25*/, COMMA/*26*/, DATE_TIME/*27*/, TEXT/*28*/,
	MSG_ID/*29*/, ADDRESS/*30*/, PHRASE/*31*/, WORD/*32*/,
	OTHERFIELD/*33*/, GROUP/*34*/, END_MAILBOX3/*35*/, ROUTE/*36*/,
	MAILBOX3/*37*/,
	PARS_ERROR/*38*/, PARS_EOF/*39*/, COMMENT/*40*/, PARAMETER/*41*/,
	SEMICOLON/*42*/,
	TYPE_SUBTYPE/*43*/, LWS/*44*/, ONE/*45*/,
	ADDR_SPEC/*46*/, COLON/*47*/, MAILBOX/*48*/, TYPE/*49*/,SUBTYPE/*50*/,
	SLASH/*51*/, ATTRIBUTE/*52*/,VALUE/*53*/,CONTENT_TRANSFER_ENCODING/*54*/,
	ATOM/*55*/,TOKEN/*56*/,CONTENT_DISPOSITION/*57*/
    };
    
    static char *ParsStrcat( char **a, const char *b ); /*Dynamic adding string b to *a ) */
    static char *ParsAddchar( char **a, int c );       /* Dynamic adding char   c to *a ) */
    
    static char    *GetText             (void );
    static status  GetAddresses         (umtSlist *put_here,States terminator);
    static States  GetAddress           (umtSlist  *put_here );
    static status  GetMailboxes         (umtSlist *put_here, States terminator );
    static status  GetMailbox           (umtSlist *put_here );
    static status  GetContentType       (umtContentStruct *put_here );
    static status  GetContentDisposition(umtContentStruct *put_here );
    static time_t  GetDate              (char *date_time );
    static long    GetDiffByZone        (char *t_zone );
    static long    GetTimezone          (char * t_zone );
    static void    StrUnfolding         (char *str );
    static void    ParseContentAttribute( umtContentStruct *put_here,
					  char *attrib,
					  const char *value );
    static void    ParseDispositionAttribute( umtContentStruct *put_here,
					      char *attrib,
					      const char *value );

    static void    ToUppercase          (char *str );
    static int     GetTZDifference      (umtString tz );

    static status  GetContentTransferEncoding (umtContentStruct *put_here);
//     static status  ParseFieldContentType      (char *str,
// 					       umtContentStruct *put_here );
    static char   *PostParsingString          (char *str );

    static         ContentTransferEncoding ParseContentEncoding( char *str );
};

// Flex stuff

umtParseHeader::States yylex( void );

extern  char *pars_string;
extern  FILE *yyin, *yyout;
extern  char  *yytext;
extern  int   yyleng;
extern  char  *pars_comment;

#endif





