/*
$Header: /export/CVS/UMT/include/umtPop3.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtPop3.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

 * Revision 2.0  1996/03/18  16:45:12  sebast
 * Revision 2.0
 *
 * Revision 1.17  1995/08/25  08:20:35  lord
 * add const to parameters
 *
 * Revision 1.16  1995/08/23  16:54:27  lord
 * umtSlist make ixplixtly private
 *
 * Revision 1.15  1995/08/01  14:29:48  sebast
 * UMT coding rules
 *
 * Revision 1.14  1995/06/22  12:47:09  sebast
 * classname() removed
 *
 * Revision 1.13  1995/06/22  12:26:05  sebast
 * classname() removed
 *
 * Revision 1.12  1995/06/05  16:40:06  lord
 * make find_message public
 *
 * Revision 1.11  1995/06/04  14:49:11  lord
 * class names defined
 *
 * Revision 1.10  1995/06/04  14:40:01  lord
 * UIDL managment done.
 *
 * Revision 1.9  1995/06/03  15:08:54  lord
 * +16 in buffers size - to be safe
 *
 * Revision 1.8  1995/04/26  11:35:38  sebast
 * uses *.h++ instead *.h
 *
 * Revision 1.7  1995/03/11  14:53:00  sebast
 * pop3_msg_info::pop3_msg_info(pop3_msg_info *p) added
 *
 * Revision 1.6  1995/02/17  21:43:27  lord
 * MSG_BUF_INCREMENT added
 *
 * Revision 1.5  95/02/17  21:10:51  21:10:51  lord (Vadim Zaliva)
 * isMessageDeleted added
 * 
 * Revision 1.4  95/02/17  20:54:42  20:54:42  lord (Vadim Zaliva)
 * find_message added
 * 
 * Revision 1.3  95/02/17  20:30:21  20:30:21  lord (Vadim Zaliva)
 * change size of RSPBUF
 * 
 * Revision 1.2  95/02/16  19:33:23  19:33:23  sebast (Sebastian Kamyshenko)
 * #ifndef... construction added
 * 
 * Revision 1.1  95/02/16  18:55:06  18:55:06  lord (Vadim Zaliva)
 * Initial revision
 * 
*/

#ifndef POP3_H_FLAG
#define POP3_H_FLAG

#include "umtSockClient.h++"
#include "umtSlist.h++"

// Current implementation uses simple user/password scheme.
// This may be not secure.
// TODO: MD5 (RFC 1321) 

#define POP3_CMDBUF_SIZE (40+4+10)
#define POP3_RSPBUF_SIZE 2048
#define MSG_BUF_INCREMENT 64

class umtPop3MsgInfo: public umtMember
{
public: 
    umtPop3MsgInfo(int, int);
    umtPop3MsgInfo(umtPop3MsgInfo *);
    virtual ~umtPop3MsgInfo();

    int  N;
    int  Size;
    int  IsDeleted;
    char *UIDL;
};

class umtPop3: public umtSockClient ,private umtSlist
{
public: 

    umtPop3(const char *server, const char *service,const char *user, const char *passwd);
    virtual ~umtPop3(); /* QUIT */

    umtPop3MsgInfo *GetFirst();
    umtPop3MsgInfo *GetLast();
    umtPop3MsgInfo *GetPrev(umtPop3MsgInfo *);
    umtPop3MsgInfo *GetNext(umtPop3MsgInfo *);

    int    GetNumberOfMessages();     /* STAT */
    int    GetSizeOfMailbox();        /* STAT */
    int    GetMessageSize(int m);     /* LIST */ /* -1 ERR */
    status DeleteMessage(int n);      /* DELE */
    int    IsMessageDeleted(int n);
    status UndeleteAllMessages();     /* RSET */
    char   *GetMessage(int n);        /* RETR */
    status IsServerAlive();           /* NOOP */
  
    // Optional commands. May be not supported by server

    char *GetMessageHead(int m,int n); /* TOP */
    char *GetMessageUIDL(int m);       /* UIDL */

    // Check remote server capabilities */
  
    int IsUIDLSupported() { return uidl_yes; }

    // Utilites
    umtPop3MsgInfo *FindMessage(int); /* 0-n */

    status Rc;

protected: 

    status get_messages_list();  /* LIST, UIDL */
    status issue_cmd(char *);
    status get_pop_rsp();
    status issue_cmd_and_get_result(char *);
  
private: 
  
    int  uidl_yes;
    int  mboxsize;
    char cmdbuf[POP3_CMDBUF_SIZE+16];
    char rspbuf[POP3_RSPBUF_SIZE+16];

};

#endif


