/*
$Header: /export/CVS/UMT/include/umtRefPointList.h++,v 1.1.1.1 1996/10/21 20:46:46 vlad Exp $

$Log: umtRefPointList.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:46  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:16  sebast
# Revision 2.0
#
# Revision 1.2  1996/03/03  14:03:03  voloh
# -----
#
# Revision 1.1  1996/02/28  13:13:27  voloh
# Initial revision
#
*/

#ifndef _UMT_REF_POINT_LIST_H_
#define _UMT_REF_POINT_LIST_H_


#include <InterViews/window.h>

#include "umtPath.h++"
#include "umtSlist.h++"


class umtRefPoint : public umtMember
{
    umtPath    location;
    umtString  commentary;
    
public:
    umtRefPoint() { }
    umtRefPoint(umtString, umtPath);
    umtRefPoint(umtRefPoint& r) { *this=r; }
    virtual ~umtRefPoint();
    
    umtString& Name() { return commentary; }
    umtPath&   Loc()  { return location;   }
    
    umtRefPoint& operator =(umtRefPoint&);
    int operator ==(umtRefPoint&);
    int operator !=(umtRefPoint&);
};


class umtRefPointList;
class umtHelpDock;
class umtHelp;

class umtRefPointListEntry : public umtMember
{
    umtRefPoint       ref;
    umtRefPointList*  up;
    
public:
    umtRefPointListEntry(
	umtRefPoint,
	    umtRefPointList*
    );
    virtual ~umtRefPointListEntry();
    
    void     Act(Glyph*);
    void     CursorHilight();
    void     CursorUnHilight();
};

class umtRefPointList : public umtSlist
{
    friend class umtRefPointListEntry;
    
    umtPath                directory;
    Cursor*                cursor;
    
public:
    umtRefPointList();
    virtual ~umtRefPointList();
    
    void                   Act(Glyph*, umtRefPoint);
    
    umtRefPointListEntry*  NewRefHandler(umtRefPoint);
    void                   SetWindow(Window* w) { window=w;   }

    void                   CursorHilight();
    void                   CursorUnHilight();
    
protected:    
    int                    cursor_hilighted;
    Window*                window;
};


extern umtHelpDock  UMTHelpDock;

#endif

