/*
$Id: umtRtfGlobals.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtRtfGlobals.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:20  sebast
# Revision 2.0
#
# Revision 1.1  1996/03/03  12:38:32  voloh
# Initial revision
#
*/

#ifndef _RTF_GLOBALS_H_
#define _RTF_GLOBALS_H_


#include "UMT.h++"
#include "umtError.h++"


//#define RTF_IN_DEBUG


//  Output stream defines:

#define RTF_CRITICAL_MSG(msg)   { if ( UMTError )             \
                                    UMTError->Msg(            \
				        umtError::Critical,   \
					msg ); }
#define RTF_ERROR_MSG(msg)      { if ( UMTError )             \
                                    UMTError->Msg(            \
				        umtError::Error,      \
				        msg); }
#define RTF_WARNING_MSG(msg)    { if ( UMTError )             \
                                    UMTError->Msg(            \
				        umtError::Warning,    \
				        msg); }
#define RTF_STATISTICS_MSG(msg) { if ( UMTError )             \
                                    UMTError->Msg(            \
				        umtError::Statistics, \
					msg); }
#define RTF_INFO_MSG(msg)       { if ( UMTError )             \
                                 UMTError->Msg(               \
				     umtError::Info,          \
				     msg); }
#define RTF_DEBUG_MSG(msg)      { if ( UMTError )             \
                                    UMTError->Msg(            \
				        umtError::Debug,      \
				        msg); }


//  For class umtRTFText:

#define FONT_ID ((bold>0?1:0)+(italic>0?2:0)+\
		 (fixed>0?4:0)+(underline>0?8:0))

#define MAX_BIGGER_DEEP  5
#define MAX_SMALLER_DEEP 5


#define HELP_INDEX_COMMENT   "General Index on Help"

//   Defines for RTF-View in UMT-configuration_file:

#define HELP_PATH            "HelpPath"
#define HELP_INDEX_FILE      "HelpIndex"

#define HREF_CONFIG_GROUP    "HelpReferences"

#define GroupRTFCfgName      "RTF-View-Configuration" // {

#define DEFAULT_INDENT_WIDTH     "Indent-Width" // Indent width in Coord type.
#define SWITCH_EXCERPT_ON        "Excerpt-ON"   // String for excerpt on
#define SWITCH_EXCERPT_OFF       "Excerpt-OFF"  //   --   //     --   off

#define CyrillicFlag             "Cyrillic"     // can be "Yes" or other.

#define BaseFonts                "Fonts" // {

#define rtffDef                      "Default"
#define rtffB                        "Bold"
#define rtffI                        "Italic"
#define rtffBI                       "Bold-Italic"
#define rtffF                        "Fixed"
#define rtffBF                       "Bold-Fixed"
#define rtffIF                       "Italic-Fixed"
#define rtffBIF                      "Bold-Italic-Fixed"
#define rtffU                        "Underline"
#define rtffBU                       "Bold-Underline"
#define rtffIU                       "Italic-Underline"
#define rtffBIU                      "Bold-Italic-Underline"
#define rtffFU                       "Fixed-Underline"
#define rtffBFU                      "Bold-Fixed-Underline"
#define rtffIFU                      "Italic-Fixed-Underline"
#define rtffBIFU                     "Bold-Italic-Fixed-Underline"
//                               }
//                           }

// Not in main RTF group:
#define DefaultColor         "Colors.rtfDefault"
#define BackgroundColor      "Colors.rtfBackground"
#define HiBackgroundColor    "Colors.rtfHiBackground"

#endif
