/*
$Id: umtRtfText.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtRtfText.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:21  sebast
# Revision 2.0
#
# Revision 1.1  1996/03/03  12:38:57  voloh
# Initial revision
#
*/

#ifndef _RTF_TEXT_H_
#define _RTF_TEXT_H_

#include <InterViews/background.h>
#include <InterViews/composition.h>
#include <InterViews/layout.h>
#include <InterViews/texcomp.h>
#include <InterViews/session.h>
#include <InterViews/label.h>
#include <ctype.h>

#include "classnames.h++"

#include "umtStack.h++"
#include "umtRtfAttrib.h++"
#include "umtRtfCommands.h++"
#include "umtRtfTextComponent.h++"
#include "umtRtfAttrib.h++"
#include "umtRefPointList.h++"


#define  _REMEMBER_SCROLL_POS_ double __last_scr_pos__;               \
                               int __scr_et_end__;                    \
                               __scr_et_end__ =                       \
			          box_->cur_lower(Dimension_Y)>1? 0:1;\
                               __last_scr_pos__ =                     \
                                  ( box_->upper(Dimension_Y) -        \
				    box_->cur_upper(Dimension_Y) ) /  \
                                  box_->length(Dimension_Y)

#define  _RESTORE_SCROLL_POS_  box_->scroll_to( Dimension_Y,          \
			             box_->upper(Dimension_Y) -       \
			             __last_scr_pos__ *               \
					  box_->length(Dimension_Y) - \
			             box_->cur_length(Dimension_Y)    \
	                       );                                     \
	                       if ( !__scr_et_end__ )                 \
                                   box_->scroll_forward(Dimension_Y)

class umtScrollBox;
class umtRTFView;
class umtRTFEditor;

class umtRTFText : public umtSlist
{
    friend class umtRTFView;
    friend class umtRTFEditor;
    friend class umtScrollBox;

    int                  already;

public: 
    const WidgetKit*     Kit;
    const LayoutKit*     XLayout;
    Style*               XStyle;
    Display*             XDisplay;

    int                  RTFHintsInUse;

    status               ErrorStatus;

    ~umtRTFText          ();

    virtual void         Add(umtString&, int);
    void                 InsertInT(umtRTFTextComponent*,int);
    void                 InsertInTWM(umtRTFTextComponent*,int);

    void                 Clean();
    void                 Repair();
    void                 ReBuildAll();
    void                 ReBuild();
    void                 FastReBuild();
    void                 ReDrawIn();

    status               ResetFonts(umtRTFFonts*);
    umtRTFFonts*         GetFonts()                 { return fonts; }
    status               ResetColors(umtString&);
    umtRTFColors*        GetColors()                { return colors; }

    int                  CursorLeft();
    int                  CursorRight();
    int                  CursorUp();
    int                  CursorDown();
    int                  CursorWLeft();
    int                  CursorWRight();
    int                  CursorHome();
    int                  CursorEnd();
    int                  CursorPgUp();
    int                  CursorPgDown();
    int                  CursorTop();
    int                  CursorBottom();
    int                  Del();
    int                  BS();

    virtual Glyph*       Body() const;
    virtual Adjustable*  Adjust() const;

    status               Init(umtRTFFonts*, umtRTFColors*);

    void                 SetErrorStream(umtScrollBox*);
    umtScrollBox*        ErrorStream() { return ErrStream; }
    void                 SetWindow(Window* w) { ref_callbacks->SetWindow(w); }
    
    int                  AlReady() { return already; }
    
protected: 
    umtRTFText           ();

    void                 set_tab_width(Coord t)        { tab_width        =t; }
    void                 set_indent_width(Coord i)     { def_indent_width =i; }
    void                 set_new_indent_width(Coord i) { indent_width     =i; }
    void                 set_wind_width(Coord w)       { wind_width       =w; }
    void                 set_excerpt_on(umtString& c)  { excerpt_on       =c; }
    void                 set_excerpt_off(umtString& c) { excerpt_off      =c; }

    Coord                get_wind_width()              { return wind_width;   }

    umtRTFTextComponent* cursor;
    umtRTFTextComponent* cursor_gl;
    Glyph*               cursor_on;
    GlyphIndex           cursor_position;
    GlyphIndex           cursor_line;
    umtRefPointList*     ref_callbacks;

    int                  crtextrtf;

    int                  sized;
    int                  bold;                // bm: 0001;
    int                  italic;              // bm: 0010;
    int                  fixed;               // bm: 0100;
    int                  underline;           // bm: 1000;
    int                  indent;
    int                  indent_right;

    int                  c_indent;
    int                  c_indent_right;

    int                  indent_fl;

    umtRTFCommands       cmdstack;
    umtRTFCommands       cur_st;
    umtStack             colors_pars;

    umtRTFFonts*         fonts;
    Font*                cr_font;
    umtRTFColors*        colors;
    Color*               cr_color;

    const Color*         back;
    const Color*         hi_back;

    Coord                x_position;

    umtRTFTextComponent* first_marked;
    GlyphIndex           gi_first;
    umtRTFTextComponent* last_marked;
    GlyphIndex           gi_last;

    TBScrollBox          *box_;
    Composition          *page_;

    // attributes controls:
    void   set_bigger();
    void   set_smaller();
    void   set_bold();
    void   unset_bold();
    void   set_italic();
    void   unset_italic();
    void   set_fixed();
    void   unset_fixed();
    void   set_underline();
    void   unset_underline();

    void   pop_color();

    void   cursor_activate();
    void   cursor_unactivate();

    void   scroll_to_cursor();

#ifdef RTF_IN_DEBUG
    void   dump_out();
#endif

private: 
    void                 init();
    void                 flow_up();
    int                  cursor_placed();
    int                  cursor_placed_bk();
    Coord                update_to(umtRTFTextComponent*);
    GlyphIndex           addlbrmark(umtRTFTextComponent*,GlyphIndex);

    Coord                def_indent_width;
    Coord                indent_width;
    Coord                tab_width;

    umtString            excerpt_on;
    umtString            excerpt_off;

    Coord                wind_width;

    Font*                cfont;
    Color*               ccolor;

    Glyph                *begin_par_;
    Glyph                *end_par_;
    Glyph                *begin_line_;
    Glyph                *end_line_;
    Glyph                *word_space_;
    Glyph                *interline_;
    Glyph                *vfil_glue_;

    umtScrollBox*        ErrStream;

};


#endif
