/*
$Header: /export/CVS/UMT/include/umtSelectionList.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtSelectionList.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:25  sebast
# Revision 2.0
#
# Revision 1.11  1995/11/09  16:22:54  bird
# empty_glyph & is_empty added
#
# Revision 1.10  1995/10/01  15:35:48  bird
# Insert() added
#
# Revision 1.9  1995/09/27  17:41:14  lord
# Move added
#
# Revision 1.8  1995/09/09  15:06:51  lord
#     umtSelectionListEntry *GetSelected();
#
# Revision 1.7  1995/08/02  11:22:02  lord
# umt coding rules
#
# Revision 1.6  1995/06/22  12:29:21  sebast
# classname() removed
#
# Revision 1.5  1995/06/21  16:23:06  lord
# members now public
#
# Revision 1.4  1995/06/21  12:11:29  lord
# classname() added
#
# Revision 1.3  1995/06/18  16:34:37  lord
# umark_all added
#
# Revision 1.2  1995/06/18  12:30:08  lord
# First implementation.
#
# Revision 1.1  1995/06/18  11:55:45  lord
# Initial revision
#
*/

#ifndef SELECTION_LIST_H_FLAG
#define SELECTION_LIST_H_FLAG

#include <IV-look/kit.h>
#include <IV-look/dialogs.h>
#include <InterViews/action.h>
#include <InterViews/background.h>
#include <InterViews/layout.h>
#include <InterViews/session.h>
#include <InterViews/style.h>
#include <InterViews/window.h>
#include <InterViews/patch.h>
#include <InterViews/background.h>
#include <InterViews/stencil.h>

#include "umtSlist.h++"

class umtSelectionList;

// You must create your own class, inheriting it fro this one.
// In this class you should define actions preformed on
// pressing left or right mouse buttons and double click.
// If no special selection logic required, just call
// click_* functions of this class after yours actions
// to set is_selected flag properly.
//
// lord
class umtSelectionListEntry:public ActiveHandler,public umtMember
{
public: 

  umtSelectionListEntry(Glyph *, umtSelectionList *,Style *s);
  umtSelectionListEntry(umtSelectionListEntry *);

  virtual ~umtSelectionListEntry();

  virtual void ClickL();
  virtual void ClickR();
  virtual void ClickD();
  virtual void Move  ();
  
  int     IsSelected;

protected: 

  virtual void double_click(const Event &);
  virtual void release     (const Event &);
  virtual void press       (const Event &);
  virtual void move        (const Event &);
  virtual void drag        (const Event &);
  
  umtSelectionList  *lst;
  Glyph             *par;
  Style             *sty;
  
private: 
  
};

// Usually you should not inherit from this class. Use it as-is.
// muty_selectio_allowed flag in constructor specify if you can select
// several items.
//
//lord
class umtSelectionList:public TBScrollBox
{
  friend class umtSelectionListEntry;

public:
    
    umtSelectionList(int multi_selection_allowed=0,Glyph *g=nil);
    virtual ~umtSelectionList();
    
    virtual void Insert(umtSelectionListEntry *,umtSelectionListEntry *);
    virtual void Append(umtSelectionListEntry *);
    virtual void Remove(umtSelectionListEntry *);
    
    void     UnmarkAll();
    umtSelectionListEntry *GetSelected();
    
    umtSlist Members;
    
protected: 
    
    int                         press_flag;
    umtSelectionListEntry       *start_drag;
    int                         is_multy;
    
private: 
    int                         is_empty;
    Glyph                       *empty_glyph;
};


#endif





