/*
$Header: /export/CVS/UMT/include/umtSockClient.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

$Log: umtSockClient.h++,v $
Revision 1.1.1.1  1996/10/21 20:46:45  vlad
Puting to CVS. Version 1.00B3

 * Revision 2.0  1996/03/18  16:45:27  sebast
 * Revision 2.0
 *
 * Revision 1.11  1995/09/13  17:07:54  vlad
 * methods Send(), Recv()  are set virtual.
 *
 * Revision 1.10  1995/09/13  14:33:08  vlad
 * Method  int SendFileToSocket( int f, int blocksize, int opt ) added.
 *
 * Revision 1.9  1995/09/13  13:13:50  vlad
 * Changed method SetIOTimeOut( long input, long output ) name.
 *
 * Revision 1.8  1995/09/12  12:18:21  vlad
 * Method   int  SetIOTimeout( long input, long output ) added.
 *
 * Revision 1.7  1995/08/25  08:24:05  lord
 * Add const to constructor. Remove server_name.
 * Add const to SendFileToSocket
 *
 * Revision 1.6  1995/08/25  08:21:25  lord
 * add some const
 *
 * Revision 1.5  1995/07/31  14:32:48  lord
 * umt coding convention
 *
 * Revision 1.4  1995/07/27  16:21:52  lord
 * sys/types.h included
 *
 * Revision 1.3  1995/04/26  10:58:03  sebast
 * uses *.h++ instead *.h
 *
 * Revision 1.2  1995/02/16  19:36:19  sebast
 * #ifndef... construction added
 *
 * Revision 1.1  95/02/16  10:13:52  10:13:52  lord (Vadim Zaliva)
 * Initial revision
 * 
*/

#ifndef SOCK_CLIENT_H_FLAG
#define SOCK_CLIENT_H_FLAG

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

#include "umtMember.h++"

#define DEFAULT_SND_BLOCKSIZE 1024
 
class umtSockClient: public umtMember
{
public: 
  
    umtSockClient(const char *servern, const char *service);
    virtual ~umtSockClient();
    
    int   SendFileToSocket( const char *filename, int blocksize=DEFAULT_SND_BLOCKSIZE, int opt = 0 );
    int   SendFileToSocket( int f, int blocksize = DEFAULT_SND_BLOCKSIZE, int opt = 0 );
    virtual int Send( const char *buf, int size, int opt = 0 );
    virtual int Recv( char *buf, int size, int opt = 0);
    char *ReadLn( char *, int maxlen);
    int   SetIOTimeOut( long input, long output );/* in seconds */
    
protected: 
    
    int s; /* socket */
    
private: 
  
    struct hostent *hp;
    struct sockaddr_in server;
    struct servent *sp;
  
};

#endif
