/* 
   $Header: /export/CVS/UMT/include/umtString.h++,v 1.1.1.1 1996/10/21 20:46:45 vlad Exp $

   $Log: umtString.h++,v $
   Revision 1.1.1.1  1996/10/21 20:46:45  vlad
   Puting to CVS. Version 1.00B3

# Revision 2.0  1996/03/18  16:45:29  sebast
# Revision 2.0
#
# Revision 1.14  1995/10/28  16:10:49  vlad
# methods Sprintf(), operator +() added.
#
# Revision 1.13  1995/09/14  21:07:08  lord
# put set_value back.
#
# Revision 1.12  1995/09/14  20:17:02  lord
# Removed some old crud.
#
# Revision 1.11  1995/09/06  14:35:19  lord
# Leave only & copy constructor.
#
# Revision 1.10  1995/09/05  18:12:15  lord
# make operator[] char instead of unsigned char
#
# Revision 1.9  1995/09/03  16:50:52  voloh
# Type boolean removed.
#
# Revision 1.8  1995/08/24  13:17:23  lord
# String() renamed to Str() for IV compatibility.
#
# Revision 1.7  1995/08/23  16:11:04  lord
# remove all inlines to hell!
#
# Revision 1.6  1995/08/22  14:48:07  lord
# Hash commented out, because it is not used anywhere
#
# Revision 1.5  1995/08/02  15:00:37  lord
# make true and false defines instead of const. for HP800
#
# Revision 1.4  1995/07/31  14:27:01  lord
# converted to umt coding convention
#
# Revision 1.3  1995/07/31  10:46:18  sebast
# operator =() non-virtual
#
# Revision 1.2  1995/07/27  16:27:45  lord
# Make boolean typedef instead of define
# Make constans true and false
#
# Revision 1.1  1995/06/24  15:40:13  lord
# Initial revision
#
   */


#ifndef UMT_STRING_H_FLAG
#define UMT_STRING_H_FLAG

#include "umtMember.h++"
#include <stdio.h>

#include <sys/types.h>

#ifndef nil
#define nil NULL
#endif

#define MAX_FOPMAT_STRING 8192

class umtString : public umtMember
{
public:
    umtString();
    umtString(const umtString *) ;
    umtString(const char * );
    umtString(const char *, int );
    umtString(const umtString&);
    virtual ~umtString();

    umtString &Sprintf( const char*, ... );
    
    const char* Str() const;
    int         Length() const;

    int         Read(FILE *); /* read from file null terminated string */
    int         Write(FILE *); /* write null terminated string to file */

    void        StripCRLF(); /* strip CR and LF at the end of line */
    void        StripJunk(); /* strip SPACES CR and LF at the end of line */

    umtString& operator =(const umtString &);
    umtString& operator =(const char * );

    virtual operator char *() const;

    virtual int operator ==(const umtString &) const;
    virtual int operator ==(const char *) const;

    virtual int operator !=(const umtString &) const;
    virtual int operator !=(const char *) const;

    virtual int operator >(const umtString &) const;
    virtual int operator >(const char *) const;

    virtual int operator >=(const umtString &) const;
    virtual int operator >=(const char *) const;

    virtual int operator <(const umtString &) const;
    virtual int operator <(const char *) const;

    virtual int operator <=(const umtString &) const;
    virtual int operator <=(const char *) const;

    virtual umtString& operator +=(const char * );
    virtual umtString& operator +=(const umtString&);
    virtual umtString& operator +=(const char);

    virtual umtString operator +(const char * );
    virtual umtString operator +(const umtString&);
    virtual umtString operator +(const char);

    virtual int CaseInsensitiveEqual(const umtString &) const;
    virtual int CaseInsensitiveEqual(const char *) const;

    char  operator [](int index) const;

    virtual umtString SubStr(int start, int length) const;
    umtString         Left(int length) const;
    umtString         Right(int start) const;

    virtual void SetToSubstr(int start, int length);
    void         SetToLeft(int length);
    void         SetToRight(int start);

    void        ToLower();
    void        ToUpper();
    
    virtual int       Search(int start, unsigned char) const;
    virtual umtString Search(unsigned char) const;
    virtual umtString SearchBack(unsigned char) const;

    int               Index(unsigned char) const;
    int               RIndex(unsigned char) const;

    virtual int   ConvertTo(int    &) const;
    virtual int   ConvertTo(long   &) const;
    virtual int   ConvertTo(float  &) const;
    virtual int   ConvertTo(double &) const;

    virtual int   IsEmpty() const;

protected: 

    void set_value(const char *);

private:
    
    char* data_;
};



#endif











