/*
$Header: /export/CVS/UMT/libsrc/addrbook/umtAddrBookEntry.cc,v 1.1 1996/10/22 19:47:20 lord Exp $

$Log: umtAddrBookEntry.cc,v $
Revision 1.1  1996/10/22 19:47:20  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:46  vlad
Puting to CVS. Version 1.00B3

// Revision 2.2  1996/04/08  16:58:36  bird
// *** empty log message ***
//
// Revision 2.1  1996/04/07  11:21:53  bird
// in umtAddrBookEntry(umtMsg *m) bug fixed (If InternetAddr empty)
//
// Revision 2.0  1996/03/18  16:39:15  sebast
// Revision 2.0
//
// Revision 1.16  1996/02/23  15:40:03  bird
// Bug in Save() fixed
//
// Revision 1.15  1996/02/15  14:38:00  sebast
// GetInternetAddr() added; using ReplyTo field instead From, if possible
//
// Revision 1.14  1995/12/01  14:51:49  bird
// bug in constructor(umtMsg *) fixed
//
// Revision 1.13  1995/09/29  17:41:39  lord
// Alias.StripJunk()
//
// Revision 1.12  1995/09/29  17:41:01  lord
// Add : after Organization
//
// Revision 1.11  1995/09/29  17:26:48  lord
// Add Alias and Company detection
//
// Revision 1.10  1995/09/28  18:40:25  bird
//     RealName.StripJunk();
//     Addr.StripJunk();
// in constructor
//
// Revision 1.9  1995/08/31  11:51:09  lord
// affected by umtInternetAddr new interface
//
// Revision 1.8  1995/07/31  18:01:07  lord
// umt coding rules
//
// Revision 1.7  1995/06/24  15:42:30  lord
// stip_junk calls in read/write
//
// Revision 1.6  1995/06/24  12:36:44  lord
// operator = added
//
// Revision 1.5  1995/06/24  11:19:54  lord
// Make internet default network type.
//
// Revision 1.4  1995/06/22  10:56:16  sebast
// call of member() added
//
// Revision 1.3  1995/05/20  16:28:51  lord
// AddrBookEntry::AddrBookEntry(msg *m)
//
// Revision 1.2  1995/05/09  14:44:34  lord
// Load function fixed
//
// Revision 1.1  1995/05/09  14:00:19  lord
// Initial revision
//
*/

#include "umtAddrBook.h++"
#include "misc.h++"
#include <unistd.h>

umtAddrBookEntry::umtAddrBookEntry() : umtMember(CLASS_ADDR_BOOK_ENTRY)
{
    NetworkType              = Internet;
    Flags                    = 0;
    LastMessageReceivedAt    = 0;
    LastMessageSentAt        = 0;
}

umtAddrBookEntry::umtAddrBookEntry(umtMsg *m) : umtMember(CLASS_ADDR_BOOK_ENTRY)
{
    umtSlist           *from;
    umtString          firm;
    umtString          *f;
    umtInternetHeader  *hed;
    int                i;
    
    from=m->GetReplyToField();
    if (from->GetFirst() == nil)
        from=m->GetFromField();
    if(from->GetFirst())
    {
	RealName =((umtInternetAddr *)(from->GetFirst()))->GetName();
	Addr     =((umtInternetAddr *)(from->GetFirst()))->GetAddr();
	RealName.StripJunk();
	Addr.StripJunk();
    }
    
    hed=m->GetHeader();
    if(hed)
    {
	if(!(f=hed->GetField("Organization:")))
	    if(!(f=hed->GetField("Organisation:"))) 
		if(!(f=hed->GetField("X-Organization:"))) 
		    if(!(f=hed->GetField("X-Organisation:")))
			f = new umtString("");
    }
    
    if(f) Company=*f;

    i=Addr.Index('@');
    if(i>=0)
	Alias=Addr.Left(i);
    else
	Alias="nobody";

    Alias.StripJunk();
    
    NetworkType = Internet; // TODO: X-FTN,etc
    Flags       = 0;
}

umtAddrBookEntry::umtAddrBookEntry(umtAddrBookEntry *p) : umtMember(CLASS_ADDR_BOOK_ENTRY)
{
    Alias    = p->Alias;
    RealName = p->RealName;
    Company  = p->Company;
    Addr     = p->Addr;
  
    NetworkType = p->NetworkType;
    Flags       = p->Flags;

    LastMessageReceivedAt = p->LastMessageReceivedAt;
    LastMessageSentAt     = p->LastMessageSentAt;
}

umtAddrBookEntry::~umtAddrBookEntry()
{
}

status umtAddrBookEntry::Load(FILE *f)
{
    if( Alias    .  Read(f))  return ERROR_LOAD ;
    if( RealName .  Read(f))  return ERROR_LOAD ;
    if( Company  .  Read(f))  return ERROR_LOAD ;
    if( Addr     .  Read(f))  return ERROR_LOAD ;
  
    Alias    . StripJunk();
    RealName . StripJunk();
    Company  . StripJunk();
    Addr     . StripJunk();

    if(
	fscanf(f,"%d %u %ld %ld\n",
	       &NetworkType,
	       &Flags,
	       &LastMessageReceivedAt,
	       &LastMessageSentAt)
	!= 4
    ) return ERROR_LOAD;
    return OK;
}

status umtAddrBookEntry::Save(FILE *f)
{
    Alias    . StripJunk();
    RealName . StripJunk();
    Company  . StripJunk();
    Addr     . StripJunk();

    if( !Alias.IsEmpty() && Alias.Write(f))       return ERROR_SAVE ;
    if(fputc('\n',f)==EOF   )                     return ERROR_SAVE ;
    if( !RealName.IsEmpty() && RealName.Write(f)) return ERROR_SAVE ;
    if(fputc('\n',f)==EOF   )                     return ERROR_SAVE ;
    if( !Company.IsEmpty() && Company.Write(f))   return ERROR_SAVE ;
    if(fputc('\n',f)==EOF   )                     return ERROR_SAVE ;
    if( !Addr.IsEmpty() && Addr.Write(f))         return ERROR_SAVE ;
    if(fputc('\n',f)==EOF   )                     return ERROR_SAVE ;
    if(
	fprintf(f,"%d %u %ld %ld\n",
		NetworkType,
		Flags,
		LastMessageReceivedAt,
		LastMessageSentAt)
	< 0
    ) return ERROR_SAVE;
    return OK;
}

umtAddrBookEntry& umtAddrBookEntry::operator =(const umtAddrBookEntry &entry)
{
    Alias                    = entry.Alias;
    RealName                 = entry.RealName;
    Company                  = entry.Company;
    Addr                     = entry.Addr;
    NetworkType              = entry.NetworkType;
    Flags                    = entry.Flags;
    LastMessageReceivedAt    = entry.LastMessageReceivedAt;
    LastMessageSentAt        = entry.LastMessageSentAt;

    return *this;
}

umtInternetAddr umtAddrBookEntry::GetInternetAddr()
{
    umtInternetAddr ia;
    umtString       ErrorStr("");
    
    ia.SetRealName(&RealName);

    switch(NetworkType) {
    case Compuserve:
	if (ia.SetCompuserveAddr(&Addr) != OK)
	     ia.SetInternetAddr(&ErrorStr);
	break;
    case Fidonet:
	if (ia.SetFidonetAddr(&Addr) != OK)
	    ia.SetInternetAddr(&ErrorStr);
	break;
    case Internet:
    default:
	ia.SetInternetAddr(&Addr);
	break;
    }
    return ia;
}

