/*  $Header: /export/CVS/UMT/libsrc/coding/umtBaseCodeClass.cc,v 1.1 1996/10/22 19:47:22 lord Exp $

    $Log: umtBaseCodeClass.cc,v $
    Revision 1.1  1996/10/22 19:47:22  lord
    Due to stupidity of SUN CC, all .c++ files renamed to .cc.
    Some platform directories created in lib.
    Makefile.include for SUN created.

    Revision 1.1.1.1  1996/10/21 20:46:46  vlad
    Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:40:59  sebast
// Revision 2.0
//
// Revision 1.6  1996/02/19  19:26:29  vlad
// file name to UUENCODE is added.
//
// Revision 1.5  1995/08/01  13:03:44  lord
// umt coding rules
//
// Revision 1.4  1995/07/25  12:51:40  sebast
// IsSevenBitFile() moved to misc
//
// Revision 1.3  1995/07/24  17:28:43  sebast
// IsSevenBitFile() implemented and tested. Algorithm for GetCoder() changed.
// EightBit' coding added
//
// Revision 1.2  1995/06/22  10:58:17  sebast
// call of member() added
//
// Revision 1.1  1995/06/09  16:56:20  sebast
// Initial revision
//
*/

#include "umtBaseCodeClass.h++"

#include "umtBase64Code.h++"
#include "umtQPCode.h++"
#include "umtUUCode.h++"
#include "umtBTOACode.h++"
#include "umt8BitCode.h++"

umtBaseCodeClass::umtBaseCodeClass(umtString s, int *r) : umtMember(CLASS_BASE_CODE)
{ 
    RFile = new umtRFile(s,r); 
}
  
umtBaseCodeClass::~umtBaseCodeClass()        
{
    if(RFile)
	Delete(RFile);
}

status umtBaseCodeClass::Decode(FILE *f,umtString str )
{
    FILE *out = fopen(str,"w");
    if(out == nil) 
    {
	fclose(out);
	return ERROR_OPEN_FILE;
    }
    status ret = Decode(f,out);
    fclose(out);
    return ((ret < 0)?ERROR_IN_CALLED_FUNCTION:ret);
}

umtBaseCodeClass *umtBaseCodeClass::GetCoder(ContentTransferEncoding type,
				       umtString str,
				       int *r)
{
    switch (type) 
    {
    case base64:
	return new umtBase64Code(str,r);
    case uudecode:
	return new umtUUCode(str,r);
    case btoa:
	return new umtBTOACode(str,r);
    case binary:
    case eight_bit:
    case seven_bit:
    case x_encoding:
	return new umt8BitCode(str,r);
    case quoted_printable:
	return new umtQPCode(str,r);
    default:
	return nil;
    }
}





