/* $Header: /export/CVS/UMT/libsrc/coding/umtUUCode.cc,v 1.1 1996/10/22 19:47:23 lord Exp $

   $Log: umtUUCode.cc,v $
   Revision 1.1  1996/10/22 19:47:23  lord
   Due to stupidity of SUN CC, all .c++ files renamed to .cc.
   Some platform directories created in lib.
   Makefile.include for SUN created.

   Revision 1.1.1.1  1996/10/21 20:46:46  vlad
   Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:41:07  sebast
// Revision 2.0
//
// Revision 1.7  1996/02/22  11:36:37  vlad
// DEBUG removed.
//
// Revision 1.6  1996/02/19  19:26:12  vlad
// file name to UUENCODE is added.
//
// Revision 1.5  1995/08/01  13:16:00  lord
// umt coding rules
//
// Revision 1.4  1995/07/28  15:50:43  sebast
// bug with umtString; string.h added
//
// Revision 1.3  1995/05/23  13:08:02  bird
// Kill default consstructor
// update Decode()
//
// Revision 1.2  1995/04/28  14:30:05  sebast
// it works now!?
//
// Revision 1.1  1995/04/27  13:49:07  sebast
// Initial revision
//
Revision 1.1  1995/04/27  14:34:09  mohamed
Initial revision

*/

#include <string.h>

#include "umtUUCode.h++"

umtUUCode::umtUUCode(umtString s, int *r):umtBaseCodeClass(s,r)
{
  bufsize=100;
  Buffer=new char[bufsize+1];
  outBuffer=new char[bufsize+1];
}


umtUUCode::~umtUUCode()
{
  delete [] Buffer;
  delete [] outBuffer;
}
  
inline char umtUUCode::CHARX(int x)
{
  return S_ASCII[(x)];
}


char umtUUCode::S_ASCII[] =
"`!\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_";

int  umtUUCode::convert (char * BinBuffer,
		      char * TextBuffer,
		      int len)
{ 
  register char *tmp  = BinBuffer;
  register char *pout = TextBuffer;
  register int  i     = 0;
  register char c1, c2, c3;
  register int  k     = (len+2)/3;
  
  *pout++ = CHARX( len );
  while ( i++ < k )
    {
      c1 = *tmp++;
      c2 = *tmp++;
      c3 = *tmp++;
      *pout++ = CHARX((c1&0xfc)>>2);
      *pout++ = CHARX(((c1&3)<<4)|((c2&0xf0)>>4));
      *pout++ = CHARX(((c2&15)<<2)|((c3&0xc0)>>6));
      *pout++ = CHARX(c3&0x3f);
    }
  *pout++ = '\n';
  *pout++ = 0;
  return 0;
}

status umtUUCode::Encode ( FILE * f1 , FILE * f2, umtString filename )
{
  const int BufferSize = 45;
  const char Bg[]      = "begin 660";
  const char En[]      = "end\n";
  char BinBuffer[BufferSize];
  char TextBuffer[((BufferSize+7)*4)/3];
  int len;

//  fprintf( stderr, "Name '%s'\n", filename.Str());
  fprintf( f2, "%s %s\n", Bg, (filename.IsEmpty())? "": filename.Str());
  while ( !feof(f1) )
    {
      len = fread ( BinBuffer,1,BufferSize,f1 );
      convert     ( BinBuffer,TextBuffer,len );
      fwrite      ( TextBuffer,1,strlen(TextBuffer),f2 );
    }
  convert(BinBuffer,TextBuffer,0);
  fwrite(TextBuffer,1,strlen(TextBuffer),f2);
  fwrite(En,1,strlen(En),f2);
  return OK;
}



inline char  umtUUCode::CHARNUM(char x)
{
  return ((x-'!'+1) & 0x3f);
}


int umtUUCode::unconvert ( char *TextBuffer, char *BinBuffer)
{
  register char *ttmp = TextBuffer;
  register char c1,c2,c3,c4;
  register char *btmp = BinBuffer;
  register int count  = (CHARNUM(*ttmp++)+2)/3;

  while ( count-->0 )
    {
      c1 = CHARNUM(*ttmp++);
      c2 = CHARNUM(*ttmp++);
      c3 = CHARNUM(*ttmp++);
      c4 = CHARNUM(*ttmp++);
      *btmp++ = (  c1     << 2 ) | ( c2 >> 4 );
      *btmp++ = ( (c2&15) << 4 ) | ( c3 >> 2 );
      *btmp++ = ( (c3&3)  << 6 ) |   c4;
    }
  return 0;
}

   int umtUUCode::Begin(void)
{
  return ( Buffer[0] == 'b') &&
    ( Buffer[1] == 'e') &&
      ( Buffer[2] == 'g') &&
	( Buffer[3] == 'i') &&
	  ( Buffer[4] == 'n') &&
	    ( Buffer[5] == ' ');
}

int umtUUCode::End(void)
{
  return ( Buffer[0] == 'e' ) &&
    ( Buffer[1] == 'n' ) &&
      ( Buffer[2] == 'd' ) &&
	( (Buffer[3]=='\0')||
	 (Buffer[3]==' ')||
	 (Buffer[3]=='\11')||
	 (Buffer[3]=='\n') );
}


status umtUUCode::Decode( FILE *f1, FILE *f2 )
{
  umtString s;
  int flg_in_text = 0;
  
  RFile->SetFile(f1);  
  while ( ( RFile->More() )&&(flg_in_text<2) )
    {
      s=RFile->GetString();
      if(s.IsEmpty()) break;
      strcpy(Buffer,s);
      //      fgets(Buffer,bufsize,f1);
      
      if ( flg_in_text==1 )
	if ( End() )
	  flg_in_text = 2;
	else {
	  unconvert(Buffer,outBuffer);
	  fwrite(outBuffer,1,CHARNUM(*Buffer),f2);
	}
      if ( (flg_in_text==0) && Begin() )
	flg_in_text = 1;
    }
  
  if (RFile->GetFound()==2) 
   return LAST_BOUNDARY;
  return OK;  
}




























