/*
//$Header: /export/CVS/UMT/libsrc/folder/umtFilter.cc,v 1.1 1996/10/22 19:47:26 lord Exp $

//$Log: umtFilter.cc,v $
//Revision 1.1  1996/10/22 19:47:26  lord
//Due to stupidity of SUN CC, all .c++ files renamed to .cc.
//Some platform directories created in lib.
//Makefile.include for SUN created.
//
//Revision 1.1.1.1  1996/10/21 20:46:47  vlad
//Puting to CVS. Version 1.00B3
//
// Revision 2.0  1996/03/18  16:41:19  sebast
// Revision 2.0
//
// Revision 1.21  1996/03/01  15:12:34  vlad
// gcc 2.7.0 for LINUXelf potred.
//
//Revision 1.20  1996/02/15 13:20:29  sebast
//some changes because case in RegExp
//
// Revision 1.19  1996/02/14  10:21:37  sebast
//     umtFilterCondition(const umtFilterCondition &); added
//
// Revision 1.18  1996/02/12  12:54:05  sebast
// filters changes done
//
// Revision 1.17  1995/10/25  19:03:56  sebast
// *** empty log message ***
//
// Revision 1.16  1995/10/25  18:54:46  sebast
// lots remade
//
// Revision 1.15  1995/09/13  18:02:22  sebast
// some small bugs with Locking removed
//
// Revision 1.14  1995/09/13  15:29:07  sebast
// smth. strange with ~umtFilterList(): address of lock = 0
//
// Revision 1.13  1995/09/13  14:26:28  sebast
// return when non-error in Load() removed
//
// Revision 1.12  1995/09/13  13:34:32  sebast
// using umtLock *lock added
//
// Revision 1.11  1995/08/31  11:45:47  lord
// affected by new umtInternetAddr interface.
//
// Revision 1.10  1995/08/02  11:39:22  sebast
// umtCodingRules
//
// Revision 1.9  1995/07/31  18:12:00  sebast
// some changes for UMT coding rules
//
// Revision 1.8  1995/07/28  15:19:02  sebast
// Port for SGI: some non-supported constructions changed
//
// Revision 1.7  1995/07/09  20:54:23  lord
// sys/stat.h included for creat mode flags under Linux
//
// Revision 1.6  1995/07/06  11:06:52  sebast
// FilterList Save/Load added. NON-tested
//
// Revision 1.5  1995/07/04  19:00:09  sebast
// Save/Load changed. NON-tested
//
// Revision 1.4  1995/07/04  15:46:56  sebast
// a lot of functions added. NON-tested
//
// Revision 1.3  1995/07/03  18:01:47  sebast
// some stuff added. Work with FilterList started
//
// Revision 1.2  1995/06/22  11:10:12  sebast
// call of member() changed
//
// Revision 1.1  1995/05/23  16:25:10  lord
// Initial revision
//
*/

#include <sys/stat.h>

#include "UMT.h++"

#include "umtFilter.h++"

umtFilterCondition::umtFilterCondition(unsigned int fields,
				       umtRegex reg_exp,
				       umtString spec_field_name) :
    umtMember(CLASS_FILTER)
{
    Fields=fields;
    RegExp = reg_exp;
    SpecialFieldName = spec_field_name;
    if ( (Fields & FC_OTHER) && spec_field_name.IsEmpty()) {
	ErrorStatus = NO_VARIABLE_DEFINED;
	return ;
    }
    ErrorStatus = OK;
}

umtFilterCondition::umtFilterCondition(const umtFilterCondition& x)
{
    Fields = x.Fields;
    RegExp = x.RegExp;
    SpecialFieldName = x.SpecialFieldName;
    ErrorStatus = OK;
}

umtFilterCondition::~umtFilterCondition() {}

umtFilterCondition& umtFilterCondition::operator =(const umtFilterCondition& x)
{
    if (&x != this) {
	Fields = x.Fields;
	RegExp = x.RegExp;
	SpecialFieldName = x.SpecialFieldName;
    }
    return *this;
}

int umtFilterCondition::Match(umtMsg *msg)
{
    umtSlist        *lst;
    umtInternetAddr *ia;
  
    if (Fields&FC_SUBJECT) {
	if (RegExp == *(msg->GetSubjField()))
	    return 1;
    }
    
    if (Fields&FC_OTHER)
	if (RegExp==*(msg->GetHeader()->GetField(&SpecialFieldName)))
	    return 1;

    if (Fields&FC_TO) {
	lst=msg->GetToField();
	for (ia=(umtInternetAddr *)lst->GetFirst();
	     ia;
	     ia=(umtInternetAddr *)lst->GetNext(ia))
	    if (RegExp == ia->GetAddr()) {
		return 1;
	    }
    }

    if (Fields&FC_FROM) {
	lst=msg->GetFromField();
	for (ia=(umtInternetAddr *)lst->GetFirst();
	     ia;
	     ia=(umtInternetAddr *)lst->GetNext(ia))
	    if (RegExp == ia->GetAddr()) {
		return 1;
	    }
    }
    
    if (Fields&FC_REPLYTO) {
	lst=msg->GetReplyToField();
	for (ia=(umtInternetAddr *)lst->GetFirst();
	     ia;
	     ia=(umtInternetAddr *)lst->GetNext(ia))
	    if (RegExp == ia->GetAddr()) {
		return 1;
	    }
    }

    return 0;
}

umtFilter::umtFilter(umtString name, int active,
		     umtFilterCondition condition,
		     unsigned int acts,
		     umtPath   act_copy,
		     umtPath   act_reply,
		     umtString act_forward)
    : umtMember(CLASS_FILTER)
{
    FilterName = name;
    IsActive   = active;

    FilterCondition = condition;

    Actions              = acts;
    ActionCopyPath       = act_copy;
    ActionReplyPath      = act_reply;
    ActionForwardAddress = act_forward;
    if ( ((Actions&FA_COPY) && ActionCopyPath.IsEmpty()) ||
	 ((Actions&FA_REPLY) && ActionReplyPath.IsEmpty()) ||
	 ((Actions&FA_FORWARD) && ActionForwardAddress.IsEmpty())
    ) {
	ErrorStatus = NO_VARIABLE_DEFINED;
	return ;
    }
    
    ErrorStatus = OK;
}

umtFilter::~umtFilter() {}

int umtFilter::Match(umtMsg *m)
{
    return FilterCondition.Match(m);
}

umtFilterList::umtFilterList() : umtSlist()
{
    Lock = NULL;
}

umtFilterList::~umtFilterList()
{
    if (Lock) Delete(Lock);
    Kill(NULL); 
}

umtFilter *umtFilterList::GetFirst()
{
    return (umtFilter *)umtSlist::GetFirst();
}
umtFilter *umtFilterList::GetLast()
{
    return (umtFilter *)umtSlist::GetLast();
}
umtFilter *umtFilterList::GetPrev(umtFilter * p)
{
    return (umtFilter *)umtSlist::GetPrev(p);
}
umtFilter *umtFilterList::GetNext(umtFilter * p)
{
    return (umtFilter *)umtSlist::GetNext(p);
}

status umtFilterList::Load() {
    int i;
    umtString us;

    umtConfiguration conf;
    umtConfiguration *cfg,*cc;

    int       is_case, is_active, field, action;
    umtRegex  reg_exp;


    name = UMTConfig.GetStrField("FolderDir");
    name += "/";
    name += FILTER_FILE_NAME;

    umtPath up = name;
    up += LOCK_EXTENTION;
    Lock = new umtLock(up);
    int rc = Lock->Lock();
    if (rc!=OK && rc!=ALREADY_LOCKED ) {
	UMTError->Msg(umtError::Warning,"Can't lock file: <%s>!",Lock->GetPath().Str());
    }
    
    if (conf.Read(name))
	return ERROR_LOAD;

    us = conf.GetStrField("UMTFilterFileVersion");
    if (us.IsEmpty()) {
	cfg = conf.GetConfiguration(umtString("FilterEntries"));
	if (cfg)
	    for (cc=cfg->GetFirst(),i=0;cc;cc=cfg->GetNext(cc),++i) {
		umtString       filter_name, spec_field;
		umtString       act_par;
		    
		us = cc->GetName();
		filter_name = cfg->GetStrField(us,0);
		cfg->GetIntField(us,&field,1);
		cfg->GetIntField(us,&action,3);
		cfg->GetIntField(us,&is_case,4);
		reg_exp.Set(cfg->GetStrField(us,2),is_case);
		spec_field = cfg->GetStrField(us,5);
		act_par = cfg->GetStrField(us,6);
		cfg->GetIntField(us,&is_active,7);

		unsigned int fields = 1<<field;
		unsigned int actions = 1<<action;
		
		umtFilterCondition condition(fields,reg_exp,spec_field);
		if (condition.ErrorStatus < 0) {
		    UMTError->Msg(umtError::Error,"No variable defined");
		}
		umtPath act  ( act_par),
		        empty( "" ) ;
		Append (
		    new umtFilter(filter_name, is_active,
				  condition,
				  actions,
				  actions&FA_COPY ? act : empty,
				  actions&FA_REPLY ? act : empty,
				  actions&FA_FORWARD ? umtString(act_par) : umtString("")
		    )
		);
	    }
    }
    else if (us=="2.0") {
	cfg = conf.GetConfiguration(umtString("FilterEntries"));
	if (cfg)
	    for (cc=cfg->GetFirst(),i=0;cc;cc=cfg->GetNext(cc),++i) {
//		us = cc->GetName(); us+=".";
		cc->GetIntField("IsActive",&is_active);

		cc->GetIntField("Condition.IsCase",&is_case);
		cc->GetIntField("Condition.Fields",&field);
		reg_exp.Set(cc->GetStrField("Condition.RegExp"), is_case);
		cc->GetIntField("Actions.Action",&action);

		umtFilterCondition condition((unsigned int)field,
					     reg_exp,
					     cc->GetStrField("Condition.OtherFieldName")
		);
		if (condition.ErrorStatus < 0) {
		    UMTError->Msg(umtError::Error,"No variable defined");
		}

		umtString ActionCopyPath  = cc->GetStrField("Actions.ActionCopyPath");
		umtString ActionReplyPath = cc->GetStrField("Actions.ActionReplyPath");
		Append (
		    new umtFilter(cc->GetStrField("Name"),
				  is_active,
				  condition,
				  (unsigned int)action,
				  ActionCopyPath,
				  ActionReplyPath,
				  cc->GetStrField("Actions.ActionForwardAddress")
		    )
		);
	    }
    }
    
    return OK;
}

status umtFilterList::Save() {
    umtConfiguration conf;
    umtString us;
    int i;
    umtFilter *f;

    if (!Lock->IsLocked()) return NOT_LOCKED;
    unlink(name);

    conf.Set("UMTFilterFileVersion","2.0");
    for (f=GetFirst(),i=0;f;f=GetNext(f),++i) {
 	us.Sprintf("FilterEntries.%d.",i);
	conf.Set(us+"Name", f->FilterName);
	conf.Set(us+"IsActive", f->IsActive);
	conf.Set(us+"Condition.Fields",(int)f->FilterCondition.Fields);
	conf.Set(us+"Condition.OtherFieldName",f->FilterCondition.SpecialFieldName);
	conf.Set(us+"Condition.RegExp",f->FilterCondition.RegExp.GetRegEx());
	conf.Set(us+"Condition.IsCase",f->FilterCondition.RegExp.IsCase());
	conf.Set(us+"Actions.Action",(int)f->Actions);
	conf.Set(us+"Actions.ActionCopyPath",f->ActionCopyPath);
	conf.Set(us+"Actions.ActionReplyPath",f->ActionReplyPath);
	conf.Set(us+"Actions.ActionForwardAddress",f->ActionForwardAddress);
    }

    if (conf.Write(name))
	return ERROR_SAVE;
  
    return OK;
}

