/*
$Header: /export/CVS/UMT/libsrc/folder/umtInternetAddr.cc,v 1.1 1996/10/22 19:47:27 lord Exp $
    
$Log: umtInternetAddr.cc,v $
Revision 1.1  1996/10/22 19:47:27  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:46  vlad
Puting to CVS. Version 1.00B3

Revision 2.0  1996/03/18  16:41:25  sebast
Revision 2.0

Revision 1.21  1996/02/15  14:40:52  sebast
some functions to work with fido and compuserve added

Revision 1.20  1996/01/26  18:52:08  vlad
Output real name to fields is corrected.

Revision 1.19  1995/09/18  14:52:41  sebast
small cosmetic change

Revision 1.18  1995/08/31  11:45:06  lord
make addr and real_name not pointers

Revision 1.17  1995/08/24  13:26:23  voloh
umtString::String() -> umtString::Str().

Revision 1.16  1995/07/31  18:00:54  sebast
UMT code rules

Revision 1.15  1995/07/27  17:30:12  lord
make set_* return error_usage

Revision 1.14  1995/07/27  17:28:56  lord
make empty functions finish with {} not ;

Revision 1.13  1995/07/21  16:35:13  sebast
some changes in GetAddrAndName() functions

Revision 1.12  1995/06/22  12:17:10  sebast
call of member()

Revision 1.11  1995/06/13  14:06:08  sebast
getRTFAddrAndName() added

Revision 1.10  1995/06/11  15:54:20  sebast
getAddrAndName() changed

Revision 1.9  1995/04/26  11:38:24  sebast
uses *.h++ instead *.h

Revision 1.8  1995/03/18  14:10:09  sebast
changed to use umtString

Revision 1.7  1995/03/09  17:08:28  sebast
tested

Revision 1.6  1995/02/19  21:46:36  sebast
ReadFromFile and WriteFromFile added an written.

Revision 1.5  95/02/19  19:05:57  19:05:57  sebast (Sebastian Kamyshenko)
WriteTo... and ReadFromFile() implemented

Revision 1.4  95/02/13  20:21:35  20:21:35  lord (Vadim Zaliva)
get addr_and_name reimplemented


Revision 1.3  95/02/12  15:48:11  15:48:11  sebast (Sebastian Kamyshenko)
changed return valusees from INT to ENUM STATUS

Revision 1.2  95/02/10  21:47:15  21:47:15  lord (Vadim Zaliva)
some methods implemented

Revision 1.1  95/02/10  20:41:58  20:41:58  lord (Vadim Zaliva)
Initial revision
*/

#include <string.h>
#include "misc.h++"
#include "umtInternetAddr.h++"

umtInternetAddr::umtInternetAddr(umtString *a,umtString *n) :
    umtMember(CLASS_INTERNET_ADDR)
{
  if (a) addr      = *a;
  if (n) real_name = *n;
}

umtInternetAddr::umtInternetAddr(umtInternetAddr *p) :
    umtMember(CLASS_INTERNET_ADDR)
{
  if(p) 
    {
      if (p->addr)      addr=p->addr;
      if (p->real_name) real_name=p->real_name;
    }
}

umtInternetAddr::umtInternetAddr(const umtInternetAddr &p) :
    umtMember(CLASS_INTERNET_ADDR)
{
    addr=p.addr;
    real_name=p.real_name;
}

umtInternetAddr::~umtInternetAddr()
{
}

umtInternetAddr& umtInternetAddr::operator =(const umtInternetAddr &p)
{
    addr      = p.addr;
    real_name = p.real_name;
    return *this;
}

umtString umtInternetAddr::GetAddr()
{
  return addr;
}

umtString umtInternetAddr::GetName()
{
  return real_name;
}

/* return addr and name in form sutable for From: field. */
umtString umtInternetAddr::GetAddrAndName()
{
  umtString us;
  int i;
  
  if (addr.IsEmpty())
  {
      us="";
  }
  else
  {
      if (real_name.IsEmpty())
	  us=addr;
      else
      {
	  if ( strpbrk( real_name.Str(), "<>,;\\\"[].:@" ))
	  {
	      us = "\"";
	      for ( i = 0; real_name[i]; i++ )
	      {
		  if ( strchr( "\"\\", real_name[i] ))
		      us += '\\';
		  us += real_name[i];
	      }
	      us += '"';
	  }
	  else
	      us = real_name;
	  us+=" <";
	  us+=addr;
	  us+=">";
      }
      
  }
  return us;
}

/* return addr and name in form sutable for Voloh' RTFViewer */
umtString umtInternetAddr::GetRTFAddrAndName()
{
  umtString s;
  
  if (addr.IsEmpty())
  {
      s="";
  }
  else
  {
      if (real_name.IsEmpty())
	  s=addr;
      else
      {
	  s=real_name;
	  s+=" <<";
	  s+=addr;
	  s+=">";
      }
      
  }
  return s;
}

/* set ADDR field */
void umtInternetAddr::SetInternetAddr(umtString *a)
{
    addr=*a;
}

/* Set real name field */
void umtInternetAddr::SetRealName(umtString *a)
{
    real_name=*a;
}

status umtInternetAddr::CheckFidoAddr(const umtString *source)
{
    int zone, net, node, point, rc;
    if (!source)
	return NO_VARIABLE_DEFINED;
    rc=sscanf(source->Str(),"%d:%d/%d.%d",&zone,&net,&node,&point);
    if (rc<3) {
	return ERROR_IN_CALLED_FUNCTION;
    }
    return OK; 
}
status umtInternetAddr::SetFidonetAddr(const umtString *s_a, const umtString *s_n)
{
    int       zone, net, node, point, rc;
    umtString name;
    if (!s_a)
	return NO_VARIABLE_DEFINED;
    if (s_n && !s_n->IsEmpty())
	name = s_n;
    else if (!real_name.IsEmpty())
	name = real_name;
    else
	name = "root";
    
    rc=sscanf(s_a->Str(),"%d:%d/%d.%d",&zone,&net,&node,&point);
    if (rc<3) {
	return ERROR_IN_CALLED_FUNCTION;
    }
    
    if (point)
	addr.Sprintf("\"%s\"@p%d.f%d.n%d.z%d.fidonet.org",name.Str(),point,node,net,zone);
    else
	addr.Sprintf("%s@f%d.n%d.z%d.fidonet.org",name.Str(),node,net,zone);

    return OK;
}

status umtInternetAddr::CheckCompuserveAddr(const umtString *source)
{
    int one, two, rc;
    if (!source)
	return NO_VARIABLE_DEFINED;
    rc=sscanf(source->Str(),"%d,%d",&one,&two);
    if (rc!=2) {
	return ERROR_IN_CALLED_FUNCTION;
    }
    return OK;
}
status umtInternetAddr::SetCompuserveAddr(const umtString *source)
{
    int one, two, rc;
    if (!source)
	return NO_VARIABLE_DEFINED;
    rc=sscanf(source->Str(),"%d,%d",&one,&two);
    if (rc!=2) {
	return ERROR_IN_CALLED_FUNCTION;
    }
    
    addr.Sprintf("%d.%d@compuserve.com",one,two);

    return OK;
}



