/*
 * $Header: /export/CVS/UMT/libsrc/folder/umtMailbox.cc,v 1.1 1996/10/22 19:47:28 lord Exp $
 * $Log: umtMailbox.cc,v $
 * Revision 1.1  1996/10/22 19:47:28  lord
 * Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 * Some platform directories created in lib.
 * Makefile.include for SUN created.
 *
 * Revision 1.1.1.1  1996/10/21 20:46:47  vlad
 * Puting to CVS. Version 1.00B3
 *
// Revision 2.0  1996/03/18  16:41:27  sebast
// Revision 2.0
//
// Revision 1.2  1995/10/07  18:08:11  sebast
// some debug info removed
//
// Revision 1.1  1995/09/26  18:47:12  vlad
// Initial revision
//
// Revision 1.4  1995/09/26  17:35:48  vlad
// Work version.
//
// Revision 1.3  1995/09/23  17:41:01  vlad
// Some changed.
//
// Revision 1.2  1995/09/23  15:15:43  vlad
// Nothing.
//
// Revision 1.1  1995/09/23  15:10:44  vlad
// Initial revision
//
 *
 */

#include "umtMailbox.h++"
#include "umtSlist.h++"


umtMsgInfo::umtMsgInfo( int n, int s, const umtString& id )
    : umtMember()
    
{
    Number = n;
    Size   = s;
    MsgID  = id;
    IsErase = 0;
}

umtMsgInfo::umtMsgInfo( umtMsgInfo *msg )
{
    if ( msg )
    {
	Number = msg->Number;
	Size   = msg->Size;
	MsgID  = msg->MsgID;
	IsErase = msg->IsErase;
    }
    else
    {
	IsErase = Number = 0;
	Size = 0;
	MsgID  = "";
    }
}


umtMsgInfo::~umtMsgInfo()
{
}


umtMailbox::umtMailbox(): umtSlist()
{
    Rc = OK;
}


umtMailbox::~umtMailbox()
{
    Kill( NULL );
}


umtMsgInfo *umtMailbox::GetFirst()
{
    return (umtMsgInfo *)umtSlist::GetFirst();
}


umtMsgInfo *umtMailbox::GetLast()
{
    return (umtMsgInfo *)umtSlist::GetLast();
}


umtMsgInfo *umtMailbox::GetNext( umtMsgInfo *msg )
{
    return (umtMsgInfo *)umtSlist::GetNext( msg );
}


umtMsgInfo *umtMailbox::GetPrev( umtMsgInfo *msg )
{
    return (umtMsgInfo *)umtSlist::GetPrev( msg );
}


umtMsgInfo *umtMailbox::Find( int n )
{
    umtMsgInfo *msg;
    for ( msg = GetFirst(); msg; msg = GetNext( msg ))
	if ( msg->Number == n ) break;
    return msg;
}


umtMsgInfo *umtMailbox::Find( const umtString& id )
{
    umtMsgInfo *msg;
    for ( msg = GetFirst(); msg; msg = GetNext( msg ))
	if ( msg->MsgID == id ) break;
    return msg;
}


status      umtMailbox::Erase( int n )
{
    umtMsgInfo *msg;
    
    msg = Find( n );
    if ( msg )
    {
	msg->IsErase = 1;
	return OK;
    }
    return NOT_FOUND;
}


status      umtMailbox::UnErase( int n )
{
    umtMsgInfo *msg;
    
    msg = Find( n );
    if ( msg )
    {
	msg->IsErase = 0;
	return OK;
    }
    return NOT_FOUND;
}


status     umtMailbox::Status( void )
{
    return Rc;
}


long       umtMailbox::GetMailboxSize( void )
{
    long       size = 0;
    umtMsgInfo *msg;

    for ( msg = GetFirst(); msg; msg = GetNext( msg ))
	size += msg->Size;
    return size;
}











