/*
// $Header: /export/CVS/UMT/libsrc/folder/umtMailcap.cc,v 1.1 1996/10/22 19:47:29 lord Exp $
// $Log: umtMailcap.cc,v $
// Revision 1.1  1996/10/22 19:47:29  lord
// Due to stupidity of SUN CC, all .c++ files renamed to .cc.
// Some platform directories created in lib.
// Makefile.include for SUN created.
//
// Revision 1.1.1.1  1996/10/21 20:46:46  vlad
// Puting to CVS. Version 1.00B3
//
// Revision 2.0  1996/03/18  16:41:28  sebast
// Revision 2.0
//
// Revision 1.15  1996/02/02  15:25:06  vlad
// Processing "nametemplate" option is commented.
//
// Revision 1.14  1995/11/17  12:24:11  vlad
// Redone for UMTError using.
//
// Revision 1.13  1995/10/27  11:38:21  sebast
// using UMTError added
//
// Revision 1.12  1995/09/20  16:48:38  vlad
// Changed path processing.
//
// Revision 1.11  1995/08/27  15:08:46  lord
// Some debugging done
//
// Revision 1.10  1995/08/25  13:16:37  lord
// Add Free()
//
// Revision 1.9  1995/08/23  16:52:40  lord
// warnings removed
//
// Revision 1.8  1995/08/21  13:42:51  lord
// Do not check return value of umtConfiguration:Append since it's void now.
//
// Revision 1.7  1995/08/04  12:47:52  sebast
// umtCodingRules
//
// Revision 1.6  1995/08/03  17:12:49  sebast
// work with umtCodingRules started
//
// Revision 1.5  1995/06/22  11:17:15  sebast
// call of member() in constructor added
//
// Revision 1.4  1995/06/12  16:51:02  vlad
// Removed debug printing
//
// Revision 1.3  1995/06/12  11:56:36  vlad
// cfg.kill(0) in Mailcap::InitialRead() added.
//
// Revision 1.2  1995/06/12  11:34:39  sebast
// ViewMessage( msg_component& message ) implemented
//
//
*/

#include <stdio.h>
#include <strings.h>
#include <ctype.h>
#include <errno.h>
#include <stdlib.h>
#include "misc.h++"
#include "umt_error.h++"

#include "UMT.h++"
#include "umtString.h++"
#include "umtPath.h++"
#include "umtMsgComponent.h++"
#include "umtMailcap.h++"

//#define MAILCAP_DEBUG_WRITE "/tmp/.UMT.Mailcap.Test"

umtMailcap::umtMailcap() : umtConfiguration()
{
}


umtMailcap::umtMailcap( const umtPath& filename ) : umtConfiguration()
{
    ReadMailcap( filename );
}


umtMailcap::~umtMailcap()
{
#ifdef MAILCAP_DEBUG_WRITE
    WriteMailcap( MAILCAP_DEBUG_WRITE );
#endif
    Free();
}


void  umtMailcap::Free()
{
    Kill(0);
}

status  umtMailcap::InitialRead()
{
    umtPath     path;
    int         i = 0;
    status      st = NOT_FOUND;
    
    Free();
    while (1)
    {
	path = UMTConfig.GetStrField( umtString( MAILCAP_GROUP
						 "."
						 MAILCAP_FILES ), i++);
	if ( path.IsEmpty()) break;
	if ( path.Normalize() == OK )
	    if (ReadMailcap( path ) == OK ) st = OK;
    }
    if ( st != OK ) {
	char ds[200];
	sprintf(ds,"umtMailcap:No one umtMailcap file loaded.");
	UMTError->Msg(umtError::Error,ds);
    }
    return st;
}



status  umtMailcap::ReadMailcap( const umtPath& filename )
{
    FILE              *umtMailcap_file;
    int               i = 0, n;
    char             *str;
    umtString         string, field;
    char              buffer[MAX_STR_SIZE];
    char              num_str[5];
    umtConfiguration *tmp_cfg;

//    string.Sprintf( "Mailcap: reading mailcap file %s",filename.Str());
//   UMTError->Msg( umtError::Info, string );
    umtMailcap_file = fopen( filename.Str(), "r" );
    if ( umtMailcap_file == NULL )
    {
//	string.Sprintf( "Mailcap: Can't open file %s", filename.Str());
//	UMTError->Msg( umtError::Error, string );
	return ERROR_OPEN_FILE;
    }
    while ( !feof( umtMailcap_file ) && !ferror( umtMailcap_file ))
    {
	if ( fgets( buffer + i, MAX_STR_SIZE - i, umtMailcap_file ) != NULL )
	    i = strlen( buffer );
	else continue;
	if ( i && buffer[i-1] != '\n' )
	{
	    fclose( umtMailcap_file );
	    return UNDEFINED_VALUE;
	}
	if ( i > 1 && buffer[i-2] == '\\' )
	{
	    i-=2;
	    continue;
	}
	for ( str = buffer;
	     isspace( *str ) && *str != '\0';
	     str++ );
	if ( *str == '#' || *str == '\0' )
	{
	    i = 0;
	    continue;
	}
	buffer[i-1] = '\0';
//	fprintf( stderr,"%s\n", buffer );
	str = buffer;
	tmp_cfg = NULL;
	for ( i = 0; *str; i++ )
	{
	    parsing_string( &str, string );
	    if ( i == 0 )
	    {
//		fprintf(stderr,"Name: %s\n",string.Str());
		field = string;
		continue;
	    }
	    else if ( tmp_cfg == NULL )
	    {
		tmp_cfg = GetConfiguration( field );
		if ( tmp_cfg == NULL )
		{
		    tmp_cfg = new umtConfiguration( field );
		    if ( tmp_cfg ) Append((umtMember *) tmp_cfg );
		    else
		    {
			fclose( umtMailcap_file );
			UMTError->Msg(umtError::Error,
				      "umtMailcap: Can't allocate memory "
				      "for umtConfiguration"
			);
			return NOT_ENOUGH_MEMORY;
		    }
		}
		n = 0;
		while (1) /* Count how many methods for this type/subtype */
		{
		    sprintf( num_str, "%d", n );
		    if ( !( tmp_cfg->
			    GetStrField( umtString( num_str ))).IsEmpty())
		    {
			n++;
			continue;
		    }
		    break;
		}
	    }
	    tmp_cfg->Set( umtString( num_str ), string, i - 1 );
//	    fprintf(stderr,"Val %d: %s\n",i,string.Str());
	}
	i = 0;
    }
    fclose( umtMailcap_file );
    return OK;
}

status  umtMailcap::WriteMailcap( const umtPath& filename )
{
    return Write( filename );
}

umtString umtMailcap::ViewMessage   ( umtMsgComponent& message )
{
    return ViewMessage(*message.ThePath,&message.ContentField);
}

umtString umtMailcap::EditMessage   ( umtMsgComponent &/* message*/ )
{
    return "";
}

umtString umtMailcap::PrintMessage  ( umtMsgComponent& /*message*/ )
{
    return "";
}

umtString umtMailcap::ComposeMessage( umtMsgComponent& /*message*/ )
{
    return "";
}

umtString umtMailcap::ViewMessage( umtString file, umtContentStruct *cnt )
{
    umtConfiguration *type_subtype;
    int            n = 0;
    char           num_str[10];
    umtString      field, view_command, command;
    
    type_subtype = find_type_subtype( cnt->SContentType,
				      cnt->SContentSubtype );
    if ( type_subtype == NULL ) return "";
    while ( 1 )
    {
	sprintf( num_str, "%d", n++ );
	field = find_subfield( type_subtype,
			       umtString( num_str ),
			       umtString( "test" ));
	if ( field.IsEmpty()) break;
	else  
	{
	    command = make_command(( char *)field,( char *)file, cnt );
	    if ( !command.IsEmpty())
		if  ( !system(( char *)command )) break;
	}
    }
    
//    field = find_subfield( type_subtype, num_str, "nametemplate" );
//    if ( !field.isempty())
//	file = make_command(( char *)field,( char *)file, cnt );
    
    view_command = make_command(( char *)(type_subtype->
					  GetStrField(umtString( num_str ))),
				( char *)file,
				cnt );
    if ( view_command.IsEmpty())
	return "";
    if ( !find_subfield( type_subtype, num_str, "needsterminal" ).IsEmpty())
    {
/*    'needsterminal' is present */	
	field = UMTConfig.GetStrField( umtString( MAILCAP_GROUP
						  "."
						  MAILCAP_TERMINAL ));
	if ( field.IsEmpty())
	    field = DEFAULT_XTERM " " DEFAULT_XTERM_FLAGS;
	else 
	{
	    field += ' ';
	    field +=
		UMTConfig.GetStrField( umtString( MAILCAP_GROUP
						  "."
						  MAILCAP_TERMINAL_FLAGS));
	}
	command = make_command(( char *)field, ( char *)view_command, cnt );
    }
    else 
	command = view_command;
    return command;
}


umtString umtMailcap::EditMessage   ( umtString/* file*/, umtContentStruct */*cnt*/ )
{
    return "";
}


umtString umtMailcap::PrintMessage  ( umtString /*file*/, umtContentStruct */*cnt*/ )
{
    return "";
}


umtString umtMailcap::ComposeMessage( umtString /*file*/, umtContentStruct */*cnt*/ )
{
    return "";
}

    
umtConfiguration* umtMailcap::find_type_subtype( umtString type, umtString subtype )
{
    umtConfiguration *tmp_cfg;
    umtString      work;
    
    work  = type;
    work += '/';
    work += subtype;
    work.ToLower();
    tmp_cfg = GetConfiguration(work);
    if ( tmp_cfg == NULL ) 
    {
	work  = type;
	work += "/*";
	work.ToLower();
	tmp_cfg = GetConfiguration( work );	
    }
    return tmp_cfg;
}


umtString umtMailcap::find_subfield( umtConfiguration *type_subtype,
				     umtString field,
				     umtString subfield )
{
    int       i;
    umtString tmp;
    char      *value;
    
    for ( i = 0;
	 tmp = type_subtype->GetStrField( field, i ), !tmp.IsEmpty();
	 i++ )
    {
	tmp.ToLower();
	if ( tmp.SubStr( 0, subfield.Length()) == subfield )
	{
	    tmp = type_subtype->GetStrField( field, i );
	    value = ( char *)tmp;
	    value = strchr( value, '=' );
	    if ( value == NULL )
		return umtString( " " );
	    while ( isspace( *++value ));
	    return umtString( value );
	}
    }
    return umtString( "" );
}


void  umtMailcap::parsing_string( char **str, umtString &string )
{
    string = "";
// Skiping spaces in the begin of string
    while ( isspace( **str )) (*str)++;
    while ( **str != ';' )
    {	
	switch ( **str )
	{
	case  '\0': return ;
	case  '\\':
	    string += '\\';
	    (*str)++;
	}
	string += **str;
	(*str)++;
    }
// Skiping spaces in the end of string
    while ( string.Length() &&
	    isspace( string[ string.Length() - 1]))
	string.SetToLeft( string.Length() - 1);	    
// Skiping ';'
    (*str)++;
}


umtString  umtMailcap::make_command( char *format,
				     char *filename,
				     umtContentStruct *cnt )
{
    char *tmp, *tmp2;
    umtString command;
    umtString cont_field;
    int i;
    
    while (( tmp = strchr( format, '%' )) != NULL )
    {
	if ( tmp != format && tmp[-1] == '\\' )
	{
	    cont_field = format;
	    cont_field.SetToSubstr( 0, int ( tmp - format ) - 1 );
	    command += cont_field;
	    command += '%';
	    tmp -= 1;
	}
	else
	{
	    cont_field = format;
	    cont_field.SetToSubstr( 0, int ( tmp - format )); 
	    command += cont_field;
	    switch ( tmp[1] )
	    {
	    case 's' :
		command += filename;
		break;
	    case 't' :
		command += cnt->SContentType;
		command += '/';
		command += cnt->SContentSubtype;
		break;
	    case '{' :
		tmp2 = strchr( tmp, '}' );
		if ( tmp2 != NULL )
		{
		    cont_field = tmp;
		    cont_field.SetToSubstr( 2, int ( tmp2 - tmp ) - 2 );
		}
		else  return umtString( "" );
		if ( cont_field.CaseInsensitiveEqual( "boundary" ))
		    command += cnt->BoundaryString;
		else  if ( cont_field.CaseInsensitiveEqual( "name" ))
		    command += cnt->Name;
		else  if ( cont_field.CaseInsensitiveEqual( "charset" ))
		    command += cnt->CharSet;
		else 
		    return umtString( "" );
		tmp = tmp2 - 1;
		break;
	    default: return umtString( "" );
	    }
	}
	format = tmp + 2;
    }
    command += format;
    
// Skipping backslashes . 
    for ( i = 0; command[i]; i++ )
    {
	if ( command[i] == '\\' )
	{
	    cont_field = command.SubStr( i + 1, -1 );
	    command.SetToSubstr( 0, i );
	    command += cont_field;
	    if ( !++i ) break;
	}
    }
    return command;
}


status         run_command      ( umtString /*command*/ )
{    
    return OK;
}

