/*
$Header: /export/CVS/UMT/libsrc/folder/umtPop3.cc,v 1.1 1996/10/22 19:47:31 lord Exp $

$Log: umtPop3.cc,v $
Revision 1.1  1996/10/22 19:47:31  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:47  vlad
Puting to CVS. Version 1.00B3

Revision 2.0  1996/03/18  16:41:40  sebast
Revision 2.0

Revision 1.23  1996/02/20  17:21:10  vlad
History new work scheme realised.

Revision 1.22  1995/09/13  18:07:24  vlad
Send(), Recv are set virtual.

Revision 1.20  1995/08/25  08:21:51  lord
Add const to constructor

Revision 1.19  1995/08/23  16:42:12  lord
remove few warnigns

Revision 1.18  1995/08/01  14:29:32  sebast
UMT coding rules

Revision 1.17  1995/07/28  14:41:12  sebast
using word "virtual" in destructor implementation removed

Revision 1.16  1995/07/09  23:17:54  lord
Return OK if UIDL not supported

Revision 1.15  1995/06/22  12:27:55  sebast
call of member() changed

Revision 1.14  1995/06/11  10:31:49  lord
Checking for dot at the beginning of the response line

Revision 1.13  1995/06/04  14:40:05  lord
UIDL managment done.

Revision 1.12  1995/06/04  11:52:03  lord
Debuuging stuff removed

Revision 1.11  1995/06/02  18:34:30  lord
Some debugging printfs

Revision 1.10  1995/04/26  11:35:29  sebast
uses *.h++ instead *.h

Revision 1.9  1995/03/11  14:52:50  sebast
pop3_msg_info::pop3_msg_info(pop3_msg_info *p) added

Revision 1.8  1995/03/04  16:07:21  lord
Remove all \d at eol

Revision 1.7  95/03/04  15:14:48  15:14:48  lord (Vadim Zaliva)
bug in getMessage fixed

Revision 1.6  95/02/17  21:55:59  21:55:59  lord (Vadim Zaliva)
getMessage implemented

Revision 1.5  95/02/17  21:12:26  21:12:26  lord (Vadim Zaliva)
isMessageDeleted added

Revision 1.4  95/02/17  21:07:13  21:07:13  lord (Vadim Zaliva)
getMessageSize implemented

Revision 1.3  95/02/17  20:54:50  20:54:50  lord (Vadim Zaliva)
find_message added

Revision 1.2  95/02/17  20:45:43  20:45:43  lord (Vadim Zaliva)
It works! Some parts still missing

Revision 1.1  95/02/16  18:55:13  18:55:13  lord (Vadim Zaliva)
Initial revision

*/

//                    Post Office Protocol - Version 3
//                            RFC 1725

//#define POP3_DEBUG 1

#include <stdio.h>
#include <string.h>

#include "misc.h++"

#include "umtPop3.h++"
#include "UMT.h++"

//---------------------------------------------
// Class pop3_msg_info
//---------------------------------------------

umtPop3::umtPop3(const char *server, const char *service,const char *user, const char *passwd)
    :umtSockClient(server,service), umtSlist()
{
    char tmpb[256];

    uidl_yes=0;
    if((Rc=get_pop_rsp())!=OK) return; // Server not ready
  
//   The UMTPOP3 session is now in the AUTHORIZATION state.

    sprintf(tmpb,"USER %s",user);
    if(issue_cmd_and_get_result(tmpb)!=OK) return;

    sprintf(tmpb,"PASS %s",passwd);
    if(issue_cmd_and_get_result(tmpb)!=OK) return;

//  The TRANSACTION State

    get_messages_list();
}

umtPop3::~umtPop3()
{
    issue_cmd_and_get_result("QUIT");
    Kill(NULL);
}

umtPop3MsgInfo *umtPop3::GetFirst()
{
    return (umtPop3MsgInfo *) umtSlist::GetFirst();
}

umtPop3MsgInfo *umtPop3::GetLast()
{
    return (umtPop3MsgInfo *) umtSlist::GetLast();
}

umtPop3MsgInfo *umtPop3::GetPrev(umtPop3MsgInfo *p)
{
    return (umtPop3MsgInfo *) umtSlist::GetPrev(p);
}

umtPop3MsgInfo *umtPop3::GetNext(umtPop3MsgInfo *p)
{
    return (umtPop3MsgInfo *) umtSlist::GetNext(p);
}

status umtPop3::get_messages_list()
{
    int messages_number = 0;
    int n = 0;
    int size = 0;
    umtPop3MsgInfo *x;
    char tmp[POP3_RSPBUF_SIZE];
    enum { UIDL, TOP, XTND_XLST, NO_WAY } what_way = NO_WAY;
    const char *format_str = ""; // to scan message identifier

    if (issue_cmd_and_get_result("STAT")!=OK) return Rc;
    sscanf(rspbuf,"+OK %d %d",&messages_number, &mboxsize);
    if ( !messages_number ) return OK;
    if (issue_cmd_and_get_result("LIST")!=OK) return Rc;
  
    while ( ReadLn(rspbuf,sizeof( rspbuf )))
    {
	if( *rspbuf == '.' ) break;
	sscanf( rspbuf,"%d %d", &n, &size );
	x = new umtPop3MsgInfo( n, size );
	if ( x ) Append( x );
	else UMTError->Msg( umtError::Error,
	    "UMTPOP3:Can't create UMTPOP3_MSG_INFO object!"
	);
    }
    
// Try to get UIDL's
    if ( issue_cmd_and_get_result("UIDL") == OK )
    {
   	what_way = UIDL;
	format_str = "%d %s";
    }
    else 
    {
// Try to get Message-Id using XTND XLST command
	if (
	    Rc == POP3ERROR &&
	    issue_cmd_and_get_result("XTND XLST Message-Id") == OK
	)
	{
	    format_str = "%d%*[^<]<%[^>]>";
	    what_way = XTND_XLST;
	}
	else
// Try to get Message-Id using TOP command	    
	    if ( Rc == POP3ERROR && issue_cmd_and_get_result("TOP 1 1") == OK)
		what_way = TOP;
    }
    if ( Rc != OK && Rc != POP3ERROR )
	return Rc; // Socket error, or somthing of the kind.
    uidl_yes = 1;
    switch ( what_way )
    {
    case XTND_XLST :
    case UIDL :
	while ( ReadLn(rspbuf,sizeof(rspbuf)))
	{
	    if ( *rspbuf == '.' ) break;
	    if ( sscanf( rspbuf, format_str, &n, tmp ) == 2 )
	    {
		x = FindMessage( n - 1 );
		if ( x )
		{
		    if( x->UIDL ) Delete( x->UIDL );
		    x->UIDL = ustrdup( tmp );
		}
		else 
		{
		    UMTError->Msg(
			umtError::Error,
			    "UMTPOP3:Can't find message %d to set UIDL\n",
			    n
		    );
		}
	    }
	    else 
	    {
		UMTError->Msg(
		    umtError::Error,
			"UMTPOP3:Can't parse UIDL list output: %s\n",
			tmp
		);
	    }
	}  
	break;
    case TOP  :
	n = 1;
	while (1)
	{
	    while ( Rc == OK && ReadLn( rspbuf, sizeof(rspbuf)))
	    {
		if (*rspbuf=='.') break;
		if (!strncasecmp( "Message-Id", rspbuf, 10 ))
		{
		    if (
			sscanf(
			    rspbuf + 10/*length "Message-Id" string*/,
			    "%*[^<]<%[^>]>",
			    tmp
			) != 1
		    )
		    {
		        *tmp = '\0';
			UMTError->Msg(
			    umtError::Error,	
				"Can't parse Message-Id field\n\t'%s'",
				rspbuf);
		    }
		    x = FindMessage( n - 1 );
		    if ( x )
		    {
			if (x->UIDL) Delete(x->UIDL);
			x->UIDL=ustrdup(tmp);
		    }
		    else 
			UMTError->Msg(
			    umtError::Error,	
				"POP3:Can't find message %d to set UIDL\n",
				n);
		}
	    }
	    if ( ++n > messages_number ) break;
	    sprintf( tmp, "TOP %d 1", n );
	    if ( issue_cmd_and_get_result(tmp) != OK && Rc != POP3ERROR )
		return Rc;
	}
    default: uidl_yes = 0; 
	break;
    }
    return OK;
}

status umtPop3::IsServerAlive()
{
    return issue_cmd_and_get_result("NOOP");
}

int    umtPop3::GetNumberOfMessages()
{
    return(GetCount());
}

int    umtPop3::GetSizeOfMailbox()
{
    return mboxsize;
}

int    umtPop3::GetMessageSize(int m)
{
    umtPop3MsgInfo *x;

    if ((x=FindMessage(m))!=NULL)
	if(x->IsDeleted==0)
	    return x->Size;

    return 0;
}

status umtPop3::DeleteMessage(int n)
{
    umtPop3MsgInfo *x;
    char tmpb[80];

    if((x=FindMessage(n))!=NULL)
	if(x->IsDeleted==0)
	{
	    x->IsDeleted=1;
	    sprintf(tmpb,"DELE %d",n+1);
	    return issue_cmd_and_get_result(tmpb);
	}
    
    return NOT_FOUND;
}

int    umtPop3::IsMessageDeleted(int n)
{
    umtPop3MsgInfo *x;
  
    if ((x=FindMessage(n))!=NULL)
	return x->IsDeleted;
    else 
	return 1;
}


status umtPop3::UndeleteAllMessages()
{
    umtPop3MsgInfo *i;
  
    if (issue_cmd_and_get_result("RSET")!=OK) return Rc;
    for (i=GetFirst();i;i=GetNext(i))
	if(i->IsDeleted) i->IsDeleted=0;
    return OK;
}


char   *umtPop3::GetMessage(int n)
{
    char *buf;
    char *buf1;
    char *d;
    char tmpb[80];
    char *s;
    int  size;
    int  csize;
    char *x;
  
 
    if (IsMessageDeleted(n)) return NULL;

    sprintf(tmpb,"RETR %d",n+1);
    if (issue_cmd_and_get_result(tmpb)!=OK) return NULL;

    if((buf=new char[csize=size=GetMessageSize(n)])==NULL) return NULL;
    *(d=buf)='\0';
  
    while(ReadLn(rspbuf,sizeof(rspbuf)))
    {

	x=strchr(rspbuf,'\0');
	if(*(x-1)=='\n' && *(x-2)=='\r') 
	{
	    *(x-2)='\n';
	    *(x-1)='\0';
	}

	if(*rspbuf=='.') 
	{
	    if(*(rspbuf+1)=='\n') break;
	    s=rspbuf+1;
	} else {
	    s=rspbuf;
	}
	while(*s && size) 
	{
	    *d++=*s++;
	    size--;
	  
	    if(size==0) 
	    {
		if((buf1=new char[csize+MSG_BUF_INCREMENT])==NULL) 
		{
		    Delete(buf);
		    return NULL;
		}
		memcpy(buf1,buf,csize);
		Delete(buf);
		buf=buf1;
		d=buf+csize;
		csize=csize+(size=MSG_BUF_INCREMENT);
	    }
	} /* while */
    } /* while */
    *d='\0';
    return buf;
}


char * umtPop3::GetMessageHead(int ,int )
{
    return NULL;
}


status umtPop3::issue_cmd(char *cmd)
{
    strcpy(cmdbuf,cmd);
    strcat(cmdbuf,"\r\n");
    if (Send(cmdbuf,strlen(cmdbuf))==-1)
	Rc=SOCKET_ERROR;
    else 
	Rc=OK;
    return Rc;
}

status umtPop3::get_pop_rsp()
{
    if(ReadLn(rspbuf,sizeof(rspbuf))==NULL) return (Rc=SOCKET_ERROR);
    if(strncmp(rspbuf,"+OK",3)==SAME) return (Rc=OK);
    if(strncmp(rspbuf,"-ERR",4)==SAME) return (Rc=POP3ERROR);
    return SOCKET_ERROR; //?
}

char *umtPop3::GetMessageUIDL(int m)
{
    char tmpb[80];
    char *s;

    if(IsMessageDeleted(m)) return NULL;
  
    sprintf(tmpb,"UIDL %d",m+1);
    if(issue_cmd_and_get_result(tmpb)!=OK) return NULL;

    s=rspbuf+4;
    while (*s!=' ') s++;
    return(s+1);
}

//---------------------------------------------
// Class umtPop3_msg_info
//---------------------------------------------

umtPop3MsgInfo::umtPop3MsgInfo(int me, int nn) : umtMember(CLASS_POP3_MSG_INFO)
{
    N=me;
    Size=nn;
    IsDeleted=0;
    UIDL=nil;
}

umtPop3MsgInfo::umtPop3MsgInfo(umtPop3MsgInfo *p) : umtMember(CLASS_POP3_MSG_INFO)
{
    N = p->N;
    Size = p->Size;
    IsDeleted = p->IsDeleted;
    if(p->UIDL) UIDL=ustrdup(p->UIDL);
}

umtPop3MsgInfo::~umtPop3MsgInfo()
{
    if(UIDL) Delete(UIDL);
}

status umtPop3::issue_cmd_and_get_result(char *cmd)
{
#ifdef UMTPOP3_DEBUG
    UMTError->Msg(umtError::Error,"UMTPOP3: CMD=%s\n",cmd);
#endif
    if((Rc=issue_cmd(cmd))!=OK) return Rc;
    Rc=get_pop_rsp();
#ifdef UMTPOP3_DEBUG
    UMTError->Msg(umtError::Error,"UMTPOP3: RSP=%s\n",rspbuf);
#endif
    return Rc;
}

umtPop3MsgInfo *umtPop3::FindMessage(int i)
{
    umtPop3MsgInfo *x;
  
    for(x=GetFirst();x;x=GetNext(x))
	if((x->N)==(i+1)) return x;
    
    return NULL;
}  




