/*
 * $Headed$
 * $Log: umtSMTPDeliverAgent.cc,v $
 * Revision 1.2  1996/10/22 21:41:18  lord
 * Alpha version for SUN done and works.
 * Still few warning to be eleminated and
 * file locking to be done.
 * file 'build_number' renamed to 'build_num'.
 *
 * Revision 1.1  1996/10/22 19:47:31  lord
 * Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 * Some platform directories created in lib.
 * Makefile.include for SUN created.
 *
 * Revision 1.1.1.1  1996/10/21 20:46:47  vlad
 * Puting to CVS. Version 1.00B3
 *
// Revision 2.1  1996/04/26  14:43:59  vlad
// If any recipient is unknown - return error.
//
// Revision 2.0  1996/03/18  16:41:41  sebast
// Revision 2.0
//
// Revision 1.13  1996/03/18  15:18:45  vlad
// *** empty log message ***
//
 * Revision 1.12  1996/03/01 18:35:16  vlad
 * Duplicate emptystrings in status umtSMTPDeliverAgent::Deliver( umtMsg* msg );
 *
 * Revision 1.11  1995/11/17 12:46:41  vlad
 * Redone to use UMTError.
 *
// Revision 1.10  1995/09/16  12:42:30  vlad
// Nothing
//
// Revision 1.9  1995/09/15  14:23:18  sebast
// small bug removed
//
// Revision 1.8  1995/09/15  13:52:48  vlad
// Method Deliver() changed a bit.
//
// Revision 1.7  1995/09/14  15:41:14  sebast
// small bug in Deliver() removed
//
// Revision 1.6  1995/09/14  14:07:26  vlad
// Method Send() removed,
// Method Deliver() modified.
//
// Revision 1.5  1995/09/13  17:45:52  vlad
// New edition.
//
// Revision 1.1  1995/09/13  16:42:40  vlad
// Initial revision
//
// Revision 1.1  1995/09/13  15:42:06  vlad
// Initial revision
//
 */


#include <stdlib.h>
#include <unistd.h>

#ifdef IRIX
# define _BSD_SIGNALS
#endif

#include <signal.h>
#include <sys/wait.h>
#include "UMT.h++"
#include "umtInternetAddr.h++"
#include "umtDeliver.h++"
#include "umtSockClient.h++"
#include "umtString.h++"
#include "umtSMTPDeliverAgent.h++"

#ifdef SUN
extern "C" { int  gethostname(char *, int); }
#endif

const char* umtSMTPDeliverAgent::SMTP_CRLF = "\r\n";

umtSMTPDeliverAgent::umtSMTPDeliverAgent( umtString host, umtString port ):
    umtDeliverAgent(), umtSockClient( host.Str(), port.Str()) 
{
    umtString       cmd;
    long            timeout;
    char            hostname[80];
    
    *rspbuf = '\0';
    if ( UMTConfig.GetLongField ( "SMTP.TimeOut", &timeout ) == OK )
	SetIOTimeOut( timeout, timeout );
    do 
	if ( get_smtp_rsp() != OK || smtp_rc != 220 )
	{
	    UMTError->Msg( umtError::Error, GetErrorMessage());
	    return;
	}
    while ( rspbuf[3] == '-' );
    if ( !gethostname( hostname, 80 ))
    {
	cmd  = "HELO ";
	cmd += hostname;
	issue_cmd_and_get_result( cmd );
    }
    return ;
}

umtSMTPDeliverAgent::~umtSMTPDeliverAgent()
{
    if ( issue_cmd_and_get_result( "QUIT" ) == OK )
    {
	if ( smtp_rc != 221 )
	    UMTError->Msg( umtError::Error, GetErrorMessage());
    }
}

status umtSMTPDeliverAgent::Deliver( umtMsg* msg )
{
    umtSlist        *addresses;
    umtInternetAddr *addr;
    umtString        cmd;
    FILE            *mtf;  
    int              i;
    char             strbuf[SMTP_MAX_STRING];       
    status           msg_rc;
    char            *tmp; 
    
    if ( !msg ) return NO_VARIABLE_DEFINED;
    ( void )issue_cmd_and_get_result( "RSET" );/* To reset previous
					        * transmission errors if any
				                */
    addresses = msg->GetFromField();
    if ( !addresses || addresses->GetCount() == 0 )
    {
	UMTError->Msg( umtError::Error, "SMTP: NO Sender.");
	return DELIVER_NO_RECEPIENTS;
    }
    cmd = "MAIL FROM:";
    cmd += (( umtInternetAddr* )( addresses->GetFirst()))->GetAddr();
    if ( issue_cmd_and_get_result( cmd ) != OK ) return SOCKET_ERROR;
    if ( smtp_rc != 250 && smtp_rc != 251 )
    {
	UMTError->Msg( umtError::Error, GetErrorMessage());
	return SMTP_ERROR;
    }
    for ( i = 0; i < 3; i++ )
    {
	switch ( i )
	{
	case 0 :
	    addresses = msg->GetToField();
	    break;
	case 1 :
	    addresses = msg->GetCCField();
	    break;
	case 2 :
	    addresses = msg->GetBCCField();
	}
	if ( addresses )
	{
	    for ( addr = ( umtInternetAddr* )addresses->GetFirst();
		 addr;
		 addr = ( umtInternetAddr* )addresses->GetNext( addr )
	    )
	    {
		cmd = "RCPT TO:";
		cmd += addr->GetAddr();
		if ( issue_cmd_and_get_result( cmd ) != OK )
		    return SOCKET_ERROR;
		if ( smtp_rc != 250 && smtp_rc != 251 )
		    return SMTP_ERROR;
	    }
	}
    }
    mtf = tmpfile();
    if ( mtf == nil ) return ERROR_OBTAINING_TMP_FILE;
    if (( msg_rc = msg->ExportMIME10( mtf )) != OK )
	return msg_rc;
    fseek( mtf, 0, SEEK_SET );   /* Data is prepared */
    if ( issue_cmd_and_get_result( "DATA" ) != OK ) return SOCKET_ERROR;
    if ( smtp_rc != 354 )
    {
	UMTError->Msg( umtError::Error, GetErrorMessage());
	( void )fclose( mtf );
	return SMTP_ERROR;
    }
    clearerr( mtf );
    while ( 1 )
    {
	cmd = "";
	while ( fgets( strbuf, sizeof( strbuf ), mtf ))
	{
	    cmd += strbuf;
	    if (( tmp = strchr( strbuf, '\n' )))
	    {
	        cmd.StripJunk();
		if ( cmd[0] == '\n' && cmd[0] == '\r' )
		    cmd = "";
		break;
	    }
	}
	if ( feof( mtf )) break;
	if ( ferror( mtf ))
	{
	    ( void )fclose( mtf );
	    return ERROR_LOAD;
	}
	if ( issue_cmd(( cmd == "." ) ? umtString("..") : cmd ) != OK )
	{
	    ( void )fclose( mtf );
	    return SOCKET_ERROR;
	}
    }
    ( void )fclose( mtf );
    if ( issue_cmd_and_get_result( "." ) != OK ) return SOCKET_ERROR;
    if ( smtp_rc != 250 )
    {
	UMTError->Msg( umtError::Error, GetErrorMessage());
	return SMTP_ERROR;
    }
    return OK;
}


umtString umtSMTPDeliverAgent::GetErrorMessage( void )
{
    umtString ErrMsg = umtString("SMTP: ") +
	umtString(( smtp_rc < 0 )? "Communication Error": rspbuf );
    ErrMsg.StripJunk();
    return ErrMsg;
}

status umtSMTPDeliverAgent::issue_cmd( umtString cmd )
{
    cmd += SMTP_CRLF;
    return ( umtSockClient::Send( cmd.Str(), cmd.Length()) == -1 )? SOCKET_ERROR: OK;
}

status umtSMTPDeliverAgent::get_smtp_rsp()
{
    if ( 
	( ReadLn( rspbuf, sizeof( rspbuf )) == NULL ) ||
	( sscanf( rspbuf, "%i", &smtp_rc ) != 1 )
    )
    {
 	smtp_rc = -1;
	return SOCKET_ERROR;
    }
    return OK;
}

status umtSMTPDeliverAgent::issue_cmd_and_get_result( umtString cmd )
{
    status rc;
#ifdef UMT_SMTP_DEBUG
    
    UMTError->Msg( umtError::Debug, umtString( "SMTP: CMD=" ) + cmd );
#endif
    if(( issue_cmd( cmd )) != OK ) return SOCKET_ERROR;
    rc = get_smtp_rsp();
#ifdef UMT_SMTP_DEBUG
    UMTError->Msg( umtError::Debug,
		   umtString( "SMTP: RSP=") + umtString( rspbuf ));
#endif
    return rc;
}




