/*
 * $Id: parsing.l,v 1.3 1997/08/20 02:01:58 lord Exp $
 * $Log: parsing.l,v $
 * Revision 1.3  1997/08/20 02:01:58  lord
 * Starting FreeBSD port
 *
 * Revision 1.2  1996/10/22 21:41:18  lord
 * Alpha version for SUN done and works.
 * Still few warning to be eleminated and
 * file locking to be done.
 * file 'build_number' renamed to 'build_num'.
 *
 * Revision 1.1.1.1  1996/10/21 20:46:47  vlad
 * Puting to CVS. Version 1.00B3
 *
 * Revision 1.13  1996/04/12 15:40:23  vlad
 * Content-Disposition header field process staff added.
 *
 * Revision 1.12  1996/03/11 12:16:25  vlad
 * Bug in real name parsing  fixed.
 *
 * Revision 1.11  1996/03/10 15:54:32  vlad
 * Fucked flex's printing to stdout fixed
 * 
 * Revision 1.10  1996/02/19 16:50:25  vlad
 * Fatal bug in parsing MAILBOX1 ' aaa@bbb.ccc.dd (Real (name))' is fixed.
 * 
 * Revision 1.9  1995/10/05  17:00:25  vlad
 * Address '<aa@bb.cc.dd>' implemented.
 * 
 * Revision 1.8  1995/09/20  13:09:47  vlad
 * macro time changed. (for timezone)
 * 
 * Revision 1.7  1995/09/16  10:11:10  vlad
 * Rule 'Reply-to:' changed.
 * 
 * Revision 1.6  1995/08/01  10:55:58  lord
 * umt coding rules.
 * umrParseHeader class
 * 
 * Revision 1.5  1995/07/16  12:44:54  lord
 * For LUNUX uuwrap declared as "C"
 * 
 * Revision 1.4  1995/05/26  12:52:56  vlad
 * Changed processing {value} in CONTENT-TYPE
 * 
 * Revision 1.3  1995/04/02  16:43:56  vlad
 * First revision 
 *  
*/

%{
#include <ctype.h>
#include <stdio.h>
#include <strings.h>
#include <UMT.h++>
#include "umtParseHeader.h++"
    
#define yyterminate() return PARS_EOF;
#define YY_DECL umtParseHeader::States yylex()
#undef  YY_INPUT
#define YY_INPUT(buf,result,max_size) { \
/*  fprintf( stderr,"SYMBOL '%c' %i\n",*pars_string, *pars_string ); */ \
                      if ( *pars_string != '\0' )\
                      { \
			    buf[0] = *pars_string++; \
			    result = 1;\
		      }\
                      else  result = 0;\
                      }
#undef ECHO
#define ECHO {}
#define YY_USER_INIT { pars_init_stack(); }

#define PARS_STACK_SIZE 1024

int    pars_skipcomment( void );
char  *pars_getcomment( char **str );
void   pars_push( int st );
int    pars_pop( void );
void   pars_init_stack( void );

#ifdef LINUX
extern "C" int yywrap (void);
#else
#ifndef SUN
#ifndef FREEBSD
int    yywrap();
#endif
#endif
#endif

/* Flags */
    
char  *pars_string;

int    pars_stack[PARS_STACK_SIZE];
int    pars_stackpointer;
char  *pars_comment = NULL;

/* Global variables */

/*

   !!!!!! TO DO : include delimiters to addr-spac !!!!

*/
/* Folowing tokens doesn't need now.


address                 {mailbox}|{group}
group                   {phrase}":"{del}?({mailbox}?({del}?",")+{del}?)*{mailbox}?{del}?";"


*/

%}

CHAR			[\000-\177]
ALPHA			[\101-\132\141-\172]
DIGIT			[0-9]
CTL			[\000-\037\177]
CR			\015
LF			\012
CRLF			{LF}{LF}
SPACE			\040
HTAB			\011

LWSP-char		{SPACE}|{HTAB}
linear-white-space	({LF}?{LWSP-char})+
quoted-pair		"\\"{CHAR}
atom			[^()<>@,;:\\\".\[\]\000-\037 \177]+
lws			{linear-white-space}
del                     ({lws}|{comment})+
domain-literal		"["({dtext}|{quoted-pair})*"]"
text			.|{LF}
qtext			[^\"\\\015]|{linear-white-space}
dtext		 	[^\[\]\\\015]|{linear-white-space}
ctext		 	[^()\\\015]|{linear-white-space}
quoted-string		"\""({qtext}|{quoted-pair})*"\""
word                    {atom}|{quoted-string}
phrase			({word}{del}?)+
begin-comment		"("({ctext}|{quoted-pair})*
comment                 ("("[^)]*")")
field-name		{atom}{lws}?":"

mailbox1		{addr-spec}{lws}?{begin-comment}
mailbox2                {addr-spec}
mailbox3                {phrase}?{route-addr}
mailbox                 {mailbox3}|{mailbox1}|{mailbox2}

route-addr		"<"{del}?{route}?{del}?{addr-spec}{del}?">"
route			("@"{del}?{domain}({del}?",")+{del}?)*"@"{del}?{domain}{del}?":"
addr-spec		{local-part}("@"{domain})?
local-part		{word}("."{word})*
domain			{sub-domain}("."{sub-domain})*
sub-domain		{domain-ref}|{domain-literal}
domain-ref		{atom}

date-time		({day}{lws}?",")?{lws}?{date}{lws}?{time}
day			{ALPHA}{3}
date			{DIGIT}{1,2}{lws}?{month}{lws}?{DIGIT}{2,4}
month			{ALPHA}{3}
time			{hour}{lws}?{zone}?
hour			{DIGIT}{2}":"{DIGIT}{2}(":"{DIGIT}{2})?
zone			{atom}

token                   [^()<>@,;:\\\"?=./\[\]\000-\037 \177]+
value                   {token}|{quoted-string}


%x field_cond
%x text_cond
%x date_cond
%x to_cond
%x from_cond
%x content_cond
%x content_dispos_cond
%x parameters_cond
%x x_face_cond
%x mailbox3_cond
%x mailbox1_cond
%x mailbox_cond
%x group_cond
%x addr_spec_cond
%x content_transfer_cond
%x NOTHING

%%
"REPLY-TO"{LWSP-char}?":" {
    BEGIN(to_cond);
    return umtParseHeader::REPLY_TO;
}

"FROM"{LWSP-char}?":" {
    BEGIN(from_cond);
    return umtParseHeader::FROM;
}

"SENDER"{LWSP-char}?":"  {
    BEGIN(from_cond);
    return umtParseHeader::SENDER;
}

"DATE"{LWSP-char}?":" {
    BEGIN(date_cond);
    return umtParseHeader::DATE;
}

"TO"{LWSP-char}?":"  {
    BEGIN(to_cond);
    return umtParseHeader::TO;
}

"CC"{LWSP-char}?":" {
    BEGIN(to_cond);
    return umtParseHeader::CC;
}

"BCC"{LWSP-char}?":" {
    BEGIN(to_cond);
    return umtParseHeader::BCC;
}

"SUBJECT"{LWSP-char}?":" {
    BEGIN(text_cond);
    return umtParseHeader::SUBJECT;
}

"MIME-VERSION"{LWSP-char}?":" {
    BEGIN(text_cond);
    return umtParseHeader::MIME_VERSION;
}

"CONTENT-TYPE"{LWSP-char}?":" {
    BEGIN(content_cond);     
    return umtParseHeader::CONTENT_TYPE;
}

"CONTENT-DISPOSITION"{LWSP-char}?":" {
    BEGIN(content_dispos_cond);     
    return umtParseHeader::CONTENT_DISPOSITION;
}

"CONTENT-TRANSFER-ENCODING"{LWSP-char}?":" {
    BEGIN(content_transfer_cond);
    return umtParseHeader::CONTENT_TRANSFER_ENCODING;
}

"X-FACE"{LWSP-char}?":" {
    BEGIN(x_face_cond);
    return umtParseHeader::X_FACE;
}

{field-name} {
    return umtParseHeader::OTHERFIELD;
}

<date_cond,x_face_cond,from_cond,to_cond,mailbox_cond,group_cond,content_cond,content_dispos_cond,parameters_cond,mailbox3_cond,mailbox1_cond,addr_spec_cond,content_transfer_cond>{lws} {
/* skip */
}

<date_cond,from_cond,to_cond,content_cond,content_dispos_cond,parameters_cond,mailbox_cond,mailbox3_cond,group_cond,content_transfer_cond>{begin-comment} {
    if ( pars_skipcomment()) return umtParseHeader::PARS_ERROR;
}

<to_cond>{phrase}":" {
    pars_push( to_cond );
    BEGIN(group_cond);
    return umtParseHeader::GROUP;
}

<to_cond,from_cond,group_cond>"," {
    return umtParseHeader::COMMA;
}

<to_cond,from_cond,group_cond>{mailbox} {
    pars_push( YY_START );
    yyless(0);
    BEGIN(mailbox_cond);
    return umtParseHeader::MAILBOX;
}

<content_cond,content_dispos_cond,parameters_cond,group_cond>";" {
    if ( YY_START == group_cond )
         BEGIN(pars_pop());
    else  if ( YY_START == content_cond || YY_START == content_dispos_cond )
         BEGIN(parameters_cond);
    return umtParseHeader::SEMICOLON;
}

<mailbox_cond>{mailbox3} {
    BEGIN(mailbox3_cond);
    yyless(0);
    return umtParseHeader::MAILBOX3;
}

<mailbox_cond>{mailbox1} {
    BEGIN(mailbox1_cond);
    yyless(0);
    return umtParseHeader::MAILBOX1;
}

<mailbox_cond>{mailbox2} {
    BEGIN(pars_pop());
    return umtParseHeader::MAILBOX2;
}

<mailbox1_cond>{addr-spec} {
    return umtParseHeader::ADDR_SPEC;
}

<mailbox1_cond>{begin-comment} {
/*    yyless(0); */
    pars_comment = umtParseHeader::ParsStrcat( NULL, yytext );
    pars_getcomment( &pars_comment );
    BEGIN(pars_pop());
    return umtParseHeader::COMMENT;
}

<mailbox3_cond>{word} {
    return umtParseHeader::WORD;
}

<mailbox3_cond>"<"{del}?{route}? {
    BEGIN(addr_spec_cond);
    return umtParseHeader::ROUTE;
}

<addr_spec_cond>{addr-spec} {
    return umtParseHeader::ADDR_SPEC;
}

<addr_spec_cond>">" {
    BEGIN(pars_pop());
    return umtParseHeader::END_MAILBOX3;
}

<text_cond,x_face_cond>{text} {
    return umtParseHeader::TEXT;
}

<date_cond>{date-time} {
    return umtParseHeader::DATE_TIME;
}

<content_cond>"/" {
    return umtParseHeader::SLASH;
}

<content_transfer_cond,content_cond,content_dispos_cond>{token} {
    return umtParseHeader::TOKEN;
}

<parameters_cond>{token}{del}?"="{del}? {
    yytext[strcspn( yytext, "=( \n\t" )] = '\0';
    return umtParseHeader::ATTRIBUTE;
}


<parameters_cond>{value} {
    if ( *yytext == '"' )
    {
         yytext[yyleng - 1] = '\0';
         yytext++;
    }
    return umtParseHeader::VALUE;
}


<<EOF>> {
/*    fprintf( stderr,"PARS_EOF %d\n", YY_START ); */
    BEGIN(INITIAL);
    yyrestart( NULL );
    pars_init_stack();
    return umtParseHeader::PARS_EOF;
}

<INITIAL,date_cond,from_cond,to_cond,content_cond,content_dispos_cond,parameters_cond,mailbox3_cond,addr_spec_cond,group_cond,mailbox_cond,mailbox1_cond,content_transfer_cond>. {
    BEGIN(INITIAL);
    return umtParseHeader::PARS_ERROR;
}

<NOTHING>. {
    pars_init_stack();
    BEGIN(INITIAL);
    fprintf( stderr," PARS STACK ERROR \n" );
    return umtParseHeader::PARS_ERROR;    
}
%%

int pars_skipcomment( void )
{
    int c;

    while (1)
    {
	switch ( c = yyinput())
	{
	case ')'  :
	    return 0;
	case '('  :
	    pars_skipcomment();
	    break;
	case '\\' :
	    if (( c = yyinput()) == EOF ) return 1;
	    break;
	case EOF :
	    return 1;
	}
    }
}


char *pars_getcomment( char **str )
{
    int c;

    while (1)
    {
	c = yyinput();
/*        fprintf( stderr, "'%c' %d\n", ( char )c, c ); */
	switch (c)
	{
	case ')'  :
	    return umtParseHeader::ParsAddchar( str, c );
	case '('  :
	    umtParseHeader::ParsAddchar( str, c );
	    pars_getcomment( str );
	    break;
	case '\\' :
	    umtParseHeader::ParsAddchar( str, c );
	    if (( c = yyinput()) == EOF ) return *str;
	    umtParseHeader::ParsAddchar( str, c );
	    break;
	case EOF :
	    return *str;
	default:
	    umtParseHeader::ParsAddchar( str, c );
	}
    }
}


char *umtParseHeader::ParsAddchar( char **a, int c )
{
    char  cc[2];
    
    cc[0] = (char) c;
    cc[1] = '\0';
    return umtParseHeader::ParsStrcat( a, cc );
}


char *umtParseHeader::ParsStrcat( char **a, const char *b )
{
    char *aa, *result;
    int len = 0;

    if ( a == NULL )
	aa = NULL;
    else aa = *a;
    if ( aa == NULL )
    {
	aa = new char[PARS_STRING_INC];
	aa[0] = '\0';
    }
    if ( b == NULL ) return aa;
    len = PARS_STRING_INC - ((strlen( aa ) + 1) % PARS_STRING_INC );
    if ((signed)( strlen( b ) + 1 ) > len )
    {	
	if (( result =
	      new char[
	      strlen( aa )
	      + 1
	      + len
	      + ((( strlen( b )/ PARS_STRING_INC ) + 1 )
		 * PARS_STRING_INC) ] ) == NULL )
	    return NULL;
	strcpy( result, aa );
	delete aa;
    }
    else result = aa;
    strcat( result, b );
    if ( a != NULL ) *a = result;
    return result;
}


int  yywrap()
{
    return 1;
}


int    pars_pop( void )
{
    return ( pars_stackpointer )?
	pars_stack[ --pars_stackpointer ]:
        NOTHING;
}


void   pars_push( int st )
{
    if ( pars_stackpointer < PARS_STACK_SIZE )
	pars_stack[ pars_stackpointer++ ] = st;
    return ;
}


void   pars_init_stack( void )
{
    pars_stackpointer = 0;
    return ;
}




