#include "UMT.h++"
#include <InterViews/bitmap.h>
#include <InterViews/raster.h>
#include <InterViews/transformer.h>
#include <InterViews/tformsetter.h>
#include <InterViews/image.h>
#include <InterViews/tiff.h>
#include <InterViews/label.h>

#define TB_DEFAULT_SPACE 0
#define TB_GROUP_SPACE 10
void umtGRTFEditorImpl::InitToolBar(Glyph *bar)
{
    WidgetKit *k=WidgetKit::instance();
    LayoutKit *l=LayoutKit::instance();
    Transformer t,t1;
    umtPath p1(UMTNoReadIcon);
    Glyph  *im_bold,*im_italic,*im_underline,*im_fixed,*im_bigger,*im_small,
	*im_ind,*im_indoff,*im_indl,*im_indr,
	*im_al,*im_ac,*im_ar,
	*im_color,*im_search;
    Raster *r_bold,*r_italic,*r_underline,*r_fixed,*r_bigger,*r_small,
	*r_ind,*r_indoff,*r_indl,*r_indr,
	*r_al,*r_ac,*r_ar,
	*r_color,*r_search;
    
    b_bold=b_italic=b_underline=b_fixed=
	b_a_left=b_a_center=b_a_right=nil;
    
    b_indent_right_size=b_indent_left_size=b_font_size=nil;

    if(bar==nil)return;
    if(IsEditable==true)
    {
	//Bigger
	if( p1.IsExists() == OK
	    &&
	    (r_bigger = TIFFRaster::load(UMTRtfTb_Bigger)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_bigger->width(),
		    MsgStatusIconHeight/r_bigger->height());
	    im_bigger = new TransformSetter(new Image(r_bigger),t);
	    
	}
	else im_bigger = new Label(">>",k->font(),k->foreground());

	//Smaller
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_small = TIFFRaster::load(UMTRtfTb_Smaller)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_small->width(),
		    MsgStatusIconHeight/r_small->height());
	    im_small = new TransformSetter(new Image(r_small),t);
	    
	}
	else im_small = new Label("<<",k->font(),k->foreground());

	//Bold
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_bold = TIFFRaster::load(UMTRtfTb_Bold)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_bold->width(),
		    MsgStatusIconHeight/r_bold->height());
	    im_bold = new TransformSetter(new Image(r_bold),t);
	    
	}
	else im_bold = new Label("B",k->font(),k->foreground());

	//Italic
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_italic = TIFFRaster::load(UMTRtfTb_Italic)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_italic->width(),
		    MsgStatusIconHeight/r_italic->height());
	    im_italic = new TransformSetter(new Image(r_italic),t);
	    
	}
	else im_italic = new Label("I",k->font(),k->foreground());
	
	//Underline
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_underline = TIFFRaster::load(UMTRtfTb_UnderLine)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_underline->width(),
		    MsgStatusIconHeight/r_underline->height());
	    im_underline = new TransformSetter(new Image(r_underline),t);
	    
	}
	else im_underline = new Label("U",k->font(),k->foreground());
	
	//Fixed
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_fixed = TIFFRaster::load(UMTRtfTb_Fixed)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_fixed->width(),
		    MsgStatusIconHeight/r_fixed->height());
	    im_fixed = new TransformSetter(new Image(r_fixed),t);
	    
	}
	else im_fixed = new Label("U",k->font(),k->foreground());
	
	//Indent
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_ind = TIFFRaster::load(UMTRtfTb_Indent)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_ind->width(),
		    MsgStatusIconHeight/r_ind->height());
	    im_ind = new TransformSetter(new Image(r_ind),t);
	    
	}
	else im_ind = new Label("Ind",k->font(),k->foreground());
	
	//IndentOFF
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_indoff = TIFFRaster::load(UMTRtfTb_IndentOff)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_indoff->width(),
		    MsgStatusIconHeight/r_indoff->height());
	    im_indoff = new TransformSetter(new Image(r_indoff),t);
	    
	}
	else im_indoff = new Label("IndOff",k->font(),k->foreground());
	
	//IndentLeft
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_indl = TIFFRaster::load(UMTRtfTb_RightIndentOff)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_indl->width(),
		    MsgStatusIconHeight/r_indl->height());
	    im_indl = new TransformSetter(new Image(r_indl),t);
	    
	}
	else im_indl = new Label("IL",k->font(),k->foreground());
	
	//IndentRight
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_indr = TIFFRaster::load(UMTRtfTb_RightIndent)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_indr->width(),
		    MsgStatusIconHeight/r_indr->height());
	    im_indr = new TransformSetter(new Image(r_indr),t);
	    
	}
	else im_indr = new Label("IR",k->font(),k->foreground());
	
	//AlignLeft
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_al = TIFFRaster::load(UMTRtfTb_Left)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_al->width(),
		    MsgStatusIconHeight/r_al->height());
	    im_al = new TransformSetter(new Image(r_al),t);
	    
	}
	else im_al = new Label("L",k->font(),k->foreground());
	
	//AlignCenter
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_ac = TIFFRaster::load(UMTRtfTb_Center)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_ac->width(),
		    MsgStatusIconHeight/r_ac->height());
	    im_ac = new TransformSetter(new Image(r_ac),t);
	    
	}
	else im_ac = new Label("C",k->font(),k->foreground());
	
	//AlignRight
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_ar = TIFFRaster::load(UMTRtfTb_Right)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_ar->width(),
		    MsgStatusIconHeight/r_ar->height());
	    im_ar = new TransformSetter(new Image(r_ar),t);
	    
	}
	else im_ar = new Label("R",k->font(),k->foreground());
	
	//Color
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_color = TIFFRaster::load(UMTRtfTb_Color)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_color->width(),
		    MsgStatusIconHeight/r_color->height());
	    im_color = new TransformSetter(new Image(r_color),t);
	    
	}
	else im_color = new Label("Color",k->font(),k->foreground());
	
	//Search
	p1=UMTNoReadIcon;
	if( p1.IsExists() == OK
	    &&
	    (r_search = TIFFRaster::load(UMTRtfTb_Search)) != nil)
	{
	    t = t1;
	    t.scale(MsgStatusIconWidth/r_search->width(),
		    MsgStatusIconHeight/r_search->height());
	    im_search = new TransformSetter(new Image(r_search),t);
	    
	}
	else im_search = new Label("Search",k->font(),k->foreground());
	
	k->begin_style("UMTSmallButtonStyle");
	k->style()->attribute("*Label*minimumWidth", "5.0");
	k->style()->attribute("*Label*minimumHeight", "5.0");
	k->style()->attribute("*PushButton*minimumWidth", "5.0");
	k->style()->attribute("*PaletteButton*minimumWidth", "5.0");
	k->style()->attribute("*PushButton*minimumHeight", "5.0");
	k->style()->attribute("*PaletteButton*minimumHeight", "5.0");
//	k->style()->attribute("*RadioButton*minimumWidth", "20.0");

	bar->append(l->hspace(TB_GROUP_SPACE));
	bar->append(k->push_button(im_small,new ImplCb(this,RtfBiggerOFF)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	
	{
	  long i;
	  Deck *d=l->deck();
	  
	  char tmp[10];
	  for( i=-10 ; i<=10 ; i++ )
	    {
	      sprintf(tmp,"%d",(int)i);
	      d->append(k->label(tmp));
	    }
//	  bar->append(l->vcenter(b_font_size=new Patch(d),0));
	  bar->append(l->vcenter(k->inset_frame(b_font_size=new Patch(d)),0));
	}
 
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(k->push_button(im_bigger,new ImplCb(this,RtfBigger)));
	bar->append(l->hspace(TB_GROUP_SPACE));

	bar->append(b_bold=k->palette_button(im_bold,new ImplCb(this,RtfBold)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(b_italic=k->palette_button(im_italic,new ImplCb(this,RtfItalic)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(b_underline=k->palette_button(im_underline,new ImplCb(this,RtfUnderLine)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(b_fixed=k->palette_button(im_fixed,new ImplCb(this,RtfFixed)));

	bar->append(l->hspace(TB_GROUP_SPACE));
	bar->append(k->push_button(im_ind,new ImplCb(this,RtfIndent)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));

	{
	  long i;
	  char tmp[10];
	  Deck *d=l->deck();
	  
	  for( i=0 ; i<=10 ; i++ )
	    {
	      sprintf(tmp,"%d",(int)i);
	      d->append(k->label(tmp));
	    }
	  bar->append(l->vcenter(k->inset_frame(b_indent_left_size=new Patch(d)),0));
	}

	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(k->push_button(im_indoff,new ImplCb(this,RtfIndentOFF)));
	bar->append(l->hspace(TB_GROUP_SPACE));
	bar->append(k->push_button(im_indr,new ImplCb(this,RtfIndentRight)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));

	{
	  long i;
	  char tmp[10];
	  Deck *d=l->deck();
	  
	  for( i=0 ; i<=10 ; i++ )
	    {
	      sprintf(tmp,"%d",(int)i);
	      d->append(k->label(tmp));
	    }
	  bar->append(l->vcenter(k->inset_frame(b_indent_right_size=new Patch(d)),0));
	}

	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(k->push_button(im_indl,new ImplCb(this,RtfIndentRightOFF)));
	bar->append(l->hspace(TB_GROUP_SPACE));

        bar->append(b_a_left=k->palette_button(im_al, new ImplCb(this,RtfFlushLeft)));
        bar->append(l->hspace(TB_DEFAULT_SPACE));
        bar->append(b_a_center=k->palette_button(im_ac, new ImplCb(this,RtfCenter)));
        bar->append(l->hspace(TB_DEFAULT_SPACE));
        bar->append(b_a_right=k->palette_button(im_ar, new ImplCb(this,RtfFlushRight)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(l->hspace(TB_GROUP_SPACE));
	    
	bar->append(k->push_button(im_color,new ImplCb(this,RtfX_Color)));
	bar->append(l->hspace(TB_DEFAULT_SPACE));
	bar->append(k->push_button(im_search,new ImplCb(this,RTFSearch)));
	bar->append(l->hspace(TB_GROUP_SPACE));
        bar->append(l->hglue());
      k->end_style();
    }  
}


void umtGRTFEditorImpl::UpdateToolBar(void)
{
  
  if(current_block!=nil)
    {
      long i=current_block->char_size;

      if(b_font_size!=nil)
	{
	  if(i<-10)i=-10;
	  if(i> 10)i=10;
	  i+=10;
	  if(i!=((Deck*)(b_font_size->body()))->card())
	    {
	      ((Deck*)(b_font_size->body()))->flip_to(i);
	      b_font_size->redraw();
	    }
	}

      i=current_block->indent_left;
      if(b_indent_left_size!=nil)
	{
	  if(i< 0 )i=0;
	  if(i> 10)i=10;
	  if(i!=((Deck*)(b_indent_left_size->body()))->card())
	    {
	      ((Deck*)(b_indent_left_size->body()))->flip_to(i);
	      b_indent_left_size->redraw();
	    }
	}

      i=current_block->indent_right;
      if(b_indent_right_size!=nil)
	{
	  if(i< 0 )i=0;
	  if(i> 10)i=10;
	  if(i!=((Deck*)(b_indent_right_size->body()))->card())
	    {
	      ((Deck*)(b_indent_right_size->body()))->flip_to(i);
	      b_indent_right_size->redraw();
	    }
	}
    }
    
  if(b_bold!=nil)
    b_bold->state()->set
	(TelltaleState::is_chosen, (current_block->font_style & RTFFONT_Bold)?true:false);
  
  if(b_italic!=nil)
    b_italic->state()->set
      (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_Italic)?true:false);
  
  if(b_underline!=nil)
    b_underline->state()->set
      (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_UnderLine)?true:false);
  
  if(b_fixed!=nil)
    b_fixed->state()->set
      (TelltaleState::is_chosen, (current_block->font_style & RTFFONT_Fixed)?true:false);
  
  
  {
    boolean bl=true,bc=false,br=false;
    long t=CharParagrafNumber(cur_cursor_pos);
    
    if(
       (t>=0) &&
       (t<paragrafs.count())
       )
      {
	switch(paragrafs.item(t)->Align())
	  {
	  case RtfCenter    :bl=false;bc=true;break;
	  case RtfFlushRight:bl=false;br=true;break;
      }
  }

    if(b_a_left!=nil)
      b_a_left->state()->set
	(TelltaleState::is_chosen,bl);
    
    if(b_a_center!=nil)
      b_a_center->state()->set
	(TelltaleState::is_chosen,bc);
    
    if(b_a_right!=nil)
      b_a_right->state()->set
	(TelltaleState::is_chosen,br);
  }
}








