/*
$Id: umtRefPointList.cc,v 1.1 1996/10/22 19:47:41 lord Exp $

$Log: umtRefPointList.cc,v $
Revision 1.1  1996/10/22 19:47:41  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 2.1  1996/04/08  15:43:21  voloh
// new cursor insted
//
// Revision 2.0  1996/03/18  16:42:38  sebast
// Revision 2.0
//
// Revision 1.4  1996/03/07  17:34:51  voloh
// .
//
// Revision 1.3  1996/03/03  19:25:06  voloh
// mailto reference manager added.
//
// Revision 1.2  1996/03/03  14:08:44  voloh
// -----
//
// Revision 1.1  1996/03/03  12:47:18  voloh
// Initial revision
//
*/


#include "umtRefPointList.h++"
#include "umtRtfGlobals.h++"
#include "umtHelpCl.h++"
#include "../src/umtApp.h++"


umtRefPoint::umtRefPoint(umtString comm, umtPath loc)
{
    location   = loc;
    commentary = comm;
}


umtRefPoint& umtRefPoint::operator =(umtRefPoint& hp)
{
    location   = hp.location;
    commentary = hp.commentary;
    return hp;
}

umtRefPoint::~umtRefPoint() { }

    
int umtRefPoint::operator ==(umtRefPoint& hp)
{
    return ( location == hp.location );
}

int umtRefPoint::operator !=(umtRefPoint& hp)
{
    return ( location != hp.location );
}


umtRefPointListEntry::umtRefPointListEntry(
    umtRefPoint rr,
	umtRefPointList* hl )
{
    ref = rr;
    up  = hl;
}

umtRefPointListEntry::~umtRefPointListEntry() { }


void umtRefPointListEntry::Act(Glyph* gl)
{
    up->Act(gl, ref);
}


void umtRefPointListEntry::CursorHilight()
{
    up->CursorHilight();
}

void umtRefPointListEntry::CursorUnHilight()
{
    up->CursorUnHilight();
}

static int umt_help_cursor_pat[]= {
    0x0000,
    0x0100,
    0x0100,
    0x0100,
    0x07c0,
    0x07c0,
    0x06c0,
    0x7c7c,
    0x06c0,
    0x07c0,
    0x07c0,
    0x0100,
    0x0100,
    0x0100,
    0x0000,
    0x0000
};
static int umt_help_cursor_mask[]= {
    0x0380,
    0x0380,
    0x0380,
    0x0380,
    0x0fe0,
    0x0fe0,
    0xfffe,
    0xfffe,
    0xfffe,
    0x0fe0,
    0x0fe0,
    0x0380,
    0x0380,
    0x0380,
    0x0380,
    0x0000
};

umtRefPointList::umtRefPointList() :
    umtSlist()
{
//    cursor = WidgetKit::instance()->hand_cursor();
    cursor = new Cursor(
	7, 7,
	    umt_help_cursor_pat,
	    umt_help_cursor_mask
    );
    directory = UMTConfig.GetStrField(HELP_PATH);
    if ( directory.IsEmpty() )
	directory = ".";
}

umtRefPointList::~umtRefPointList()
{
    delete cursor;
    Kill(nil);
}


umtRefPointListEntry* umtRefPointList::NewRefHandler(
    umtRefPoint ref )
{
    Append(new umtRefPointListEntry(
	ref, this
    ));
    return (umtRefPointListEntry*)GetLast();
}

void umtRefPointList::Act(
    Glyph* gl, umtRefPoint ref)
{
    umtString s1, s2, s3, s4;
    umtMsgEditDock  *me;
    umtInternetAddr ia;
    CursorUnHilight();
    umtString param = ref.Loc();
    if ( !param.IsEmpty() && !param.Search(':').IsEmpty() ) {
	s1 = param.Left(param.Index(':'));
	s2 = param.Right(param.RIndex(':')+1);
	s3 = UMTConfig.GetStrField(
	    umtString(HREF_CONFIG_GROUP)+"."+s1
	);
	if ( s3.IsEmpty() ) {
	    if ( s1 == "http" )
		s4 = umtString("netscape http://")+s2+" &";
	    else if ( s1 == "ftp" )
		s4 = umtString("netscape ftp://")+s2+" &";
	    else if ( s1 == "html" )
		s4 = umtString("netscape ")+directory+"/"+s2+" &";
	    else if ( s1 == "img" )
		s4 = umtString("xv ")+directory+"/"+s2+" &";
	    else if ( s1 == "xv" )
		s4 = umtString("xv ")+directory+"/"+s2+" &";
	    else if ( s1 == "mailto" ) {
		ia.SetInternetAddr(&s2);
		me = UMTApplication->MakeNewMsg();
		if (!me) return;
		me->Msg->AddToField(&ia);
		me->Open();
		return;
	    }
	} else {
	    if ( param.RIndex(':') ==
		 param.Index(':') )
		s4.Sprintf((s3+" &").Str(),
			   (directory+"/"+s2).Str());
	    else
		s4.Sprintf((s3+" &").Str(),
			   s2.Str());
	}
	if ( !s4.IsEmpty() ) {
	    if ( UMTError )
		UMTError->Msg(
		    umtError::Info,
			umtString("Runing \"")+
			s4+
			umtString("\"!")
		);
	    system(s4.Str());
	    return;
	}
    }
    UMTHelpDock.open(gl, ref);
}

void umtRefPointList::CursorHilight()
{
    if ( window &&
	 !cursor_hilighted ) {
	window->cursor(cursor);
	window->cursor()->init();
	cursor_hilighted = 1;
    }
}

void umtRefPointList::CursorUnHilight()
{
    if ( window &&
	 cursor_hilighted ) {
	window->cursor(defaultCursor);
	window->cursor()->init();
	cursor_hilighted = 0;
    }
}
