/*
$Id: umtRtfCommands.cc,v 1.1 1996/10/22 19:47:42 lord Exp $
  
$Log: umtRtfCommands.cc,v $
Revision 1.1  1996/10/22 19:47:42  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:41  sebast
// Revision 2.0
//
// Revision 1.3  1996/03/07  14:43:39  voloh
// Clean() uses ::Kill() now
//
// Revision 1.2  1996/03/03  18:16:29  voloh
// some debuging removed
//
// Revision 1.1  1996/03/03  12:46:46  voloh
// Initial revision
//
*/

#include "umtRtfCommands.h++"


umtRTFCom& umtRTFCom::operator =(umtRTFCommand c)
{
    Mean = c;
    return *this;
}

umtRTFCom& umtRTFCom::operator =(umtRTFCom& c)
{
    Mean = c.Mean;
    return *this;
}

umtRTFCom::~umtRTFCom() { }

int umtRTFCom::GetType()
{
    return  1;
}


umtRTFCommands::~umtRTFCommands()
{
    Kill ( nil );
}

void  umtRTFCommands::Push(umtRTFCommand c)
{
    Append((umtMember*)new umtRTFCom(c));
}

status umtRTFCommands::Pop(umtRTFCommand c)
{
    if ( last && ((umtRTFCom*)last)->Mean==c ) {
	umtRTFCom *l = (umtRTFCom*)last;
	Remove((umtMember*)l);
	delete l;
    } else
	return ERROR_REMOVE;
    return OK;
}

umtRTFCommand umtRTFCommands::Top()
{
    if ( !last ) return NoCommand;
    else  return ((umtRTFCom*)last)->Mean;
}

umtRTFCommand umtRTFCommands::LastFlush()
{
    umtRTFCom* p = (umtRTFCom*)last;
    while ( p && !infirstgroup(p->Mean) )
	p = (umtRTFCom*)p->Prev;
    if ( p ) return p->Mean;
    else return NoCommand;
}

int umtRTFCommands::SizeCount()
{ // It not correct in global view.
    umtRTFCom* p = (umtRTFCom*)first;
    int rez = 0;
    while ( p ) {
	if ( p->Mean==cmBigger || p->Mean==cmSmallerDn )
	    rez++;
	else if ( p->Mean==cmBiggerDn || p->Mean==cmSmaller )
	    rez--;
	p = (umtRTFCom*)p->Next;
    }
    return rez;
}

void umtRTFCommands::Clean()
{
    Kill(nil);
}

int umtRTFCommands::infirstgroup(umtRTFCommand c)
{
    switch ( c ) {
    case cmNofill:
    case cmCenter:
    case cmFlushLeft:
    case cmFlushRight:
    case cmFlushBoth:
	return 1;
    default: return 0;
    }
}

int umtRTFCommands::insecondgroup(umtRTFCommand c)
{
    switch ( c ) {
    case cmRtfOn:
    case cmRtfOff:
    case cmNewLine:
    case UnknownCommand:
	return 1;
    default: return 0;
    }
}

umtString umtRTFCommands::Name(umtRTFCommand cm)
{
    switch (cm) {
    case NoCommand:       return "NoCommand";
    case cmRtfOn:         return "RTF-On";
    case cmRtfOff:        return "RTF-Off";
    case cmNewLine:       return "NL";
    case cmParam:         return "Param";
    case cmParamDn:       return "/Param";
    case cmComment:       return "Comment";
    case cmCommentDn:     return "/Comment";
    case cmBigger:        return "Bigger";
    case cmBiggerDn:      return "/Bigger";
    case cmSmaller:       return "Smaller";
    case cmSmallerDn:     return "/Smaller";
    case cmBiggest:       return "Biggest";
    case cmBiggestDn:     return "/Biggest";
    case cmTinier:        return "Tinier";
    case cmTinierDn:      return "/Tinier";
    case cmBold:          return "Bold";
    case cmBoldDn:        return "/Bold";
    case cmItalic:        return "Italic";
    case cmItalicDn:      return "/Italic";
    case cmFixed:         return "Fixed";
    case cmFixedDn:       return "/Fixed";
    case cmUnderline:     return "Underline";
    case cmUnderlineDn:   return "/Underline";
    case cmCenter:        return "Center";
    case cmCenterDn:      return "/Center";
    case cmFlushLeft:     return "FlushLeft";
    case cmFlushLeftDn:   return "/FlushLeft";
    case cmFlushRight:    return "FlushRight";
    case cmFlushRightDn:  return "/FlushRight";
    case cmFlushBoth:     return "FlushBoth";
    case cmFlushBothDn:   return "/FlushBoth";
    case cmNofill:        return "Nofill";
    case cmNofillDn:      return "/Nofill";
    case cmXColor:        return "X-Color";
    case cmXColorDn:      return "/X-Color";
    case cmIndent:        return "Indent";
    case cmIndentDn:      return "/Indent";
    case cmIndentRight:   return "IndentRight";
    case cmIndentRightDn: return "/IndentRight";
    case cmExcerpt:       return "Excerpt";
    case cmExcerptDn:     return "/Excerpt";
    case cmHRef:          return "HRef";
    case cmHRefDn:        return "/HRef";
    default:              return "UnknownCommand";
    }
    return "UnknownCommand!!!";
}

umtRTFCommand umtRTFCommands::WhatCommand(umtString name)
{
    if ( name == "rtf-on" ) return cmRtfOn;
    else if ( name == "rtf-off" ) return cmRtfOff;
    else if ( name == "nl" ) return cmNewLine;
    else if ( name == "param" ) return cmParam;
    else if ( name == "/param" ) return cmParamDn;
    else if ( name == "comment" ) return cmComment;
    else if ( name == "/comment" ) return cmCommentDn;
    else if ( name == "ignore-me" ) return cmComment;
    else if ( name == "/ignore-me" ) return cmCommentDn;
    else if ( name == "bigger" ) return cmBigger;
    else if ( name == "/bigger" ) return cmBiggerDn;
    else if ( name == "smaller" ) return cmSmaller;    
    else if ( name == "/smaller" ) return cmSmallerDn;    
    else if ( name == "biggest" ) return cmBiggest;
    else if ( name == "/biggest" ) return cmBiggestDn;
    else if ( name == "tinier" ) return cmTinier;
    else if ( name == "/tinier" ) return cmTinierDn;
    else if ( name == "bold" ) return cmBold;
    else if ( name == "/bold" ) return cmBoldDn;
    else if ( name == "italic" ) return cmItalic;
    else if ( name == "/italic" ) return cmItalicDn;
    else if ( name == "fixed" ) return cmFixed;
    else if ( name == "/fixed" ) return cmFixedDn;
    else if ( name == "underline" ) return cmUnderline;
    else if ( name == "/underline" ) return cmUnderlineDn;
    else if ( name == "center" ) return cmCenter;
    else if ( name == "/center" ) return cmCenterDn;
    else if ( name == "flushleft" ) return cmFlushLeft;
    else if ( name == "/flushleft" ) return cmFlushLeftDn;
    else if ( name == "flushright" ) return cmFlushRight;
    else if ( name == "/flushright" ) return cmFlushRightDn;
    else if ( name == "flushboth" ) return cmFlushBoth;
    else if ( name == "/flushboth" ) return cmFlushBothDn;
    else if ( name == "nofill" ) return cmNofill;
    else if ( name == "/nofill" ) return cmNofillDn;
    else if ( name == "x-color" ) return cmXColor;
    else if ( name == "/x-color" ) return cmXColorDn;
    else if ( name == "indent" ) return cmIndent;
    else if ( name == "/indent" ) return cmIndentDn;
    else if ( name == "indentright" ) return cmIndentRight;
    else if ( name == "/indentright" ) return cmIndentRightDn;
    else if ( name == "excerpt" ) return cmExcerpt;
    else if ( name == "/excerpt" ) return cmExcerptDn;
    else if ( name == "href" ) return cmHRef;
    else if ( name == "/href" ) return cmHRefDn;
    else return UnknownCommand;
}

