/*
$Id: umtRtfFonts.cc,v 1.1 1996/10/22 19:47:42 lord Exp $

$Log: umtRtfFonts.cc,v $
Revision 1.1  1996/10/22 19:47:42  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:49  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:41  sebast
// Revision 2.0
//
// Revision 1.6  1996/03/11  18:50:00  voloh
// Getting fonts configuration from GRTFEdit config.
//
// Revision 1.5  1996/03/07  17:33:50  voloh
// 'new Font' -> Font::lookup()
//
// Revision 1.4  1996/03/07  14:45:12  voloh
// ref/unref extended
//
// Revision 1.3  1996/03/03  15:10:34  voloh
// Small bug
//
// Revision 1.2  1996/03/03  13:44:17  voloh
// -----
//
// Revision 1.1  1996/03/03  12:46:33  voloh
// Initial revision
//
*/


#include "umtRtfAttrib.h++"
#include "umtGRTFEditor.h++"

// const char *umtRTFFonts::FntName[] = {rtffDef,rtffB,rtffI,rtffBI,
// 				      rtffF,rtffBF,rtffIF,rtffBIF,
// 				      rtffU,rtffBU,rtffIU,rtffBIU,
// 				      rtffFU,rtffBFU,rtffIFU,rtffBIFU };


umtRTFFont::umtRTFFont(umtString& name,
		       int FI, int Szd ):
    umtMember(CLASS_RTFFont)
{
    FontId     = FI;
    Sized      = Szd;
    f_name     = name;
    opened     = 0;
    fn         = nil;
}

umtRTFFont::umtRTFFont(umtRTFFont* rf):
    umtMember(CLASS_RTFFont)
{
    Sized = rf->Sized;
    FontId = rf->FontId;
    if ( fn = rf->fn )
	Resource::ref(fn);
    opened = rf->opened;
    f_name = f_name;
}

umtRTFFont::umtRTFFont(Font* rf, int FI, int Sz):
    umtMember(CLASS_RTFFont)
{
    Sized = Sz;
    FontId = FI;
    if ( fn = rf )
	Resource::ref(fn);
    opened = 1;
}

umtRTFFont::~umtRTFFont()
{
    if ( fn ) Resource::unref(fn);
}

Font* umtRTFFont::GetFn()
{
    if ( !opened ) {
	fn = (Font*)Font::lookup(f_name.Str());
	if ( fn )
	    Resource::ref(fn);
//	else {
// 	    char zzz[1024];
// 	    sprintf(zzz, " Error open %s font named as '%s'",
// 		    umtRTFFonts::FntName[FontId],
// 		    f_name.Str());
//	    RTF_WARNING_MSG(zzz)
//	}
	opened = 1;
    }
    return fn;
}


umtRTFFonts::umtRTFFonts(umtString /*CfgFnt*/):
    umtSlist()
{
#define GRTF_FONT_STYLE(i) ((((i&(1<<1))?1:0)<<0)|(((i&(1<<2))?1:0)<<1)|(((i&(1<<0))?1:0)<<2))

   char *fnames[] = {
	umtGRTF_FONT_NORMAL,
	umtGRTF_FONT_FIXED,
	umtGRTF_FONT_BOLD,
	umtGRTF_FONT_BOLD_FIXED,
	umtGRTF_FONT_ITALIC,
	umtGRTF_FONT_ITALIC_FIXED,
	umtGRTF_FONT_ITALIC_BOLD,
	umtGRTF_FONT_ITALIC_BOLD_FIXED
    };
    
    umtConfiguration *cur_config, *config;
    umtString        cur_font_name;
    char             tmp[1024];
    int              i,j;
    
    config = UMTConfig.GetConfiguration(
	umtString("RTFEditor")+"."+"Fonts"
    );
    
    if ( config ) {
	for ( i=0 ; i<8 ; i++ ) {
	    cur_config = config->GetConfiguration(fnames[i]);
	    if ( cur_config ) {
		
		sprintf( tmp, "%s",
			 umtGRTF_FONT_NORMAL_PREFIX );
		cur_font_name = cur_config->GetStrField(tmp);
		if ( !cur_font_name.IsEmpty() &&
		     Font::exists(
			 Session::instance()->default_display(),
			     cur_font_name.Str())==true )
		    Append(
			new umtRTFFont(
			    cur_font_name,
				GRTF_FONT_STYLE(i), 0
			)
		    );
		else
		    Append(
			new umtRTFFont(
			    (Font*)WidgetKit::instance()->font(),
				GRTF_FONT_STYLE(i), 0 )
		    );
		
		j = 0;
		while ( 1 ) {
		    if ( j )
			sprintf( tmp, "%s%d",
				 umtGRTF_FONT_BIGGER_PREFIX, j);
		    else
			sprintf(tmp, "%s",
				umtGRTF_FONT_BIGGER_PREFIX);
		    cur_font_name = cur_config->GetStrField(tmp);
		    if ( cur_font_name.IsEmpty() ) break;
		    if ( Font::exists(
			Session::instance()->default_display(),
			    cur_font_name.Str())==true )
			Append(
			    new umtRTFFont(
				cur_font_name,
				    GRTF_FONT_STYLE(i), j
			    )
			);
		    j++;
		}
		
		j = 0;
		while ( 1 ) {
		    if ( j )
			sprintf( tmp, "%s%d",
				 umtGRTF_FONT_SMALLER_PREFIX, j );
		    else
			sprintf( tmp, "%s",
				 umtGRTF_FONT_SMALLER_PREFIX );
		    cur_font_name = cur_config->GetStrField(tmp);
		    if ( cur_font_name.IsEmpty() ) break;
		    Append(
			new umtRTFFont(
			    cur_font_name,
				GRTF_FONT_STYLE(i), -j
			)
		    );
		    j++;
		}
	    }
	}
    } else {
	ErrorStatus = ERROR_IN_CALLED_FUNCTION;
	sprintf( tmp,
		 "Undefined configuration for fonts definition !!!" );
	RTF_ERROR_MSG(tmp)
        return;
    }
    ErrorStatus = OK;
}

umtRTFFonts::~umtRTFFonts()
{
    Kill(NULL);
}

Font* umtRTFFonts::Default()
{
    return (Font*)((umtRTFFont*)first)->GetFn();
}

Font* umtRTFFonts::GetFont(int i,int s)
{
    umtRTFFont*       r = (umtRTFFont*)first;
    umtRTFFont*       l = r;
    Font*             f2r;
//    char              zzz[1024];

    while ( r && ((r->FontId!=i)||(r->Sized!=s)) ) {
	if ( r->FontId == i )
	    if ( l->FontId == i ) {
		if ( abs(s-(l->Sized)) >= abs(s-(r->Sized)) )
		    l = r;
	    } else
		l = r;
	r = (umtRTFFont*)GetNext(r);
    }
    if ( r && (f2r=r->GetFn()) )
	return f2r;

    if ( l->FontId == i && (f2r=l->GetFn()) ) {
	// Sized too bigger or too smaller
//	sprintf(zzz, " Needs font %s sized to %d", FntName[i], s);
//	RTF_DEBUG_MSG(zzz)
//	sprintf(zzz, "      using %s at size %d", FntName[l->FontId], l->Sized);
//	RTF_DEBUG_MSG(zzz)
	return f2r;
    }

    if ( i != 0 ) {
	// no this font type seted
	// try to switch down some flags
//	sprintf(zzz, " Needs font %s sized to %d", FntName[i], s);
//	RTF_DEBUG_MSG(zzz)
//	sprintf(zzz, "    finding %s", FntName[0]);
//	RTF_DEBUG_MSG(zzz)
	if ( i & 0x08 ) i &= 0x07;
	else
	    if ( i & 0x04 ) i &= 0x3;
	    else
		if ( i & 0x02 ) i &= 0x1;
		else i = 0;
	return GetFont(i,s);
    }

    else {
	// returns default font with any sized
//	sprintf(zzz, " Needs font %s sized to %d", FntName[i], s);
//	RTF_DEBUG_MSG(zzz)
//	sprintf(zzz, "      using %s at size %d", FntName[l->FontId], l->Sized);
//	RTF_DEBUG_MSG(zzz)
	return l->GetFn();
    }
}
