/*
$Header: /export/CVS/UMT/libsrc/umtIV/umtPasswd.cc,v 1.1 1996/10/22 19:47:47 lord Exp $

$Log: umtPasswd.cc,v $
Revision 1.1  1996/10/22 19:47:47  lord
Due to stupidity of SUN CC, all .c++ files renamed to .cc.
Some platform directories created in lib.
Makefile.include for SUN created.

Revision 1.1.1.1  1996/10/21 20:46:47  vlad
Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:42:54  sebast
// Revision 2.0
//
// Revision 1.6  1996/02/17  12:41:53  bird
// Set Window title
//
// Revision 1.5  1995/11/21  17:49:49  voloh
// updated for languages
//
// Revision 1.4  1995/10/30  17:39:24  voloh
// cosmetics on c++-text
//
// Revision 1.3  1995/10/30  09:07:27  voloh
// small size correction
//
// Revision 1.2  1995/10/29  15:52:27  voloh
// small cosmetics on face
//
// Revision 1.1  1995/10/29  12:21:28  voloh
// Initial revision
//
*/

#include "umtPasswd.h++"

#define CHAR_TO_SHOW '.'
#define EMPTY_SPACE  ' '
#define CURSOR_CHAR  '_'

implementActionCallback(umtPasswordEntry)

umtPasswordEntry::umtPasswordEntry(
    umtString title,
    Style* st, WidgetKit* k,
    const LayoutKit* l)
    :
    umtDialog(l->vbox(), st,"Enter password")
{
    kit = k;
    layout = l;
    *(pval=val) = '\0';
    body_build(title);
}

umtPasswordEntry::~umtPasswordEntry()
{
    Resource::unref(sb);
    Resource::unref(my_body);
}


void umtPasswordEntry::body_build(umtString title)
{
    my_body = new LRComposition(
	sb = layout->vscrollbox(),
        new TeXCompositor(1),
        nil, 0, fil, fil, 0
    );
    Resource::ref(sb);
    sb->small_scroll(Dimension_Y,2);
    Resource::ref(my_body);
    my_body->append(layout->vstrut(0));
    my_body->append(
	new Character(EMPTY_SPACE, kit->font(), kit->foreground()));
    my_body->append(
	new Character(CURSOR_CHAR, kit->font(), kit->foreground()));
    my_body->append(layout->vglue(0,fil,fil));
    my_body->append(layout->strut(kit->font(),0,fil,fil));
    my_body->repair();
    sb->notify(Dimension_Y);
    body(
	layout->hbox(
	    kit->outset_frame(
		layout->vbox(
		    layout->vspace(10),
	            layout->hbox(
			layout->hglue(),
		        kit->fancy_label(title.Str()),
	                layout->hglue()
	            ),
	            layout->vspace(7),
	            layout->hbox(
			layout->hspace(10),
		        kit->outset_frame(
			    layout->hbox(
				layout->vcenter(
				    kit->fancy_label(
					UMTSTR(631)
				    ),
				    .5
				),
			        kit->inset_frame(
				    layout->fixed(
					layout->vcenter(
					    my_body,
					    .5
					),
				        kit->font()->width(CHAR_TO_SHOW)*22,
				        kit->font()->size()*1.5
				    )
			        )
			    )
		        ), layout->hspace(10)
		    ), layout->vspace(10)
	        )
	    ), layout->natural_span(kit->vscroll_bar(sb),0,0)
	)
    );
}

void umtPasswordEntry::keystroke(const Event& ev)
{
    if ( (ev.keysym()&0xff) == 13l ) {
	*pval = '\0';
	dismiss(true);
    } else if ( (ev.keysym()&0xff) == 27l ) {
	*val = '\0';
	dismiss(false);
    } else if ( (ev.keysym()&0xff) == 8l ) {
	if ( pval > val ) {
	    my_body->remove( 2 );
	    pval--;
	}
    } else if ( (ev.keysym()&0xff) == ev.keysym() ) {
	if ( pval >= val+sizeof(val) )
	    return;
 	my_body->insert( 2,
 	    new Character(
 		CHAR_TO_SHOW,
 	        kit->font(),
 	        kit->foreground()
 	    )
 	);
	*pval++ = (char)(
	    (ev.shift_is_down()) ?
	((ev.keysym()&0xff)+'A'-'a'):
	(ev.keysym()&0xff));
    }
    my_body->repair();
    sb->notify(Dimension_Y);
}

umtString umtPasswordEntry::GetValue() const
{
    return umtString(val);
}
