/*  $Id: umtProgressIndicator.cc,v 1.1 1996/10/22 19:47:48 lord Exp $

    $Log: umtProgressIndicator.cc,v $
    Revision 1.1  1996/10/22 19:47:48  lord
    Due to stupidity of SUN CC, all .c++ files renamed to .cc.
    Some platform directories created in lib.
    Makefile.include for SUN created.

    Revision 1.1.1.1  1996/10/21 20:46:48  vlad
    Puting to CVS. Version 1.00B3

// Revision 1.6  1996/03/30  18:01:22  bird
// Bug in Run() fixed
//
// Revision 1.5  1996/03/16  16:32:15  vlad
// wnd = NULL; in constructor added
//
// Revision 1.4  1996/03/16  16:13:49  bird
// *** empty log message ***
//
// Revision 1.3  1995/09/28  13:42:50  sebast
// work with updating... => bird
//
// Revision 1.2  1995/09/25  17:23:18  sebast
// using Kit, Layout from parameters
//
// Revision 1.1  1995/09/25  17:02:07  sebast
// Initial revision
//
*/

#include <InterViews/display.h>
#include <InterViews/event.h>
#include <InterViews/background.h>
#include <InterViews/color.h>
#include <IV-X11/xcanvas.h>
#include <IV-X11/xwindow.h>

#include "umtProgressIndicator.h++"
#include "umtHandler.h++"
#include "UMT.h++"



umtProgressIndicatorEntry::umtProgressIndicatorEntry(Glyph *g) : MonoGlyph(g)
{
    c = nil;
}

umtProgressIndicatorEntry::~umtProgressIndicatorEntry()
{
}
    
void umtProgressIndicatorEntry::draw(Canvas *c_, const Allocation &a_) const
{
    if(c_)
	{
	    ((umtProgressIndicatorEntry*)this)->c = c_;
 	    ((umtProgressIndicatorEntry*)this)->a.allot_x(a_.x_allotment()); 
 	    ((umtProgressIndicatorEntry*)this)->a.allot_y(a_.y_allotment()); 
	}
    MonoGlyph::draw(c_,a_);
//    fprintf(stderr,"Progress. draw() %d\n",int(c_));
}

void umtProgressIndicatorEntry::undraw()
{
    c = nil;
    MonoGlyph::undraw();
}

void umtProgressIndicatorEntry::Redraw()
{
    Canvas *tmp = c;
    if( c )
    {
	c = nil;
//	draw(tmp,a);
	tmp->damage_all();
//	tmp->rep()->flush();
	Session *s = Session::instance();
	s->default_display()->flush();
	s->default_display()->sync();
	s->default_display()->flush();
	Event e;
	while(c == nil && s->pending())
	{
	    s->read(e);
	    // tmp->rep()->window_->receive(e);
	    e.handle();
	}

    }
}

umtProgressIndicator::umtProgressIndicator() 
{
    TheKit       = WidgetKit::instance();
    TheLayout    = LayoutKit::instance();
    indicator_patch = NULL;
    wnd          = NULL;
}

void umtProgressIndicator::Run(unsigned  int m_val, unsigned  int s_val,
			       int is_persent, umtSlist *header_)
{
    PolyGlyph *header_glyph;
    wnd = NULL;
    
    indicator_patch = NULL;

    max_val = m_val;
    cur_val = s_val;
    is_persent_show = is_persent;
    header = header_;
    
    header_glyph = TheLayout->vbox();
    for (umtString *u = (umtString *)header->GetFirst();
	 u;
	 u = (umtString *)header->GetNext(u))
	header_glyph->append(
	    TheLayout->hbox(
		TheLayout->hglue(),
		TheKit->label(u->Str()),
		TheLayout->hglue()
	    )
	);
    
    UpdateIndicator(cur_val);
    
    wnd =
	new TopLevelWindow
	(
	    TheLayout->vbox(TheKit->outset_frame(TheLayout->vbox(TheLayout->vspace(5),
								 header_glyph,
								 TheLayout->vspace(5))),
			    indicator_patch)
	);
    
    WindowName(wnd, "Progress Indicator", TheKit->style());
    
    wnd->wm_delete(new umtHandler(this));


    Session *s = Session::instance();

    Event e;
    while(s->pending())
    {
	s->read(e);
	e.handle();
    }
    
    wnd->map();
    s->default_display()->flush();
    s->default_display()->sync();
    s->default_display()->flush();
	
    wnd->repair();

    while(indicator_patch->c == nil)
    {
	if(s->pending())
	{
	    s->read(e);
	    e.handle();
	}
//	wnd->receive(e);
 	if(indicator_patch->c != nil)
 	    break;
    }
}

umtProgressIndicator::~umtProgressIndicator()
{
    Done();
}

void umtProgressIndicator::Done()
{
    if (indicator_patch)
    {
	indicator_patch->Resource::unref();
	indicator_patch = nil;
    }
    if(wnd)
    {
        wnd->unmap();
	Delete(wnd);
	wnd = nil;
    }
}

void umtProgressIndicator::UpdateIndicator( unsigned  int val)
{
    char s[200];
    int persent;
    cur_val = val;
    if (cur_val > max_val)
    	return;
    
    
    if (is_persent_show)
    {
	if(max_val == 0)
	    persent = 0;
	else
	    persent = int(cur_val/( double ) max_val * 100);
	sprintf(s,"Progress: %d%%",persent);
    }
    else 
	sprintf(s,"Progress: %5d of %5d",cur_val, max_val);

    Glyph *g =  TheKit->inset_frame(
	TheLayout->vbox(
	    TheLayout->hbox(TheLayout->hglue(),
			    TheKit->label(s),
				    TheLayout->hglue())
	));
    
    if(is_persent_show)
    {
	g->append(TheLayout->vspace(10));
	g->append(TheLayout->hbox(TheLayout->hglue(),
				  TheLayout->hspace(30),
				  TheLayout->fixed
				  (
				      TheKit->inset_frame
					  (
					      TheLayout->hbox(
						  TheKit->outset_frame
						      (
							  new Background(TheLayout->hspace(4*persent),
									 new Color(0.0f,0.0f,1.0f))
						      ),
						      
						      TheLayout->hglue())    
					  ),
					  
					  400,
					  20),
				  TheLayout->hspace(30),
				  TheLayout->hglue()));
	g->append(TheLayout->vspace(10));
    }
    
    if (!indicator_patch)
    {
	indicator_patch = new umtProgressIndicatorEntry(TheKit->outset_frame(g));
	indicator_patch->Resource::ref();
    }
    else
    {
	indicator_patch->body(g);
	indicator_patch->Redraw();
    }

}
int umtProgressIndicator::CloseWindow()
{
    return 1;
}

implementActionCallback(umtProgressIndicator);







