/*
   $Header: /export/CVS/UMT/libsrc/umtbase/umtDictionary.cc,v 1.1 1996/10/22 19:47:52 lord Exp $
   
   $Log: umtDictionary.cc,v $
   Revision 1.1  1996/10/22 19:47:52  lord
   Due to stupidity of SUN CC, all .c++ files renamed to .cc.
   Some platform directories created in lib.
   Makefile.include for SUN created.

   Revision 1.1.1.1  1996/10/21 20:46:48  vlad
   Puting to CVS. Version 1.00B3

Revision 2.0  1996/03/18  16:43:11  sebast
Revision 2.0

Revision 1.14  1995/09/12  15:49:54  sebast
umtDictionary(umtDictionary *d) reworked

Revision 1.13  1995/07/31  17:47:52  sebast
some inherited from Slist functions added

Revision 1.12  1995/07/31  14:30:00  lord
umt coding convention

Revision 1.11  1995/06/22  11:26:15  sebast
call of member() in constructors added

Revision 1.10  1995/04/26  11:00:29  sebast
uses *.h++ instead *.h

Revision 1.9  1995/03/17  19:58:01  sebast
changed to use class umtString

Revision 1.8  1995/03/11  14:53:26  sebast
dictionary::dictionary(dictionary *d) changed

Revision 1.7  1995/03/09  17:04:17  sebast
dictionary::dictionary(dictionary *d) implemented

Revision 1.6  1995/03/07  15:58:03  sebast
constructor dictionary::dictionary(dictionary *d) implemented

Revision 1.5  1995/02/17  17:37:49  sebast
added call of base constructor

Revision 1.4  95/02/13  14:45:09  14:45:09  lord (Vadim Zaliva)
Implemented. I should test it some day.

Revision 1.3  95/02/13  10:14:50  10:14:50  lord (Vadim Zaliva)
Destructor written

Revision 1.2  95/02/12  16:38:58  16:38:58  sebast (Sebastian Kamyshenko)
the shit with defining of class commented

Revision 1.1  95/02/12  15:46:17  15:46:17  sebast (Sebastian Kamyshenko)
Initial revision

*/

#include "umtDictionary.h++"
#include "misc.h++"

umtDictionaryEntry::umtDictionaryEntry():umtMember()
{
    Handler=Value=NULL;
}

umtDictionaryEntry::umtDictionaryEntry(umtDictionaryEntry *p) : umtMember(CLASS_DICTIONARY_ENTRY)
{
    if(p)
    {
	if(p->Handler) Handler = new umtString(p->Handler);
	else Handler = NULL;

	if(p->Value) Value   = new umtString(p->Value);
	else Value = NULL;
    }
}

umtDictionaryEntry::umtDictionaryEntry(umtString *h, umtString *v)
    : umtMember(CLASS_DICTIONARY_ENTRY)
{
    if(h) Handler = new umtString(h);
    if(v) Value   = new umtString(v);
}

umtDictionaryEntry::~umtDictionaryEntry()
{
    if(Handler) Delete(Handler);
    if(Value)   Delete(Value);
}

umtDictionary::umtDictionary():umtSlist()
{
}


umtDictionary::umtDictionary(umtDictionary *d)
{
    umtDictionaryEntry *e = (umtDictionaryEntry *)d->GetFirst();
    for(; e; e = (umtDictionaryEntry *)d->GetNext(e))
	Append(new umtDictionaryEntry(e));	
}

umtDictionary::~umtDictionary()
{
    Kill(NULL);
}

umtDictionaryEntry *umtDictionary::GetLast()
{
    return (umtDictionaryEntry *) umtSlist::GetLast();
}
umtDictionaryEntry *umtDictionary::GetFirst()
{
    return (umtDictionaryEntry *) umtSlist::GetFirst();
}

umtDictionaryEntry *umtDictionary::GetNext(umtDictionaryEntry *a)
{
    return (umtDictionaryEntry *) umtSlist::GetNext(a);
}

umtDictionaryEntry *umtDictionary::GetPrev(umtDictionaryEntry *a)
{
    return (umtDictionaryEntry *) umtSlist::GetPrev(a);
}


status  umtDictionary::Add(umtString *h,umtString *v)
{
    umtDictionary::Add(new umtDictionaryEntry(h,v));
    return OK;
}

status  umtDictionary::Add(umtDictionaryEntry *n)
{
    Append(n);
    return OK;
}

umtString  *umtDictionary::Get(umtString *h)
{
    umtDictionaryEntry *i;
  
    for(i=(umtDictionaryEntry *)GetFirst();i;i=(umtDictionaryEntry *)GetNext(i))
	if((*i->Handler)==(*h))
	    return i->Value;

    return NULL;
}


status  umtDictionary::Del(umtString *h)
{
    umtDictionaryEntry *i;
  
    for(i=(umtDictionaryEntry *)GetFirst();i;i=(umtDictionaryEntry *)GetNext(i))
	if(*i->Handler==*h)
	{
	    Kill(i);
	    return OK;
	}
  
    return NOT_FOUND;
}






