/*
  $Header: /export/CVS/UMT/libsrc/umtbase/umtDir.cc,v 1.1 1996/10/22 19:47:52 lord Exp $

  $Log: umtDir.cc,v $
  Revision 1.1  1996/10/22 19:47:52  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:48  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:43:12  sebast
// Revision 2.0
//
// Revision 1.15  1995/11/30  18:44:42  bird
// #ifdef HPUX in NextEntry & dirp = nil in Close
//
// Revision 1.14  1995/09/30  12:49:54  sebast
// some constructors added
//
// Revision 1.13  1995/09/14  14:16:11  lord
// Create added
//
// Revision 1.12  1995/09/06  14:40:28  lord
// umtDir::umtDir(const char *s)
//
// Revision 1.11  1995/09/06  14:35:23  lord
// Leave only & copy constructor.
//
// Revision 1.10  1995/09/05  14:21:55  lord
// empty constructor added.
// Some useless comments added
//
// Revision 1.9  1995/08/24  13:18:52  lord
// String -> Str
//
// Revision 1.8  1995/07/31  16:52:13  lord
// umt coding rules
//
// Revision 1.7  1995/07/26  16:34:15  lord
// BUG present in Next entry.
//
// Revision 1.6  1995/07/15  16:39:28  lord
// do not skip . and ..
//
// Revision 1.5  1995/07/15  16:34:55  lord
// NextEntry now returns umtPath *
//
// Revision 1.4  1995/07/15  16:05:27  lord
// Skip . and .. in NextEntry
//
// Revision 1.3  1995/07/15  16:01:09  lord
// bug in Open fixed
//
// Revision 1.2  1995/07/15  15:53:21  lord
// make NextEntry return umtPath
//
// Revision 1.1  1995/07/15  15:42:10  lord
// Initial revision
//
  */

#include "umtDir.h++"


#include <string.h>
#include <sys/types.h>
#include <sys/stat.h> 
#include <sys/param.h> // MAXPATHLEN defined here in HPUX

umtDir::umtDir():umtPath()
{
    dirp=nil;
}

umtDir::umtDir(umtString &s):umtPath(s)
{
    dirp=nil;
}

umtDir::umtDir(const char *s):umtPath(s)
{
    dirp=nil;
}

umtDir::umtDir(umtPath &s):umtPath(s)
{
    dirp=nil;
}

umtDir::umtDir(umtDir &s):umtPath(s)
{
    dirp=nil;
}

umtDir::~umtDir() {}

umtDir& umtDir::operator =(const umtDir &f)
{
    *((umtPath *)this)=(const umtPath *)&f;
    dirp = f.dirp ;
    dp   = f.dp   ;
    return *this;
}

status     umtDir::Open     ()
{
    if(IsEmpty()) return NO_VARIABLE_DEFINED;
    dirp = ::opendir(Str());
    if(!dirp)
	return ERROR_OPEN_FILE;
    else
	return OK;
}

status     umtDir::Close    ()
{
    if(::closedir(dirp)==0)
    {
	dirp = nil;
	return OK;
    }
    else return ERROR_IN_CALLED_FUNCTION;
}

status     umtDir::Rewind   ()
{
    rewinddir(dirp);
    return OK; // For future extentions.
}

umtPath umtDir::NextEntry()
{
    char      *es;
    char      s[MAXPATHLEN];

    dp = ::readdir(dirp);
    if(!dp)
    {
	return umtPath("");
    }

//      if(dp->d_reclen==1 && dp->d_name[0]=='.')
//  	return NextEntry(); // Skip .

//      if(dp->d_reclen==2 && dp->d_name[0]=='.' && dp->d_name[0]=='.')
//  	return NextEntry(); // Skip ..
    
    strcpy (s,Str());
    strcat (s,"/");
#ifndef HPUX
    strncpy(es=strchr(s,'\0'),dp->d_name,dp->d_reclen);
    *(es+dp->d_reclen)='\0';
#else
    strncpy(es=strchr(s,'\0'),dp->d_name,dp->d_namlen);
    *(es+dp->d_namlen)='\0';
#endif    
    return umtPath(s);
} 

int        umtDir::IsOpened()
{
    return dirp?1:0;
}

status     umtDir::Create()
{
    return mkdir(Str(),S_IRWXU) ? ERROR_CREATE_FILE : OK;
}

