/*
 * $Header: /export/CVS/UMT/libsrc/umtbase/umtLanguage.cc,v 1.1 1996/10/22 19:47:53 lord Exp $
 * $Log: umtLanguage.cc,v $
 * Revision 1.1  1996/10/22 19:47:53  lord
 * Due to stupidity of SUN CC, all .c++ files renamed to .cc.
 * Some platform directories created in lib.
 * Makefile.include for SUN created.
 *
 * Revision 1.1.1.1  1996/10/21 20:46:48  vlad
 * Puting to CVS. Version 1.00B3
 *
// Revision 2.0  1996/03/18  16:43:14  sebast
// Revision 2.0
//
// Revision 1.18  1995/10/11  17:54:49  sebast
// UMT_CONFIG_DEFAULT_umtLanguage defines at FULL config' id
//
// Revision 1.17  1995/10/11  16:09:09  sebast
// some changes following UMT.cfg
//
// Revision 1.16  1995/08/24  16:36:59  lord
// 2 errors fixed.
// 1. SGI compiler calls ::read instead of umtLanguage::read
// 2. Vlad did not know yet, that EOF can not be stored in char!
//
// Revision 1.15  1995/08/24  15:20:34  lord
// read takes const
//
// Revision 1.14  1995/08/24  15:10:43  lord
// Check for List==nil at Free
//
// Revision 1.13  1995/08/22  14:42:41  lord
// added const in compar to avoid warnings
//
// Revision 1.12  1995/08/22  12:41:33  lord
// ChangeumtLanguage->ChangeLangugae
//
// Revision 1.11  1995/07/31  16:25:51  lord
// umt coding rules
//
// Revision 1.10  1995/07/31  16:02:08  lord
// umtCoding rules
//
// Revision 1.9  1995/07/27  16:57:43  lord
// Some type casts added. lang_msg constructor parameters specified
//
// Revision 1.8  1995/06/22  12:22:11  sebast
// call of member() changed
//
// Revision 1.7  1995/06/22  11:12:09  sebast
// call of member() changed
//
// Revision 1.6  1995/06/12  15:54:25  vlad
// method  umtLangMessage::read() changed,
//         ang_message::parse_string() added.
//
// Revision 1.5  1995/06/11  07:57:35  vlad
// constructor Languige, returen value of operator[] changed.
//
// Revision 1.4  1995/06/10  15:38:13  vlad
// replaced isspace( *mess ) --> ( *mess == ' ' || *mess == '\t' ) for russian
// literals.
//
// Revision 1.3  1995/06/10  14:37:15  lord
// Some brush-up
//
// Revision 1.2  1995/06/10  14:04:30  vlad
//  RCS Comments ( $Header: /export/CVS/UMT/libsrc/umtbase/umtLanguage.cc,v 1.1 1996/10/22 19:47:53 lord Exp $ $log$ ) added
//
 */

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>

#include "umtConfiguration.h++"
#include "UMT.h++"
#include "umt_error.h++"
#include "umtLanguage.h++"


umtLangMessage::umtLangMessage( umtLangMessage *mess ):umtMember(CLASS_LANG_MESSAGE)
{
    number  = mess->number;
    message = mess->message;
}

umtLangMessage::~umtLangMessage()
{
}

int   umtLangMessage::Read( FILE *f, char *buff, int len )
{
    int  c;
    char *str;
    
    while(1)
    {
	if (!fscanf(f, "%d", &number))
	{
	    if ( fgets( buff, len, f ) == NULL ) return -1;
	    continue;
	}
	while (( c = fgetc( f )) == ' ' || c == '\t' ); 
	switch ( c )
	{
	case  EOF : return -1;
	case  '"' :
	    message = parse_string( f, buff, len );
	    break;
	case  '\n':
	    message = "";
	    break;
	default:
	    buff[0] = c;
	    fgets( buff + 1, len - 1, f );
	    if (( str = strpbrk( buff, " \n" )) != NULL ) *str = '\0';
	    message = buff;
	}
	return 0;
    }
}


umtString  umtLangMessage::parse_string( FILE* f, char *buff, int len )
{
    char       *str1, *str2, c;
    umtString   u_str = "";

    if ( fgets( buff, len, f ) == NULL ) return u_str;
    str1 = buff;
    while (( str2 = strpbrk( str1, "\\\"" )) != NULL )
    {
	c = *str2; 
	*str2 = '\0';
	u_str += str1;
	if ( c == '"' )
	    return u_str; 
	else 
	{
	    switch ( *++str2 )
	    {
	    case  'f':
		u_str += '\f';
		break;
	    case  'n':
		u_str += '\n';
		break;
	    case  't':
		u_str += '\t';
		break;
	    case  'v':	
		u_str += '\v';
		break;
	    case  'b':
		u_str += '\b';
		break;
	    case  'r':
		u_str += '\r';
		break;
	    case '\n':
		u_str += parse_string( f, buff, len );
		return u_str;
	    case '\0':
		ungetc( '\\', f );
		u_str += parse_string( f, buff, len );
		return u_str;
	    default:
		u_str += *str2;
	    }
	    str1 = ++str2;
	}
    }
    u_str += str1;
    if( u_str.Length() && u_str[ u_str.Length() - 1 ] == '\n' )
	u_str.SetToSubstr( 0, u_str.Length() - 1 );
    return u_str;
}


umtLanguage::umtLanguage():umtMember(CLASS_LANG)
{
    number = 0;
    List   = NULL;
    name   = "";
}


umtLanguage::~umtLanguage()
{
    Free();
}


void  umtLanguage::Free()
{
    int i;

   if(List)
   {
       for ( i = 0; i < number; i++ )
	   Delete( List[i]);
       Delete( List );
   }
    number = 0;
    name   = ""; 
}


status  umtLanguage::ChangeLanguage( umtString n )
{
    umtString path;
    umtConfiguration *cfg;
    
    cfg = UMTConfig.GetConfiguration( UMT_CONFIG_umtLanguage_FIELD );
    if ( cfg == NULL )
    {
	return NO_VARIABLE_DEFINED;
    }
    if ( n.IsEmpty())
	n = UMTConfig.GetStrField( UMT_CONFIG_DEFAULT_umtLanguage );  
    if ( n.IsEmpty()) return NO_VARIABLE_DEFINED;
//    path = cfg->GetStrField( UMT_CONFIG_umtLanguage_PATH );
//    path += '/';
//    path += cfg->GetStrField( n );
    path = cfg->GetStrField( n );
    Free();
    name  = n;
    return umtLanguage::read(path.Str());
}


status umtLanguage::read( const char *filename )
{
    umtLangMessage msg(0,""), *ptr;
    char buff[ LANG_BUFF_SIZE ];
    FILE *file;
    umtSlist  msg_list;
    int i;
    
    file = fopen( filename, "r" );
    if ( file == NULL ) return ERROR_OPEN_FILE;
    while ( !msg.Read( file, buff, LANG_BUFF_SIZE ))
 	msg_list.Append( new umtLangMessage( &msg ));
    number = (int)msg_list.GetCount();
    List = new umtLangMessage*[ number ];
    if ( List == NULL ) return NOT_ENOUGH_MEMORY;
    for ( ptr = (umtLangMessage *) (msg_list.GetFirst()), i = 0;
	 ptr;
	 ptr = (umtLangMessage *) (msg_list.GetNext( ptr )), i++
    )
	List[i] = ptr;
    qsort( List, number, sizeof ( umtLangMessage *), compar );
    return OK;
}


int      umtLanguage::compar( const void *a, const void *b )
{
    int n1, n2;
    n1 = (*( umtLangMessage * const *)(a))->GetNum();
    n2 = (*( umtLangMessage * const *)(b))->GetNum();
    return  ( n1 == n2 )? 0:( n1 < n2 )? -1: 1;
  }


const char*  umtLanguage::operator []( int n )
{
  umtLangMessage **pptr, *ptr, tmp( n, "" );

  if ( number == 0 || List == NULL ) return UNEXISTING_STRING;
  ptr = &tmp;
  pptr = ( umtLangMessage **)bsearch( &ptr,
				   List,
				   number,
				   sizeof( umtLangMessage *),
				   compar );
  return ( pptr )? (*pptr)->GetStr(): UNEXISTING_STRING;
}












