/*
  $Header: /export/CVS/UMT/libsrc/umtbase/umtRegex.cc,v 1.1 1996/10/22 19:47:55 lord Exp $
  
  $Log: umtRegex.cc,v $
  Revision 1.1  1996/10/22 19:47:55  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:48  vlad
  Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:43:20  sebast
// Revision 2.0
//
// Revision 1.17  1996/02/15  18:03:54  bird
// is_case added
//
// Revision 1.16  1996/02/14  10:22:00  sebast
// In umtRegex& umtRegex::operator = (const umtRegex &r) const added
//
// Revision 1.15  1995/11/17  15:15:42  bird
// umtRegex::umtRegex (umtRegex &r) & operator = added
//
// Revision 1.14  1995/10/27  15:43:45  bird
// int reg(const char *,const char *); added
//
// Revision 1.13  1995/10/23  15:31:25  voloh
// *** empty log message ***
//
// Revision 1.12  1995/10/23  15:03:10  voloh
// *** empty log message ***
//
// Revision 1.11  1995/10/22  16:09:24  voloh
// testing on LINUX
//
// Revision 1.10  1995/10/21  15:43:08  sebast
// some changes with GetRegEx; reg_str added
//
// Revision 1.9  1995/10/21  14:02:22  sebast
// changes in GetRegEx
//
// Revision 1.8  1995/10/16  16:19:16  sebast
// cflags removed because it is not supported
//
// Revision 1.7  1995/10/16  14:08:25  sebast
// GetRegEx() added
//
// Revision 1.6  1995/09/18  08:53:00  vlad
// is_full=0 was missed in constuctors. Fixed.
//
// Revision 1.5  1995/08/24  13:22:17  lord
// String->Str
//
// Revision 1.4  1995/08/22  14:54:16  lord
// avoid warning
//
// Revision 1.3  1995/07/31  16:33:16  lord
// umt coding rules
//
// Revision 1.2  1995/07/27  17:19:58  lord
// Port for dumb SGI regex
//
// Revision 1.1  1995/07/07  11:52:31  lord
// Initial revision
//
*/

#include <string.h>
#include "umtRegex.h++"

umtRegex::umtRegex () : umtMember(CLASS_REGEX)
{
    is_full=0;
    is_case=0;
}

umtRegex::umtRegex (umtRegex &r) : umtMember(CLASS_REGEX)
{
    Set(r.reg_str,r.is_case);  
}

umtRegex::umtRegex (umtString s, int is_case_ ) : umtMember(CLASS_REGEX)
{
    is_full=0;
    Set(s.Str(),is_case_);
}

umtRegex::umtRegex (char *s, int is_case_) : umtMember(CLASS_REGEX)
{
    is_full=0;
    Set(s,is_case_);
}

umtRegex::~umtRegex()
{
//    if(is_full)
//	regfree(&preg);
}

umtRegex& umtRegex::operator = (const umtRegex &r)
{
    Set(r.reg_str,r.is_case);
    return *this;
}

void umtRegex::Set(const umtString s, int is_case_)
{
    Set(s.Str(),is_case_);
}

void umtRegex::Set(const char *s,int is_case_)
{
    is_case = is_case_;
    reg_str = s;
//    if(is_full)
//	regfree(&preg);
    //cflags=flags;
//    error_code = regcomp(&preg, reg_str.Str(), 0);
//    if ( error_code == 0 )
//	is_full=1;
    
}

int  umtRegex::Match(const char *s)
{
    
// #ifndef IRIX
//     return regexec(&preg, s, (size_t) 0, NULL, 0) ? 0:1; // was 1:0
// #else
//     char *zzz;
    
//     zzz=re_comp(preg);
//     if(zzz==0)
// 	return re_exec(s);
//     else
// 	return 0;
// #endif
    umtString tmps(s);
    umtString tmpr(reg_str);
    if(!is_case)
    {
       tmpr.ToUpper();
       tmps.ToUpper();
    }
    return reg(tmps.Str(),tmpr.Str());
}

int  umtRegex::operator == (const char *s)
{
    return Match(s);
}

int  umtRegex::operator == (const umtString s)
{
    return Match(s.Str());
}
    
int  umtRegex::Match(const umtString s)
{
    return Match(s.Str());
}
    
int  umtRegex::IsOk()
{
//    if(!is_full) return 0;
//    return error_code?0:1;
    return 1;
}
int  umtRegex::IsCase()
{
//    if(!is_full) return 0;
//    return error_code?0:1;
    return is_case;
}

int  umtRegex::GetErrorCode()
{
//    return error_code;
    return 0;
}

umtString umtRegex::GetRegEx()
{
//#ifdef IRIX
    return reg_str;
//#else
//    return umtString(( char *)preg.buffer);
//#endif
}

int  umtRegex::reg(const char *str,const char *mask)
{
    if( *str == '\0' )
    	if( *mask == '\0' )
	    return 1;
    
    if( *mask == '*' )
    {
	for(;*str;str++)
	{
	    if(reg(str,mask+1))
		return 1;
	}
	return reg(str,mask+1);
    }
    else
	if( (*mask == '?' && *str) ||  *str == *mask )  
	    return reg(str+1,mask+1);
    
    return 0;
    
}





