/* $Header: /export/CVS/UMT/libsrc/umtbase/umtString.cc,v 1.1 1996/10/22 19:47:56 lord Exp $

   $Log: umtString.cc,v $
   Revision 1.1  1996/10/22 19:47:56  lord
   Due to stupidity of SUN CC, all .c++ files renamed to .cc.
   Some platform directories created in lib.
   Makefile.include for SUN created.

   Revision 1.1.1.1  1996/10/21 20:46:48  vlad
   Puting to CVS. Version 1.00B3

// Revision 2.0  1996/03/18  16:43:24  sebast
// Revision 2.0
//
// Revision 1.10  1996/03/01  18:33:09  vlad
// void umtString::StripJunk()
//  // TODO: This function don't strip string if it is only one char !!! Fix it.
//
   Revision 1.9  1996/02/19 15:00:53  sebast
   bug in CaseInsensitiveEqual() fixed

// Revision 1.8  1995/10/28  16:11:13  vlad
// methods Sprintf(), operator + added.
//
// Revision 1.7  1995/09/28  18:26:18  bird
// bug in Write fixed
//
// Revision 1.6  1995/09/15  17:19:43  lord
// bug fixed in ==
//
// Revision 1.5  1995/09/15  14:26:43  lord
// Some additional checks in == and !=
//
// Revision 1.4  1995/09/15  14:16:51  lord
// *** empty log message ***
//
// Revision 1.3  1995/09/14  11:00:31  sebast
// some bugs in ToLower() and ToUpper() removed
//
// Revision 1.2  1995/09/14  10:57:16  sebast
// lots log info from prev ver removed
//
// Revision 1.1  1995/09/14  10:55:29  sebast
// Initial revision
*/


#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>

#include "misc.h++"
#include "umtString.h++"


umtString::umtString():umtMember(CLASS_UMT_STRING)
{
    data_ = nil;
}

umtString::umtString( const char* s ):umtMember(CLASS_UMT_STRING)
{
    data_ = ustrdup(s);
}

umtString::umtString( const char *s, int len ):umtMember(CLASS_UMT_STRING)
{
    if(s && len>0)
    {
	data_=new char[len+1];
	strncpy(data_,s,len);
	data_[len]='\0';
    }
    else
	data_=nil;
}


umtString::umtString(const umtString &s):umtMember(CLASS_UMT_STRING)
{
    data_=ustrdup(s.data_);
}

umtString::umtString(const umtString *s):umtMember(CLASS_UMT_STRING)
{
    data_=(s)? ustrdup(s->data_) : (char*)nil;
}

umtString::~umtString()
{
    if (data_) Delete(data_);
}

umtString &umtString::Sprintf(const char *format, ... )
{
    static  char s[MAX_FOPMAT_STRING];
    va_list ap;
    
    *s = '\0';
    if ( data_ ) Delete( data_ );
    va_start(ap, format);
    (void)vsprintf(s, format, ap);
    va_end(ap);
    data_=ustrdup(s);
    return *this;
}

umtString &umtString::operator =(const umtString &s)
{
    if(data_) Delete(data_);
    data_ = ustrdup(s.data_);
    return *this;
}

umtString &umtString::operator =(const char* s)
{
    if(data_) Delete(data_);
    data_ = ustrdup(s);
    return *this;
}

umtString &umtString::operator +=(const char* s)
{
    int  l;
    char *tmp;
    
    if(!s) return *this;

    l=(data_)?strlen(data_):0;
    l+=strlen(s);
    
    tmp = new char[l+1];
    if(data_)
	strcpy(tmp,data_);
    else
	*tmp='\0';
    strcat(tmp,s);

    if(data_) Delete(data_);
    data_ = tmp;
    return *this;
}

umtString &umtString::operator +=(const umtString& s)
{
    int  l;
    char *tmp;
    
    if(s.data_==nil) return *this;

    l=(data_)?strlen(data_):0;
    l+=s.Length();
    
    tmp = new char[l+1];
    if(data_)
	strcpy(tmp,data_);
    else
	*tmp='\0';
    strcat(tmp,s.data_);

    if(data_) Delete(data_);
    data_ = tmp;
    return *this;
}

umtString& umtString::operator +=( const char ch)
{
    int l;
    char *tmp;
    
    l=Length();
    
    tmp = new char[l+2];
    if (data_)
	strcpy(tmp,data_);
    else
	*tmp='\0';

    tmp[l  ]=ch;
    tmp[l+1]='\0';
    
    if (data_) Delete(data_);
    data_ = tmp;
    return *this;
}

umtString umtString::operator +(const char* s )
{
    umtString tmp = data_; 

    tmp+=s;
    return tmp;
}

umtString umtString::operator +(const umtString& a)
{
    umtString tmp = data_;
    
    tmp += a;
    return tmp;
}

umtString umtString::operator +( const char sh )
{
    umtString tmp = data_;
    
    tmp += sh;
    return tmp;
}

umtString::operator char *() const
{
    return (char*) data_;
}

int umtString::operator ==(const umtString &s) const 
{
    if(s.data_ == data_)
	return 1;
    else
	if(data_== nil || s.data_==nil)
	    return 0;
	else
	    return (strcmp(data_, s.data_) == SAME);
}

int umtString::operator ==(const char *s) const 
{
    if(s==nil)
    {
	return data_?1:0;
    }
    else
    {
	if(data_==nil)
	    return 0;
	else
	    return (strcmp(data_, s) == 0);
    }
}

int umtString::operator !=(const umtString &s) const 
{
    if(s.data_ == data_)
	return 0;
    else
	if(data_== nil || s.data_==nil)
	    return 1;
	else
	    return (strcmp(data_, s.data_) != 0);
}

int umtString::operator !=(const char *s) const
{
    if(s==nil)
    {
	return !data_;
    }
    else
    {
	if(data_==nil)
	    return 1;
	else
	    return (strcmp(data_, s) != 0);
    }
}

// All compairson operators make sense if data_ != nil
// TODO: fix this.

int umtString::operator >(const umtString &s) const 
 {
     return strcmp(data_, s.data_) > 0;
 }

 int umtString::operator >(const char* s) const
 {
     return (s ? (strcmp(data_, s) > 0) : 1);
 }

 int umtString::operator >=(const umtString& s) const
 {
     return strcmp(data_, s.data_) >= 0;
 }

 int umtString::operator >=(const char* s) const
 {
     return s ? (strcmp(data_, s) >= 0):1;
 }

 int umtString::operator <(const umtString &s) const 
 {
     return strcmp(data_, s.data_) < 0;
 }

 int umtString::operator <(const char *s) const 
 {
     return s? (strcmp(data_, s) < 0):0;
 }

 int umtString::operator <=(const umtString &s) const
 {
     return strcmp(data_, s.data_) <= 0;
 }

 int umtString::operator <=(const char *s) const 
 {
     return s?(strcmp(data_, s) <= 0):0;
 }

int umtString::CaseInsensitiveEqual(const umtString &s) const 
{
    if(!s.data_) {
	return data_?1:0;
    }
    else {
	if(!data_)
	    return 0;
	else
	    return (strcasecmp(data_, s.data_) == SAME);
    }
}

int umtString::CaseInsensitiveEqual(const char* s) const
{
    if(!s) {
	return data_?1:0;
    }
    else {
	if(!data_)
	    return 0;
	else
	    return (strcasecmp(data_, s) == SAME);
    }
}

int umtString::Length() const
{
    return data_? strlen(data_):0;
}

umtString umtString::Left(int length) const
{
    return SubStr(0, length);
}

umtString umtString::Right(int start) const
{
    return SubStr(start, -1);
}

void umtString::SetToLeft(int length)
{
    SetToSubstr(0, length);
}

void umtString::SetToRight(int start)
{
    SetToSubstr(start, -1);
}

int umtString::Index(unsigned char c) const
{
    return Search(0, c);
}

int umtString::RIndex(unsigned char c) const
{
    return Search(-1, c);
}

char umtString::operator [](int index) const 
{
    if(data_ && index<=(signed)strlen(data_))
	return ((char *)data_)[index];
    else
	return 0;
}

// "" Is empty as (nil) string.
int umtString::IsEmpty() const
{
    return (data_==nil || *data_=='\0') ? 1 : 0;
}

void umtString::ToLower()
{
    char *c;

    
    if(data_) {
	c = data_;
       	while(*c) {*c=tolower(*c);c++;}
    }

}

void umtString::ToUpper()
{
    char *c;
    
    if(data_) {
	c = data_;
	while(*c) {*c=toupper(*c);c++;}
    }
}

const char* umtString::Str() const
{
    return data_;
}

/* strip SPACES, HT, CR and LF at the end of line */
void umtString::StripJunk()
{ // TODO: This function don't strip string if it is only one char !!! Fix it.
    char *s;
    int length_;
    
    if(data_)
    {
	length_=Length();
	if(length_)
	{
	    s=data_+length_-1;
	    while(length_ && (*s==' ' || *s=='\t' || *s=='\n' || *s=='\r'))
	    {
		s--;
		length_--;
	    }
	    *(s+1)='\0';
	}
    }
}

/* strip CR and LF at the end of line */
void umtString::StripCRLF()
{
    int i;
    
    if(data_)
    {
	i=Length()-1;
	while(i>0 && (data_[i]=='\n' || data_[i]=='\r'))
	{
	    data_[i]='\0';
	    i--;
	}
    }
}

/* write null terminated string to file */
int umtString::Write(FILE *f)
{
    char *s;
  
    s=data_;
    if(s==nil)
	return (fputc('\0',f)==EOF)?1:0;
    
    while(*s) 
	if(fputc(*s,f)==EOF) return 1;
	else s++;
  
    return 0;
}    

// read from file null terminated string
// WARNING: Can't read more than MAXSTRING! Rest will not be read.
int umtString::Read(FILE *f)
{
    char tmp[MAXSTRING+2];
    char *s;
    int  c;
    int  i;

    s=tmp;
    i=0;
    while((c=fgetc(f))!=EOF)
    {
	if(c=='\n' || c=='\0') 
	    break;
	else {
	    *s=c;
	    s++;
	    if(i==MAXSTRING) break;
	}
    }
    if(c==EOF) 
	return 1;
    else
    {
	*s='\0';
	if(data_) Delete(data_);
	data_=ustrdup(tmp);
	return 0;
    }
}

// Convert a string to binary value.
// true - OK false - Error with errno set.

int umtString::ConvertTo(int &value) const
{
    char* ptr;
    
    value = (int)strtol(data_, &ptr, 0);
    return ptr != data_;
}

int umtString::ConvertTo(long &value) const
{
    char* ptr;

    value = strtol(data_, &ptr, 0);
    return ptr != data_;
}

int umtString::ConvertTo(float& value) const
{
    char* ptr;

    value = (float)strtod(data_, &ptr);
    return ptr != data_;
}

int umtString::ConvertTo(double& value) const
{
    char* ptr;
    
    value = strtod(data_, &ptr);
    return ptr != data_;
}

umtString umtString::Search(unsigned char c) const 
{
    return strchr(data_,c);
}

umtString umtString::SearchBack(unsigned char c) const 
{
    return strrchr(data_,c);
}

/*
 * A negative value for start initializes the position at the end
 * of the string before indexing.  Any negative length makes
 * the substring extend to the end of the string.
 */

umtString umtString::SubStr(int start, int length) const
{
    int length_;
    int pos,len;

    length_=Length();
    
    if(start >= length_ || start < -length_)
    {
	/* should raise exception */
	// TODO I really do not understand what happens here
	return *this;
    }
    pos = (start >= 0) ? start : (length_ + start);

    if(pos + length > length_)
    	return *this;

    len = (length >= 0) ? length : (length_ - pos);
    return umtString(data_ + pos, len);
}


void umtString::SetToSubstr(int start, int length)
{
    int pos,len,length_;
    char *tmp;

    length_=Length();
    
    if (start > length_ || start < -length_) {
	/* should raise exception */
	return;
    }
    pos = (start >= 0) ? start : (length_ + start);
    if (pos + length > length_) {
	/* should raise exception */
	return;
    }
    len = (length >= 0) ? length : (length_ - pos);
    data_[pos + len] = '\0';
    if(pos)
    {
	tmp = ustrdup(data_ + pos);
	Delete( data_);
	data_ = tmp;
    }
}

/*
 * A negative value for start initializes the position to the end
 * of the string before indexing and searches right-to-left.
 */

int umtString::Search(int start, unsigned char c) const
{
    const char *end;
    const char *p;
    int   length_;
    
    length_=Length();
    
    if (start >= length_ || start < -length_)
    {
	/* should raise exception */
	return -1;
    }
    if (start >= 0)
    {
	end = data_ + length_;
	for(p = data_ + start; p < end; p++)
	{
	    if (*p == c) 
		return p - data_;
	}
    } else {
	for(p = data_ + length_ + start; p >= data_; p--)
	{
	    if (*p == c) 
		return p - data_;
	}
    }
    return -1;
}


void umtString::set_value(const char *s)
{
    if(data_) Delete(data_);
    data_=ustrdup(s);
}

















