
umtGRTFColor *umtGRTFEditorImpl::CursorColor   (void) const
{
  return cursor_color;
}

umtGRTFColor *umtGRTFEditorImpl::BackgroundColor(void) const
{
  return background_color;
}

umtGRTFColor *umtGRTFEditorImpl::BlockColor    (void) const
{
  return block_color;
}


umtGRTFColor *umtGRTFEditorImpl::DefaultColor(void) const
{
  if(default_color)
    return default_color;
  else
    return FindColor("#000000");
}

umtGRTFColor *umtGRTFEditorImpl::FindColor(const char *colorname) const
{
  long i;

  if(!colorname)
    return DefaultColor();

  //  fprintf(stderr,"FindColor :>%s<\n",colorname);
  for( i=0 ; i<rtf_colors.count() ; i++ )
    {
      if(!strcmp(colorname,rtf_colors.item(i)->name()))
	return rtf_colors.item(i);
    }
  
  Color* c=(Color*)Color::lookup(session_->default_display(),colorname);
  if(c!=nil)
    {
      umtGRTFColor *ret;
      Resource::ref(c);
      Resource::unref(c);
      //      fprintf(stderr,"Make New Color Cnv:>%d<\n",(int)last_canvas);
      ret=new umtGRTFColor(colorname);
      //      fprintf(stderr,"Append\n");
      ((umtGRTFEditorImpl*)(this))->rtf_colors.append(ret);
      ((umtGRTFEditorImpl*)(this))->UpdateColorsBeforeDraw=true;   
      //      strcpy(colors_names.item(colors_names.count()-1),colorname);
      //      ((umtGRTFEditorImpl*)(this))->colors.append(c);
      //      fprintf(stderr,"Make New Color is Done\n");
      return ret;
    }
  else
    return DefaultColor();
}

void umtGRTFEditorImpl::LoadColors(umtConfiguration* config)
{
  umtString   str;

  DoneColors();
  //  fprintf(stderr,"!! LoadColors ~~\n");
  if(!config)
    {
      //      fprintf(stderr,"NoColorConfig\n");
      cursor_color=FindColor("#0000ff");
      background_color=FindColor("#505050");
      block_color=FindColor("#101010");
      default_color=FindColor("#000000");
    }
  else
    {
      str=config->GetStrField("CursorColor");
      if(!str.IsEmpty())
	cursor_color=FindColor(str);
      else
	{
	  cursor_color=FindColor("#0000ff");
	  //	  fprintf(stderr,"Nocursorcolor\n");
	}
      
      str=config->GetStrField("BackgroundColor");
      if(!str.IsEmpty())
	background_color=FindColor(str);
      else
	background_color=FindColor("#505050");
      
      str=config->GetStrField("BlockColor");
      if(!str.IsEmpty())
	block_color=FindColor(str);
      else
	block_color=FindColor("#101010");
      
      str=config->GetStrField("DefaultColor");
      if(!str.IsEmpty())
	default_color=FindColor(str);
      else
	default_color=FindColor("#000000");
    }
  current_block->color=DefaultColor();
}


void umtGRTFEditorImpl::DoneColors (void)
{
  long i;

  for( i=0 ; i<rtf_colors.count() ; i++ )
    delete rtf_colors.item(i);

  cursor_color=background_color=block_color=default_color=nil;
  
  rtf_colors.remove_all();
}






