
int umtGRTFEditorImpl::Save(FILE *f)
{
  long i,j,k;
  long char_start;
  long char_end;
  umtGRTFBlock *b;
  char str[1024];

  if(!f)return 1;
  
  for( i=0 ; i<blocks.count() ; i++ )
    {
      char_start=blocks.item(i)->start;
      if(i+1<blocks.count())
	char_end=blocks.item(i+1)->start;
      else
	char_end=text.count();

      if(char_start==char_end)continue;
      
      b=blocks.item(i);
      
      GetRtfCommandStr(RtfBigger,str);
      for( k=0 ; k<b->char_size ; k++ )
	fputs(str,f);
      
      GetRtfCommandStr(RtfSmaller,str);
      for( k=0 ; k>b->char_size ; k-- )
	fputs(str,f);
      
      GetRtfCommandStr(RtfIndent,str);
      for( k=0 ; k<b->indent_left ; k++ )
	fputs(str,f);
      
      GetRtfCommandStr(RtfIndentRight,str);
      for( k=0 ; k<b->indent_right ; k++ )
	fputs(str,f);
      
      if(b->align!=RtfFlushLeft)
	{
	  GetRtfCommandStr(b->align,str);
	  fputs(str,f);
	}


      
      if((b->font_style&RTFFONT_Fixed)==RTFFONT_Fixed)
	{
	  GetRtfCommandStr(RtfFixed,str);
	  fputs(str,f);
	}
      if((b->font_style&RTFFONT_Bold)==RTFFONT_Bold)
	{
	  GetRtfCommandStr(RtfBold,str);
	  fputs(str,f);
	}
      if((b->font_style&RTFFONT_Italic)==RTFFONT_Italic)
	{
	  GetRtfCommandStr(RtfItalic,str);
	  fputs(str,f);
	}
      if((b->font_style&RTFFONT_UnderLine)==RTFFONT_UnderLine)
	{
	  GetRtfCommandStr(RtfUnderLine,str);
	  fputs(str,f);
	}
      
      if(b->color!=DefaultColor())
	{
	  GetRtfCommandStr(RtfX_Color,str);
	  fputs(str,f);
	  GetRtfCommandStr(RtfParam,str);
	  fputs(str,f);
	  fputs(b->color->name(),f);
	  GetRtfCommandStr(RtfParamOFF,str);
	  fputs(str,f);	  
	}


      for( j=char_start ; j<char_end ; j++ )
	{
	  if(text.item(j)=='\n')
	    {
	      while(
		    (j<char_end) &&
		    text.item(j)=='\n'
		    )
		{
		  putc('\n',f);
		  j++;
		}
	      putc('\n',f);
	      if(j<char_end)
		putc(text.item(j),f);
	    }
	  else
	    if(text.item(j)=='<')
	      fputs("<<",f);
	  else
	    putc(text.item(j),f);
	}

      
      if(b->color!=DefaultColor())
	{
	  GetRtfCommandStr(RtfX_ColorOFF,str);
	  fputs(str,f);
	}      
      if((b->font_style&RTFFONT_UnderLine)==RTFFONT_UnderLine)
	{
	  GetRtfCommandStr(RtfUnderLineOFF,str);
	  fputs(str,f);
	}      
      if((b->font_style&RTFFONT_Italic)==RTFFONT_Italic)
	{
	  GetRtfCommandStr(RtfItalicOFF,str);
	  fputs(str,f);
	}
      if((b->font_style&RTFFONT_Bold)==RTFFONT_Bold)
	{
	  GetRtfCommandStr(RtfBoldOFF,str);
	  fputs(str,f);
	}      
      if((b->font_style&RTFFONT_Fixed)==RTFFONT_Fixed)
	{
	  GetRtfCommandStr(RtfFixedOFF,str);
	  fputs(str,f);
	}


      
      if(b->align!=RtfFlushLeft)
	{
	  GetRtfCommandStr(b->align+RtfOffCmd,str);
	  fputs(str,f);
	}
            
      GetRtfCommandStr(RtfIndentRightOFF,str);
      for( k=0 ; k<b->indent_right ; k++ )
	fputs(str,f);
      
      GetRtfCommandStr(RtfIndentOFF,str);
      for( k=0 ; k<b->indent_left ; k++ )
	fputs(str,f);
      
      GetRtfCommandStr(RtfSmallerOFF,str);
      for( k=0 ; k>b->char_size ; k-- )
	fputs(str,f);
      
      GetRtfCommandStr(RtfBiggerOFF,str);
      for( k=0 ; k<b->char_size ; k++ )
	fputs(str,f);	      
    }
  return 0;
}

int umtGRTFEditorImpl::SaveText(FILE *f)
{
  long i,j;
  long char_start;
  long char_end;

  if(!f)return 1;
  
  for( i=0 ; i<lines.count() ; i++ )
    {
      char_start=lines.item(i)->start;
      if(i+1<lines.count())
	char_end=lines.item(i+1)->start;
      else
	char_end=text.count();

      for( j=char_start ; j<char_end ; j++ )
	putc(text.item(j),f);

      if(
	 (char_start<char_end) &&
	 (text.item(j-1)!='\n')
	 )putc('\n',f);
    }
  return 0;
}

