#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include "slist.h"

enum font_name  { times,helvetica };
enum font_size  { small=12,normalsize=15,big=20 };
enum font_type  { normal,bold,italic };

class rtf_font {
public:
  rtf_font(void);
protected:
  char cfont[15];
  char ctype[15];
  font_name name;
  font_size size;
  font_type type;
  stack<font_size> sstack;
  stack<font_type> tstack;
  void setfont(font_name);
  void setsize(font_size);
  void settype(font_type);
  void writefont(void);
  virtual void put_string(char *) {}
};


enum justify_type { leftjust,rightjust,nojust,center };
enum direction_type  { indent,outdent,noindent };

class rtf_justify {
public:
  rtf_justify(void);
protected:
  int XINITPOS,indcount;
  stack <justify_type> jstack;
  stack <direction_type> dstack;
  void setjustify(justify_type);
  void setdirection(direction_type);
  justify_type justify;
  direction_type direction;
  void chxinit(void);
};







class RTF2PS:public member,public rtf_font,public rtf_justify {
public:
  RTF2PS(FILE *inf, FILE *);
  void Translate(void);

private:
  FILE *infile,*outfile;
  char buf[260];
  int pos,ypos,xpos,charinbuf;
  int fontchanged,justifychanged;
  int needmove ,needfont;
  int test_token(char *);
  int getnext(void);
  void put_char(char);
  void put_string(char *);
  void new_line(void);
  void paragraph(void);
  void endparagraph(void);
  void excerpt(void);
  void heading(void);
  void signature(int);
  void endheading(void);
  void endfooting(void);
  void setunderline(void);
  void writeheader(void);
  void show(void);
  void de(void);
  void db(void);
  void move(int,int);
  void clear(void);
  void endsamepage(void);
  void changejustify(justify_type);
  void changedirection(direction_type);
  void changefontname(font_name);
  void changefontsize(font_size);
  void changefonttype(font_type);
  void restorefonttype(void);
  void restorefontsize(void);
  void restorejustify(void);
  void restoredirection(void);
};


