#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
#define  SIZE 43

#ifdef RAND_MAX
#undef RAND_MAX
#endif
#define RAND_MAX 50

const unsigned char  Q = 172, 
                     P = 253;


unsigned char encript( unsigned char byte );
int decript( int byte );

int main( int argc,char* argv[] )
{
    FILE*         id;
    int           i;
    unsigned long l_time;
    unsigned char buff[SIZE];
    struct   tm   t;
    unsigned int  byte;
    
    if ( argc < 4 )
    {
	printf( "Usage: %s <licensee_number> <system number>"
		" <dd-mm-yy> [output file name]\n",
		argv[0]);
	exit(0);
    }
    if ( argc > 4 )
    {
	if (( id = fopen( argv[4], "w+" )) == NULL )
	{
	    fprintf( stderr, "Can't open file %s for output\n", argv[4] );
	    return 1;
	}
    }
    else id = stdout;

    memset( &t, 0, sizeof( t ));

    sscanf( argv[3],
	    "%d-%d-%d",
	    &(t.tm_mday),      /* days  */
	    &(t.tm_mon),       /* month */
	    &(t.tm_year)       /* year  */
	    );
    if ( t.tm_year > 1900 ) t.tm_year-=1900;
    t.tm_mon--;
    fprintf( stderr, "%lu <- %s\n",
	    l_time = ( unsigned long )mktime( &t ),
	    asctime( &t )
	     
    );
    sprintf( ( char *)buff, "%s %s %lu  ", argv[1], argv[2], l_time );
    fprintf( stderr, "%s\n", buff ); 
    srand((unsigned int)time( NULL ));
    for ( i = strlen( (char*)buff ); i < (SIZE - 1); i++ )
	while (! ( buff[i] = rand()));
    buff[i] = '\0';
    fprintf( id, "%02x", byte = encript( 1 )); /* init */
    for ( i = 0; buff[i]; i++ )
    {
	fprintf( id, "%02x", byte = encript( buff[i] ));
//	fprintf( stderr, "%02x(%c)", byte, buff[i] );
	if ( i && !( (i-2)  % 4 ))
	    fputc( ' ', id );
    }
    fprintf( id, "%02x", byte = encript(0));
    fputc( '\n', stdout );
    if ( id != stdout )
    {
	rewind( id );
	while ( fscanf( id,"%2x", &byte ) != EOF )
	{
	    i = ( unsigned char )decript((unsigned char)byte );
//	    fprintf( stderr, "%2x(%c)", i, i );
	}
	if (!decript( -1 ))
	{
	    fputs( "Ok\n", stderr );
	    return 0;
	}
	else
	{
	    fputs( "Error\n", stderr );
	    return 1;
	}
    }	
}


unsigned char encript( unsigned char byte )
{
    static unsigned char prev_byte = 0,
                         key,
                         first_byte = 0;
    int                  i;

    if( byte )
    {
	if ( !first_byte )
	{
	    srand((unsigned int)time( NULL ));
	    while ( ! (first_byte = key = (unsigned char)rand()));
//	    fprintf( stderr,"<%x> ", first_byte );
 	    return first_byte; 
	}
	for ( i = 0; i <= prev_byte; i++ )
	    key = key * Q - (( key * Q ) / P ) * P;
//	fprintf( stderr, "%d+%d=%d p=%d q=%d, prev_k=%d\n",
//	byte, key,(unsigned char)(byte+key),P,Q,prev_byte ); 
 	return ( prev_byte = byte + key );
    }
    else
    {
	
	byte = encript( first_byte );
	first_byte = 0;
	return byte;
    }
}


int decript( int byte )
{
    static unsigned char prev_byte = 0,
                         key,
	                 first_byte = 0;
    int                  i;

    if ( byte != -1 )
    {
	if ( !first_byte )
	{
	    first_byte = key = ( unsigned char )byte;
//	    fprintf( stderr,"<%x> ", key );
	    return 0;
	}
	for ( i = 0; i <= prev_byte; i++ )
	    key = key * Q - (( key * Q ) / P ) * P;
//	fprintf( stderr, "'%x-%x' ", byte, key );
	prev_byte = ( unsigned char )byte;
	return (unsigned char)((unsigned char)byte - key);
    }
    else
    {
	i = (( unsigned char)( prev_byte -key ) == first_byte )? 0: -1;
//	fprintf( stderr,"[%x,%x]",
//		 first_byte,
//		 (unsigned char)(prev_byte - key));
	first_byte = 0;
	return i;
    }
}









