/*  
$Header: /export/CVS/UMT/src.misc/pop_get/pop_get.c++,v 1.1.1.1 1996/10/21 20:46:51 vlad Exp $

$Log: pop_get.c++,v $
Revision 1.1.1.1  1996/10/21 20:46:51  vlad
Puting to CVS. Version 1.00B3

Revision 1.2  1995/03/04  16:29:26  lord
Make removal of messages

Revision 1.1  95/03/04  10:36:12  10:36:12  lord (Vadim Zaliva)
Initial revision

*/

#include <unistd.h>
#include "pop3.h"
#include "folder.h"

int main(int ac, char **av)
{
  pop3      *remote;
  int       i;
  char      *msg;
  char      *s;
  FILE      *f;
  time_t    curt;
  char      userhost[80];
  
  if(ac!=5)
    {
      fprintf(stderr,"Usage: pop_get server user password local_file\n");
      return(1);
    }
  
  if((f=fopen(av[4],"a"))==NULL) 
     {
       fprintf(stderr,"Can't open file %s for writing\n",av[4]);
       return(1);
     }

  remote=new pop3(av[1],"vkpop3",av[2],av[3]);
  if(remote->rc!=OK) 
    {
      fprintf(stderr,"Can't open pop server on %s\n",av[1]);
      return 1;
    } else
      {
	printf("Server open!\n");
      }

  printf("Number of messages: %d\n",remote->getNumberOfMessages());
  printf("Size of mbox      : %d\n",remote->getSizeOfMailbox());

  if(gethostname(userhost,80)!=0) userhost[0]='\0';

  for(i=0;i<remote->getNumberOfMessages();i++) {
    printf("MSG %02d:",i);
    if(remote->isMessageDeleted(i))
      printf("deleted\n");
    else {
      msg=remote->getMessage(i);
      if(msg==NULL) {
	printf("Can't get!\n");
	continue;
      }
      curt=time(NULL);
      fprintf(f,"From %s@%s %s",getlogin(),userhost,ctime(&curt));
      s=msg;
      while(*s) {fputc(*s,f);s++;}
      fputc('\n',f);
      printf("%d bytes - Done\n",strlen(msg));
      Delete(msg);
      remote->deleteMessage(i);
    }
  }
  fclose(f);
  delete remote;

  return 0;
}



