/*
  $Header: /export/CVS/UMT/src/umtServer.cc,v 1.1 1996/10/22 19:48:06 lord Exp $

  $Log: umtServer.cc,v $
  Revision 1.1  1996/10/22 19:48:06  lord
  Due to stupidity of SUN CC, all .c++ files renamed to .cc.
  Some platform directories created in lib.
  Makefile.include for SUN created.

  Revision 1.1.1.1  1996/10/21 20:46:49  vlad
  Puting to CVS. Version 1.00B3

  Revision 2.0  1996/03/18 16:47:27  sebast
  Revision 2.0

// Revision 1.30  1996/03/18  15:18:03  vlad
// *** empty log message ***
//
  Revision 1.29  1996/01/31 18:48:07  vlad
  Server will not live without parent process.

// Revision 1.28  1995/10/09  09:57:22  lord
// Remove all printfs. Use UMT Error.
//
// Revision 1.27  1995/09/30  12:48:37  sebast
// creating Msg from umtDir instead umtPath
//
// Revision 1.26  1995/09/20  12:49:15  vlad
// Call of umtDeliver constructor replaced to method Run();
//
// Revision 1.25  1995/09/15  14:14:00  sebast
// use SMTP added
//
// Revision 1.24  1995/09/06  14:56:26  lord
// temporary for call umtString(&)
//
// Revision 1.23  1995/09/05  11:17:32  lord
// So not print warning in lock waiting loop
//
// Revision 1.22  1995/09/04  17:57:39  lord
// Bug at exiting fixed
//
// Revision 1.21  1995/09/04  13:24:06  lord
// added int for  umtServer::unlock_delay and umtServer::check_queue_delay
//
// Revision 1.20  1995/09/02  16:32:41  lord
// Background queue processing with sendmail deliver adent.
//
// Revision 1.19  1995/08/24  16:20:20  lord
// remove some printfs
//
// Revision 1.18  1995/08/24  13:42:58  lord
// String -> Str
//
// Revision 1.17  1995/08/22  13:19:08  lord
// umlock_delay calls corrected
//
// Revision 1.16  1995/08/22  13:18:08  lord
// unlock_delay renamed
//
// Revision 1.15  1995/08/22  13:15:57  lord
// check_queue_delay renamed.
//
// Revision 1.14  1995/08/09  14:50:42  sebast
// umtCodingRules
//
// Revision 1.13  1995/08/08  16:04:15  sebast
// umtCodingRules started
//
// Revision 1.12  1995/07/30  15:09:06  sebast
// some non-supprted by SGI comp[iler lines changed; problems with umt_path' operator'=' NOT solved
//
// Revision 1.11  1995/07/29  13:27:01  sebast
// some members made static
//
// Revision 1.10  1995/07/26  16:33:47  lord
// BUG not fixed. Just lock.
//
// Revision 1.9  1995/07/18  15:23:36  lord
// skip LCK files while scanning.
// use .LCK locking mechanism for jobs.
//
// Revision 1.8  1995/07/18  13:19:30  lord
// Removing dir and lock in destructor
//
// Revision 1.7  1995/07/15  16:52:18  lord
// This shit needs more debugging. It's too late now and damned guard asks to
// go out from this damned office.
//
// Revision 1.6  1995/07/15  14:58:07  lord
// Exit on receiving message from pipe.
//
// Revision 1.5  1995/07/15  14:14:25  lord
// oops
//
// Revision 1.4  1995/07/15  14:13:35  lord
// error in lock waiting code causing infinitive loop fixed
//
// Revision 1.3  1995/07/15  14:05:14  lord
// queue dir creation.
// Waiting for Lock.
//
// Revision 1.2  1995/07/13  16:56:20  lord
// make it not to return
//
// Revision 1.1  1995/07/08  16:17:52  lord
// Initial revision
//
*/


#include <sys/stat.h>
#include <unistd.h>
#include <InterViews/session.h>
#include <InterViews/layout.h>
#include <InterViews/window.h>
#include <InterViews/style.h>
#include <InterViews/display.h>
#include <IV-look/kit.h>

#include "misc.h++"
#include "UMT.h++"
#include "umtDir.h++"
#include "umtFolder.h++"
#include "umtServer.h++"
#include "umtSMTPDeliverAgent.h++"
#include "umtUniversalDialog.h++"

const   int  umtServer::unlock_delay      = 5;
const   int  umtServer::check_queue_delay = 5; 

umtServer::umtServer(/* int z, */ int argc, char** argv )
    :umtMember(CLASS_UMT_SERVER)
{
    umtPath   lock_path;
    umtString tmp;
    
    this_is_my_UMT = getppid();
    da = NULL;
//     wpipe=z;
    tmp=UMTConfig.GetStrField("QueueDir");
    dir=new umtDir(tmp);
    if(access(dir->Str(),F_OK)!=0) // Not exists
	mkdir(dir->Str(),S_IRUSR |S_IWUSR| S_IXUSR);
    
    lock_path = dir->Str();
    lock_path+="/";
    lock_path+="LOCK";
    lock      = new umtLock( lock_path );
//     for ( int i = 0; i < argc; i++ )
// 	fprintf( stderr, "'%s' ", argv[i] );
//    fputc( '\n', stderr );
    session   = new Session( "UMT", argc, argv );
}

umtServer::~umtServer()
{
    if(lock)
    {
	lock->UnLock();
	Delete(lock);
    }
    if(dir) Delete(dir);
    if (da) Delete (da);
}

int umtServer::Run()
{
    umtPath fname;
    umtString tmp;

    while( /* read(wpipe,&rc,1)!=-1 */1 )
    {
	if ( getppid()!= this_is_my_UMT )
	{
	    if (lock) Delete(lock);
	    if(dir) Delete(dir);
	    if (da) Delete (da);
	    UMTError->Msg(
		umtError::Debug,
		    "umtServer: parent process is finished. Exit."
	    );
	    return 0;
	}
	if((lock->Lock())!=OK)
	{
	    UMTError->Msg(
		umtError::Warning,
		"Queue dir locked by another server. Waiting..."
	    );
	    sleep(unlock_delay);
	} else break;
    } 

    if(lock->IsLocked())
    {
	
	UMTError->Msg( umtError::Debug, "Queue dir locked OK." );
    
	if(dir->Open()!=OK)
	    UMTError->Msg( umtError::Error, "Can't open queue dir.");
    	while (1)
	{
	    // First of all let us run queue
	    if(dir->IsOpened()) 
	    {
		while (1)
		{
		    fname=dir->NextEntry();
		    if(fname=="") break; // No more jobs.
		    if(
			fname.GetExt () != "LCK"  && 
			fname.GetName() != "LOCK" &&
			(fname.GetName().Str())[0]!='.'
		    ) //Skip LOCK and hidden files
		    {
			if ( !da )
			{
			    tmp = UMTConfig.GetStrField("DeliverAgent");
			    if (tmp.CaseInsensitiveEqual("Sendmail"))
				da = new umtSendmailDeliverAgent();
			    else  if (tmp.CaseInsensitiveEqual("SMTP"))
				da = new umtSMTPDeliverAgent(
				    UMTConfig.GetStrField("SMTP.Host"),
				    UMTConfig.GetStrField("SMTP.Port")
				);
			    else
			    {
				UMTError->Msg(
				    umtError::Error,
				    "No deliver agent in config file"
				);
			    }
			}
			if ( da ) do_job(fname);
			else 
			    UMTError->Msg(
				umtError::Error,
				    "Not enough memory to create deliver agent!!");
		    }
		}
		if ( da )
		{
		    Delete( da );
		    da = NULL;
		}
	    }
// 	    if(read(wpipe,&rc,1)!=-1 )   // Exit message received?
// 		break;
	    if ( getppid()!= this_is_my_UMT )// or is parent UMT alive?
	    {
		if (lock) Delete(lock);
		if(dir) Delete(dir);
		if (da) Delete (da);
		UMTError->Msg( umtError::Debug,
			       "umtServer: parent process is finished. Exit." );
	        break;
	    }
	    sleep(check_queue_delay); 
	    
	    if(dir->IsOpened())
		dir->Rewind();
	}
	dir->Close();
	lock->UnLock();
    }
    return 0;
}


status umtServer::do_job(umtPath p)
{
    umtPath    l;
    status     rc;
    umtLock   *lock;
    umtMsg    *msg;
    umtString  tmp;
    
    UMTError->Msg(umtError::Info,"Processing %s: ",p.Str());
    l=p;
    l+=".LCK";

    lock=new umtLock(l);
    if(!lock)
	return ERROR_IN_CALLED_FUNCTION;

    if((lock->Lock())!=OK)
    {
	Delete(lock);
	UMTError->Msg(umtError::Warning,"Message is locked. Skipping.");
	return ALREADY_LOCKED;
    }
    
    // OK. Message in queue locked. Let's send it.
    msg=new umtMsg((umtDir *)&p);
    if(msg)
    {
	rc=da->Deliver( msg );
	if( rc != OK )
	{
	    tmp = umtString( "Deliver Error:" ) + da->GetErrorMessage();
	    UMTError->Msg( umtError::Error, tmp );
	    switch( ask_user( tmp ))
	    {
	    case 0 :
		UMTError->Msg( umtError::Debug,
			       "Retry to send message" );
		break;
	    case 1 :
		UMTError->Msg( umtError::Debug,
			       "Message removed from query" );
		rc = OK;
		break;
	    case 2 :
	    {
		umtDir  out_folder_path;
		out_folder_path.SetName( umtString(gethomedir()) +
					 umtString( "/" ) +
					 umtString(UMTFolderDir ) +
 					 umtString( "/" ) +
					 umtString( UMTOutgoingFolderName ) +
	 				 umtString( "." ) +
					 umtString( UMTFolderExt ));
		umtFolder  out_folder( &out_folder_path );
		msg->SetFace();
		rc = out_folder.AddMsg( msg );
		if ( rc == OK )
		    rc = out_folder.Save(); 
		if ( rc == OK )
		{
		    UMTError->Msg( umtError::Debug,
				   "Message moved to Outgoing folder" );
		    kill( this_is_my_UMT, SIGUSR1 ); // Send signal to UMT to 
				// update Outgoing filder 
		}
		else 
		    UMTError->Msg( umtError::Error,
				   "Error Message motion to Outgoing folder" );
		break;
	    }
	    }
	}
	else
	    UMTError->Msg( umtError::Info, "Message Deliver OK." );	
	if ( rc == OK )
	{
	    // REMOVE MSG
	    ::RemoveDirectory(p.Str(),0);
	}
    }
    Delete(msg);
    if(lock->UnLock()!=OK)
	UMTError->Msg(
	    umtError::Error,
	    "umtServer Warning: Can't unlock message in queue"
	);
    
    Delete(lock);
    return rc;
}


int umtServer::ask_user( const umtString& error_str )
{
    umtUniversalDialog *dialog;
    umtSlist            buttons;
    umtSlist           *message;
    int                 i;

    buttons.Append( new umtString(UMTSTR(1200))); /* Retry */
    buttons.Append( new umtString(UMTSTR(1201))); /* Remove */
    buttons.Append( new umtString(UMTSTR(1202))); /* Move to Outgoing folder */
    message = CutString( error_str, 40 );
    dialog = new umtUniversalDialog( WidgetKit::instance(),
				     LayoutKit::instance(),
				     session->style(),
				     umtString( "Background Deliver Agent" ),
				     message,
				     &buttons
    );
    if ( dialog )
    {
	dialog->ref();
	if ( dialog->post_at( session->default_display()->width()/2,
			      session->default_display()->height()/2 ))
	    i = dialog->GetActionNumber();
	else i = 0;
	dialog->unref();
    }
    message->Kill(NULL);
    buttons.Kill(NULL);
    Delete(message);
    return i;
}  

